(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program gestion_memo;
  uses dos, crt,
       uclavier, uerreur, uhex,
       utypcons,
       uecran, uaffiche, usaisis, uchamps,
       udonnees, usaisfic,
       uediteur, umemo;
  var g_choix: char;
      g_pt_fichier_donnees: t_pt_fichier_donnees;
      g_nom_fichier: t_string_80;
      g_pt_fichier_memo: t_pt_fichier_memo;
      g_nom_memo: t_string_80;

  procedure cree;
    begin
      cree_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
      ajoute_definition_de_zone(g_pt_fichier_donnees, 'PRENOM',    'C', 3, 0);
      ajoute_definition_de_zone(g_pt_fichier_donnees, 'MEMO1', 'M', 10, 0);
      ajoute_definition_de_zone(g_pt_fichier_donnees, 'MEMO2', 'M', 10, 0);
      ferme_fichier_donnees(g_pt_fichier_donnees);
      cree_fichier_memo(g_pt_fichier_memo, g_nom_memo);
    end; 

    procedure affiche_descripteur_DBF_avec_memo;
      begin
        ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
        affiche_en_tete_fichier_donnees(g_pt_fichier_donnees);
        ferme_fichier_donnees(g_pt_fichier_donnees);
      end; 

  procedure liste_DBF;
    var l_numero_fiche: integer;
        l_numero_zone: integer;
    begin
      ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
      l_numero_fiche:= 0;
      while not f_fin_fichier_donnees(g_pt_fichier_donnees) do
      begin
        lis_fiche_courante(g_pt_fichier_donnees);
        write(l_numero_fiche: 6, ' ');
        for l_numero_zone:= 0 to f_nombre_zones(g_pt_fichier_donnees)- 1 do
        begin
          affiche_zone(g_pt_fichier_donnees, l_numero_zone);
          write('=');
        end;
        writeln('<');
        l_numero_fiche:= l_numero_fiche+ 1;
      end; 
      ferme_fichier_donnees(g_pt_fichier_donnees);
    end; 

    procedure saisis_DBF;
      var l_masque: t_groupe_champs;
          l_pt_fichier_memo: t_pt_fichier_memo;
      begin 
        ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
        initialise_le_masque_standard(g_pt_fichier_donnees, l_masque);
        l_pt_fichier_memo:= nil;
        saisis_fiche_a_fiche(g_pt_fichier_donnees, f_nombre_fiches(g_pt_fichier_donnees),
                             l_masque, l_pt_fichier_memo);
        libere_groupe_de_champs(l_masque);
        ferme_fichier_donnees(g_pt_fichier_donnees);
      end; 

  procedure saisis_DBF_avec_memo;
    var l_masque: t_groupe_champs;
        l_pt_fichier_memo: t_pt_fichier_memo;
    begin 
      ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
      initialise_le_masque_standard(g_pt_fichier_donnees, l_masque);
      ouvre_fichier_memo(l_pt_fichier_memo, g_nom_memo);
      saisis_fiche_a_fiche(g_pt_fichier_donnees, f_nombre_fiches(g_pt_fichier_donnees),
                           l_masque, l_pt_fichier_memo);
      libere_groupe_de_champs(l_masque);
      ferme_fichier_memo(l_pt_fichier_memo);
      ferme_fichier_donnees(g_pt_fichier_donnees);
    end; 

  procedure liste_avec_memos;
    var l_choix: char;
        l_numero_fiche: longint;
        l_pt_fichier_memo: t_pt_fichier_memo;

    procedure affiche_les_zones;
      var l_numero_zone: integer;
          l_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
          l_ligne, l_colonne: integer;
          l_gabarit: t_gabarit_max;
      begin
        clrscr;
        l_ligne:= 1; l_colonne:= 1;
        for l_numero_zone:= 0 to f_nombre_zones(g_pt_fichier_donnees)- 1 do
        begin
          l_gabarit:= '';
          l_pt_descripteur_de_zone:=
              f_pt_descripteur_zone(g_pt_fichier_donnees, l_numero_zone);
          with l_pt_descripteur_de_zone^ do
            case type_zone of
              'C' : affiche_chaine_db(pt_valeur_zone^, taille_zone);
              'N' : affiche_chaine_db_numerique(pt_valeur_zone^, taille_zone, decimales_zone,
                        l_gabarit);
              'L' : write(pt_valeur_zone^[0]);
              'D' : affiche_chaine_db_date(pt_valeur_zone^);
              'M' : affiche_zone_memo(l_pt_fichier_memo, pt_valeur_zone^);
            end; 
          writeln;
          if l_ligne< 25
            then l_ligne:= l_ligne+ 1;
        end; 
      end; 

    begin 
      ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
      ouvre_fichier_memo(l_pt_fichier_memo, g_nom_memo);
      l_numero_fiche:= 0;
      while not f_fin_fichier_donnees(g_pt_fichier_donnees) do
      begin
        lis_fiche_courante(g_pt_fichier_donnees);
        write(l_numero_fiche: 6, ' ');
        affiche_les_zones;
        writeln('<'); stoppe;
        l_numero_fiche:= l_numero_fiche+ 1;
      end; 
      ferme_fichier_memo(l_pt_fichier_memo);
      ferme_fichier_donnees(g_pt_fichier_donnees);
    end; 

  procedure initialise;
    begin 
      g_nom_fichier:= 'A:EXMEMO3.DBF';
      g_nom_memo:= 'A:EXMEMO3.DBT';
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_fichier, ' + ', g_nom_memo, ' ', memavail);
      writeln('Nom, Cre, Affiche descripteur, saisie simple, Liste, ');
      write('analYse mmo, saisie Mmo, Liste, lIste avec mmos, ');
      write('Quitte ? ');
      lis_touche(g_choix); writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'c' : cree;
        'a' : affiche_descripteur_DBF_avec_memo;
        's' : saisis_DBF;
        'm' : saisis_DBF_avec_memo;
        'l' : liste_DBF;
        'y' : analyse_memo(g_nom_memo);
        'i' : liste_avec_memos;
        'n' : begin
                write('nom du fichier <A:CLIENTS.DBF> ? ');
                readln(g_nom_fichier);
              end;
      end; 
    until g_choix= 'q';
  end. 
