(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
  const k_page_saisie_max= 5;
        k_groupe_champs_max= 35;
        k_taille_titre_max= 80;
        k_nombre_titres_max= 40;
        k_indice_tampon_titres_max= 400;
        k_video_normale= false;
        k_video_inverse= true;
  type t_champ= record
                  ligne_champ, colonne_champ,
                    taille_champ, decimales_champ: integer;
                  pt_descripteur_de_zone: t_pt_descripteur_de_zone;
                  gabarit_champ: t_gabarit_max;
                end;
       t_titre= string[k_taille_titre_max];
       t_pt_titre= ^t_titre;
       t_titre_elementaire= record
                              ligne_titre, colonne_titre: integer;
                              pt_titre: t_pt_titre;
                              fin_titre: boolean;
                            end;
       t_champ_debut_fin= record
                            champ_debut_page, champ_fin_page: integer;
                          end;
       t_groupe_champs= record
                          page_fin: integer;
                          table_champs_de_la_page: array[0..k_page_saisie_max]
                              of t_champ_debut_fin;
                          groupe_champs_fin: integer;
                          table_champs: array[0..k_groupe_champs_max] of t_champ;
                          table_titres: array[0..k_nombre_titres_max] of t_titre_elementaire;
                          tampon_titres: array[0..k_indice_tampon_titres_max] of char;
                          teste_saisie_champs: boolean;
                        end;
  var g_groupe_champs: t_groupe_champs;

  procedure affiche_champ(p_numero_champ: integer; p_video_inverse: boolean);
    begin
      with g_groupe_champs.table_champs[p_numero_champ] do
      begin
        gotoxy(colonne_champ, ligne_champ);
        with pt_descripteur_de_zone^ do
           case type_zone of
             'C' : affiche_chaine_db(pt_valeur_zone^, taille_champ);
             'N' : affiche_chaine_db_numerique(pt_valeur_zone^, taille_champ, decimales_champ,
                      gabarit_champ);
             'L' : write(pt_valeur_zone^[0]);
             'D' : affiche_chaine_db_date(pt_valeur_zone^);
           end; 
        if p_video_inverse
          then inverse_champ(ligne_champ, colonne_champ, taille_champ);
      end; 
    end; 

  procedure affiche_titre(p_numero_champ: integer);
    begin
      with g_groupe_champs.table_titres[p_numero_champ] do
      begin
        gotoxy(colonne_titre, ligne_titre);
        write(pt_titre^);
      end; 
    end; 

  procedure affiche_champs_de_la_page(p_numero_page: integer);
    var l_numero_champ: integer;
    begin
      clrscr;
      with g_groupe_champs.table_champs_de_la_page[p_numero_page] do
        for l_numero_champ:= champ_debut_page to champ_fin_page do
        begin
          affiche_champ(l_numero_champ, k_video_inverse);
          affiche_titre(l_numero_champ);
        end;
    end; 

  procedure saisis_groupe_de_champs(var pv_numero_page, pv_numero_champ,
      p_position_dans_champ: integer; p_derniere_fiche: boolean);

    procedure teste_page_suivante;
      begin
        with g_groupe_champs.table_champs_de_la_page[pv_numero_page] do
          if pv_numero_champ> champ_fin_page
            then begin
                pv_numero_page:= pv_numero_page+ 1;
                affiche_champs_de_la_page(pv_numero_page);
              end;
      end; 

    procedure teste_page_precedente;
      begin
        with g_groupe_champs.table_champs_de_la_page[pv_numero_page] do
          if pv_numero_champ< champ_debut_page
            then begin
                pv_numero_page:= pv_numero_page- 1;
                affiche_champs_de_la_page(pv_numero_page);
              end;
      end; 

    procedure traite_sortie_de_groupe;
      begin
        with g_parametres_saisie, g_groupe_champs do
        begin
          case caractere_sortie_de_champ of
            k_curseur_sud,
              k_page_suivante : begin
                                  pv_numero_page:= 0;
                                  pv_numero_champ:= 0;
                                end;
            k_curseur_est,
              k_return : begin
                           pv_numero_page:= 0;
                           pv_numero_champ:= 0;
                           position_dans_champ:= 0;
                         end;
            k_curseur_nord,
              k_page_precedente : begin
                                    pv_numero_page:= page_fin- 1;
                                    pv_numero_champ:=
                                      table_champs_de_la_page[pv_numero_page].champ_fin_page;
                                  end;
            k_curseur_ouest : begin
                                pv_numero_page:= page_fin- 1;
                                pv_numero_champ:=
                                  table_champs_de_la_page[pv_numero_page].champ_fin_page;
                                position_dans_champ:=
                                  table_champs[pv_numero_champ].taille_champ- 1;
                              end;
            k_controle_end : ;
            else affiche_erreur('SYST: mauvais caractere sortie groupe');
          end; 
        end; 
      end; 

    begin 
      with g_parametres_saisie, g_groupe_champs do
      begin
        a_modifie_un_champ_du_groupe:= false;
        caractere_sortie_de_champ:= ' ';
        while not (caractere_sortie_de_champ in caracteres_sortie_fiche_a_fiche)
            and (pv_numero_champ>= 0) and (pv_numero_champ< groupe_champs_fin) do
          with g_groupe_champs.table_champs[pv_numero_champ] do
          begin
            if teste_saisie_champs
              then begin
                  gotoxy(70, 2);
                  write('T', pt_descripteur_de_zone^.type_zone, pv_numero_champ, 'T');
                end;
            with pt_descripteur_de_zone^ do
               case type_zone of
                 'C' : saisis_chaine_db(ligne_champ, colonne_champ, p_position_dans_champ,
                         taille_champ, pt_valeur_zone^, gabarit_champ, 'C');
                 'N' : saisis_chaine_db_numerique(ligne_champ, colonne_champ, p_position_dans_champ,
                         taille_champ, decimales_champ,
                         taille_zone, decimales_zone,
                         pt_valeur_zone^, gabarit_champ);
                 'L' : saisis_booleen(ligne_champ, colonne_champ, p_position_dans_champ,
                           pt_valeur_zone^[0]);
                 'D' : saisis_chaine_db_date(ligne_champ, colonne_champ, p_position_dans_champ,
                           taille_champ, pt_valeur_zone^, gabarit_champ);
               end; 
            case caractere_sortie_de_champ of
              k_curseur_est,
                k_return :
                  if p_derniere_fiche and (caractere_sortie_de_champ= k_return)
                      and (pv_numero_champ= 0) and (position_dans_champ= 0)
                    then 
                         pv_numero_champ:= -1
                    else begin
                        caractere_sortie_de_champ:= k_curseur_est;
                        pv_numero_champ:= pv_numero_champ+ 1;
                        teste_page_suivante;
                        p_position_dans_champ:= 0;
                      end;
              k_curseur_sud :
                begin
                  pv_numero_champ:= pv_numero_champ+ 1;
                  teste_page_suivante;
                  if pv_numero_champ< g_groupe_champs.groupe_champs_fin
                    then
                      with g_groupe_champs.table_champs[pv_numero_champ] do
                        if position_dans_champ>= taille_champ
                          then p_position_dans_champ:= taille_champ- 1;
                end;
              k_efface_avant_curseur,
                k_curseur_ouest, k_mot_precedent :
                  begin
                    pv_numero_champ:= pv_numero_champ- 1;
                    if pv_numero_champ>= 0
                      then begin
                          teste_page_precedente;
                          p_position_dans_champ:=
                             g_groupe_champs.table_champs[pv_numero_champ].taille_champ- 1;
                        end
                      else sonne;
                  end;
              k_curseur_nord:
                begin
                  pv_numero_champ:= pv_numero_champ- 1;
                  if pv_numero_champ>= 0
                    then begin
                        teste_page_precedente;
                        with g_groupe_champs.table_champs[pv_numero_champ] do
                          if position_dans_champ>= taille_champ
                            then p_position_dans_champ:= taille_champ- 1;
                      end;
                end; 
              k_page_suivante :
                with g_groupe_champs do
                  if pv_numero_page< page_fin- 1
                    then begin
                        pv_numero_page:= pv_numero_page+ 1;
                        pv_numero_champ:=
                          table_champs_de_la_page[pv_numero_page].champ_debut_page;
                        affiche_champs_de_la_page(pv_numero_page);
                      end
                    else sonne;
              k_page_precedente :
                if pv_numero_page> 0
                  then begin
                      pv_numero_page:= pv_numero_page- 1;
                      pv_numero_champ:=
                        g_groupe_champs.table_champs_de_la_page[pv_numero_page]
                            .champ_fin_page;
                      affiche_champs_de_la_page(pv_numero_page);
                    end
                  else sonne;
              k_controle_end, k_escape,
                k_page_ouest, k_page_est : ;
              else
                affiche_erreur('SYST: mauvaise touche de sortie');
                affiche_touche(caractere_sortie_de_champ);
            end; 
            a_modifie_un_champ_du_groupe:=
              a_modifie_un_champ_du_groupe or a_modifie_le_champ;
        end; 
        traite_sortie_de_groupe;
      end; 
    end; 

  procedure affiche_parametres_un_champ(p_champ: t_champ);
    begin
      with p_champ do
        write(pt_descripteur_de_zone^.nom_zone, pt_descripteur_de_zone^.type_zone: 3,
              ligne_champ: 7, colonne_champ: 6, taille_champ: 8, decimales_champ: 8,
              ' ', gabarit_champ);
    end; 

  procedure affiche_parametres_des_champs;
    var l_champ, l_page: integer;
    begin
      writeln(' nom-zone  type ligne colonne taille decimales gabarit');
      with g_groupe_champs do
      begin
        for l_champ:= 0 to groupe_champs_fin- 1 do
        begin
          affiche_parametres_un_champ(table_champs[l_champ]);
          writeln('<', table_titres[l_champ].pt_titre^, '=');
        end;
        for l_page:= 0 to page_fin- 1 do
          with table_champs_de_la_page[l_page] do
          writeln(l_page: 2, ' [', champ_debut_page: 2,
                   '-', champ_fin_page, ']');
      end;
    end; 

  procedure initialise_groupe_de_champs;
    begin
      fillchar(g_groupe_champs, sizeof(g_groupe_champs), 0);
    end; 

  procedure initialise_un_champ(var pv_champ: t_champ;
          p_numero_zone, p_numero_page,
          p_ligne, p_colonne, p_taille, p_decimales: integer;
          p_gabarit: t_gabarit_max);
    begin
      with pv_champ do
      begin
        pt_descripteur_de_zone:= f_pt_descripteur(p_numero_zone);
        ligne_champ:= p_ligne; colonne_champ:= p_colonne;
        taille_champ:= p_taille;
        decimales_champ:= p_decimales;
        gabarit_champ:= p_gabarit;
      end; 
    end; 

  procedure initialise_un_champ_du_groupe(p_numero_zone, p_numero_page,
          p_ligne, p_colonne, p_taille, p_decimales: integer;
          p_gabarit: t_gabarit_max);
    begin
      with g_groupe_champs do
      begin
        initialise_un_champ(g_groupe_champs.table_champs[groupe_champs_fin],
               p_numero_zone, p_numero_page,
               p_ligne, p_colonne, p_taille, p_decimales, p_gabarit);
        if p_numero_page= page_fin
          then begin
              table_champs_de_la_page[page_fin].champ_debut_page:= groupe_champs_fin;
              page_fin:= page_fin+ 1;
            end;
        table_champs_de_la_page[page_fin- 1].champ_fin_page:= groupe_champs_fin;
        groupe_champs_fin:= groupe_champs_fin+ 1;
      end; 
    end; 

  procedure initialise_champ_et_titre(p_numero_zone, p_numero_page,
          p_ligne, p_colonne, p_taille, p_decimales: integer;
          p_gabarit: t_gabarit_max; p_titre: t_titre);
    const kt_indice_titre_fin: integer= 0;
    begin
      initialise_un_champ_du_groupe(p_numero_zone, p_numero_page,
          p_ligne, p_colonne, p_taille, p_decimales, p_gabarit);
      with g_groupe_champs, table_titres[groupe_champs_fin- 1] do
      begin
        if groupe_champs_fin- 1= 0
          then kt_indice_titre_fin:= 0;
        colonne_titre:= 1;
        ligne_titre:= p_ligne;
        pt_titre:= addr(tampon_titres[kt_indice_titre_fin]);
        pt_titre^:= p_titre;
        kt_indice_titre_fin:= kt_indice_titre_fin+ length(p_titre)+ 1;
      end; 
    end; 

    procedure initialise_le_masque_standard;
      var l_numero_zone: integer;
      begin
        initialise_groupe_de_champs;
        for l_numero_zone:= 0 to k_descripteur_zone_fin do
        begin
          with g_fichier_donnees.en_tete.tableau_descripteurs_zones[l_numero_zone] do
          begin
            case type_zone of
              'C' : initialise_champ_et_titre(l_numero_zone, 0,
                      l_numero_zone+ 1, 12, taille_zone, 0,
                      '', nom_zone);
              'N' : initialise_champ_et_titre(l_numero_zone, 0,
                      l_numero_zone+ 1, 12, taille_zone, decimales_zone,
                      '', nom_zone);
              'L' : initialise_champ_et_titre(l_numero_zone, 0,
                      l_numero_zone+ 1, 12, 1, 0,
                      '', nom_zone);
              'D' : initialise_champ_et_titre(l_numero_zone, 0,
                      l_numero_zone+ 1, 12, 8, 0,
                      '', nom_zone);
            end; 
          end; 
        end; 
      end; 
