(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

  const k_taille_descripteur_zone= 32;
        k_taille_nom_zone_max= 10;
  type t_nom_zone= array[0..k_taille_nom_zone_max] of char;
       t_pt_valeur_zone= ^t_chaine_db_max;
       t_descripteur_de_zone= record
                                nom_zone: t_nom_zone;
                                type_zone: char;
                                pt_valeur_zone: t_pt_valeur_zone;
                                taille_zone: byte;
                                case char of
                                  'N' : (decimales_zone: byte;
                                         valeur_numerique: real);
                                  ' ' : (remplissage: array[17..31] of byte);
                              end;
       t_pt_descripteur_de_zone= ^t_descripteur_de_zone;
       t_en_tete_donnees= record
                            signature: byte;
                            date_derniere_mise_a_jour: record
                                                         annee, mois, jour: byte;
                                                       end;
                            nombre_fiches: longint;
                            taille_en_tete: word;
                            taille_fiche: word;
                            remplissage: array[12..31] of byte;
                            tableau_descripteurs_zones: array[0..k_descripteur_zone_fin]
                              of t_descripteur_de_zone;
                            signature_fin: byte;
                          end;
       t_fichier_donnees= record
                            fichier: file;
                            en_tete: t_en_tete_donnees;
                            numero_fiche_courante: longint;
                            position_fiche_courante: longint;
                            fiche_courante: t_fiche_d_base;
                          end;
  var g_fichier_donnees: t_fichier_donnees;
      g_nom_donnees: t_string_80;

  procedure ajoute_definition_de_zone(p_numero_zone: integer;
      p_nom_zone: t_string_80; p_type_zone: char;
      p_taille_zone, p_decimales_zones: integer);

    procedure ajoute_decalage_dans_fiche(var pv_adresse);
      type t_adresse= record
                        decalage, segment: integer;
                      end;
      var l_adresse_surtypee: t_adresse absolute pv_adresse;
          l_numero_zone: integer;
      begin
        with l_adresse_surtypee do
        begin
          decalage:= decalage+ 1;
          for l_numero_zone:= 0 to p_numero_zone- 1 do
            decalage:= decalage
              + g_fichier_donnees.en_tete.tableau_descripteurs_zones[l_numero_zone].taille_zone;
        end; 
      end; 

    begin 
      with g_fichier_donnees.en_tete.tableau_descripteurs_zones[p_numero_zone] do
      begin
        move(p_nom_zone[1], nom_zone, length(p_nom_zone));
        type_zone:= p_type_zone;
        pt_valeur_zone:= addr(g_fichier_donnees.fiche_courante);
        ajoute_decalage_dans_fiche(pt_valeur_zone);
        taille_zone:= p_taille_zone;
        decimales_zone:= p_decimales_zones;
      end; 
    end; 

  procedure cree_fichier_donnees(p_nom_fichier: t_string_80);
    begin 
      with g_fichier_donnees do
      begin
        assign(fichier, p_nom_fichier+ '.DBF');
        rewrite(fichier, 1);
        fillchar(en_tete, sizeof(g_fichier_donnees)- sizeof(fichier), 0);
        with en_tete do
        begin
          signature:= $03;
          date_derniere_mise_a_jour.annee:= 88;
          date_derniere_mise_a_jour.mois:= 08;
          date_derniere_mise_a_jour.jour:= 09;
          taille_en_tete:= sizeof(en_tete);
          taille_fiche:= sizeof(t_fiche_d_base);
          signature_fin:= $0D;
          numero_fiche_courante:= 0;
          position_fiche_courante:= taille_en_tete;
        end; 
      end; 
    end; 

  procedure ouvre_fichier_donnees(p_nom_fichier: t_string_80);

    procedure calcule_adresses_valeurs_des_zones;
      var l_numero_zone: integer;
          l_decalage: integer;

      procedure ajoute_decalage_dans_fiche(var pv_adresse);
        type t_adresse= record
                          decalage, segment: integer;
                        end;
        var l_adresse_surtypee: t_adresse absolute pv_adresse;
        begin
          with l_adresse_surtypee do
            decalage:= decalage+ l_decalage;
          l_decalage:= l_decalage
              + g_fichier_donnees.en_tete.tableau_descripteurs_zones[l_numero_zone].taille_zone;
        end; 

      begin 
        l_decalage:= 1;
        with g_fichier_donnees do
          for l_numero_zone:= 0 to k_descripteur_zone_fin do
            with en_tete.tableau_descripteurs_zones[l_numero_zone] do
            begin
              pt_valeur_zone:= addr(fiche_courante);
              ajoute_decalage_dans_fiche(pt_valeur_zone);
            end; 
      end; 

    begin 
      with g_fichier_donnees do
      begin
        assign(fichier, p_nom_fichier+ '.DBF');
        reset(fichier, 1);
        blockread(fichier, en_tete, sizeof(en_tete));
        calcule_adresses_valeurs_des_zones;
        numero_fiche_courante:= 0;
        position_fiche_courante:= en_tete.taille_en_tete;
      end; 
    end; 

  function f_pt_descripteur(p_numero_zone: integer): t_pt_descripteur_de_zone;
    begin
      f_pt_descripteur:=
        addr(g_fichier_donnees.en_tete.tableau_descripteurs_zones[p_numero_zone]);
    end; 

  function f_fin_fichier_donnees: boolean;
    begin
      f_fin_fichier_donnees:= eof(g_fichier_donnees.fichier);
    end; 

  procedure ferme_fichier_donnees;
    begin
      with g_fichier_donnees do
      begin
        seek(fichier, 0);
        blockwrite(fichier, en_tete, sizeof(en_tete));
        close(fichier);
      end; 
    end; 

  function f_nombre_fiches: longint;
    begin
      f_nombre_fiches:= g_fichier_donnees.en_tete.nombre_fiches;
    end; 

  function f_numero_fiche_courante: longint;
    begin
      f_numero_fiche_courante:= g_fichier_donnees.numero_fiche_courante;
    end; 

  procedure positionne_fiche_courante(p_numero_fiche: longint);
    begin
      with g_fichier_donnees, g_fichier_donnees.en_tete do
      begin
        position_fiche_courante:= taille_en_tete+ p_numero_fiche* taille_fiche;
        numero_fiche_courante:= p_numero_fiche;
        seek(fichier, position_fiche_courante);
      end; 
    end; 

  procedure initialise_fiche_courante;
    begin
      with g_fichier_donnees do
        fillchar(fiche_courante, sizeof(fiche_courante), ' ');
    end; 

  procedure lis_fiche_courante;
    begin
      with g_fichier_donnees, g_fichier_donnees.en_tete do
      begin
        blockread(fichier, fiche_courante, taille_fiche);
        numero_fiche_courante:= numero_fiche_courante+ 1;
        position_fiche_courante:= position_fiche_courante+ taille_fiche;
      end; 
    end; 

  procedure ecris_fiche_courante;
    begin
      with g_fichier_donnees, g_fichier_donnees.en_tete do
      begin
        blockwrite(fichier, fiche_courante, taille_fiche);
        numero_fiche_courante:= numero_fiche_courante+ 1;
        position_fiche_courante:= position_fiche_courante+ taille_fiche;
        if numero_fiche_courante> nombre_fiches
          then nombre_fiches:= nombre_fiches+ 1;
      end; 
    end; 
