(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$v-*)
(*$r+*)
  const k_taille_cle_essai_max= 3;
        k_numero_debut= 20;
        k_cle_min= 'A';
        k_cle_max= 'Z';
        k_premiere_cle= #31;
        k_nombre_cles_essai_max= 70;
        k_nombre_de_passes: integer= 15;
        k_nombre_ajouts= 10;
        k_type_test: set of char= ['t', 's', 'p', 'r'];
  type t_cle_string= string[k_taille_cle_essai_max];
       t_fiche= record
                  cle: t_cle_string;
                end;
  type t_ensemble= record
                     cle: t_cle_string;
                     frequence: integer;
                   end;
  var g_ensemble_de_cles: array[k_numero_debut..k_nombre_cles_essai_max] of t_ensemble;
      g_numero_cle_fin: integer; 
      g_nombre_erreurs: integer;
  type t_ajoute_efface= record
                          la_cle: t_cle_string;
                          ajoute_efface: char;
                        end;
  var g_journal_ajoute_efface: file of t_ajoute_efface;
      g_fiche_journal: t_ajoute_efface;

  procedure affiche_les_erreurs(p_message: t_string_80);
    begin
      g_nombre_erreurs:= g_nombre_erreurs+ 1;
      affiche_erreur(p_message);
    end; 

  function f_genere_cle: t_cle_string;
    var l_indice: integer;
        l_cle: t_cle_string;
    begin
      l_cle:= '';
      for l_indice:= 1 to k_taille_cle_essai_max do
        l_cle:= l_cle+ chr(ord(k_cle_min)+ random(ord(k_cle_max)+ 1- ord(k_cle_min)));
      f_genere_cle:= l_cle;
    end; 

  function f_genere_cle_unique_et_ajoute_ensemble: t_cle_string;
    var l_indice: integer;
        l_cle: t_cle_string;
    begin
      repeat
        l_cle:= f_genere_cle;
        with g_ensemble_de_cles[g_numero_cle_fin] do
        begin
          cle:= l_cle;
          frequence:= 1;
        end;
        l_indice:= k_numero_debut;
        while g_ensemble_de_cles[l_indice].cle<> l_cle do
          l_indice:= l_indice+ 1;
      until (l_indice= g_numero_cle_fin)
        or ((l_indice< g_numero_cle_fin) and (g_ensemble_de_cles[l_indice].frequence= 0));
      if l_indice< g_numero_cle_fin
        then
          with g_ensemble_de_cles[l_indice] do
            frequence:= frequence+ 1
        else g_numero_cle_fin:= g_numero_cle_fin+ 1;
      f_genere_cle_unique_et_ajoute_ensemble:= l_cle;
    end; 

  function f_genere_ancienne_cle(var pv_indice: integer): t_cle_string;
    begin
      repeat
        pv_indice:= k_numero_debut+ random(g_numero_cle_fin- k_numero_debut);
      until g_ensemble_de_cles[pv_indice].frequence> 0;
      f_genere_ancienne_cle:= g_ensemble_de_cles[pv_indice].cle;
    end; 

  procedure retire_ensemble(p_indice: integer);
    begin
      with g_ensemble_de_cles[p_indice] do
        frequence:= frequence- 1;
    end; 

  procedure ajoute_milieu_ensemble(p_cle: t_cle_string);
    var l_indice: integer;
    begin
      with g_ensemble_de_cles[g_numero_cle_fin] do
      begin
        cle:= p_cle;
        frequence:= 1;
      end;
      l_indice:= k_numero_debut;
      while g_ensemble_de_cles[l_indice].cle<> p_cle do
        l_indice:= l_indice+ 1;
      if l_indice< g_numero_cle_fin
        then
          with g_ensemble_de_cles[l_indice] do
            frequence:= 1
        else g_numero_cle_fin:= g_numero_cle_fin+ 1;
    end; 

  procedure cherche_et_retire_ensemble(p_cle: t_cle_string);
    var l_indice: integer;
    begin
      g_ensemble_de_cles[g_numero_cle_fin].cle:= p_cle;
      l_indice:= k_numero_debut;
      while g_ensemble_de_cles[l_indice].cle<> p_cle do
        l_indice:= l_indice+ 1;
      with g_ensemble_de_cles[l_indice] do
        frequence:= frequence- 1;
    end; 

  procedure affiche_ensemble;
    var l_indice: integer;
    begin
      writeln;
      write('>');
      for l_indice:= k_numero_debut to g_numero_cle_fin- 1 do
        with g_ensemble_de_cles[l_indice] do
        begin
          if frequence= 0
            then write('?');
          write(cle, ' ');
        end;
    end; 

  procedure teste_recursif(p_quantite: integer);
    var l_cle, l_cle_precedente: t_cle_string;

    procedure balaye(p_numero_page: t_numero_page);
      var l_indice, l_indice_cle: integer;
          l_page: t_page;
          l_pt_fille: t_pt_fille;
      begin 
        seek(g_index.fichier_b_arbre, p_numero_page);
        blockread(g_index.fichier_b_arbre, l_page, 1);
        with l_page do
        begin
          if numero_page_0<> k_nil
            then balaye(numero_page_0);
          for l_indice:= 1 to nombre_cellules_utilisees do
            with f_pt_cellule(g_index, l_page, l_indice, l_pt_fille)^  do
            begin
              convertis_chaine_db_en_string(cle_db, 2, l_cle);
              write(l_cle, '.');
              if l_cle_precedente<> k_premiere_cle
                then
                  if l_cle< l_cle_precedente
                    then begin
                        affiche_les_erreurs('cls pas dans l''ordre');
                        exit;
                      end;
              l_cle_precedente:= l_cle;
              if l_pt_fille^<> k_nil
                then balaye(l_pt_fille^)
                else 
                    p_quantite:= p_quantite- 1;
            end; 
        end; 
      end; 

    begin 
      liste_pages_index(g_index);
      write(' TESTE RECURSIF INDEX ');
      l_cle_precedente:= k_premiere_cle;
      if g_index.numero_racine<> k_nil
        then balaye(g_index.numero_racine);
      if p_quantite<> 0
        then begin
            write(p_quantite);
            affiche_les_erreurs('quantit de cls<> nombre cls entres');
          end;
      writeln;
    end; 

  procedure teste_recherche;
    var l_indice: integer;
        l_cle_db: t_cle_db;
        l_cle_precedente: string;
        l_ok: boolean;
        l_numero_fiche: longint;
    begin
      write('RECH ');
      for l_indice:= k_numero_debut to g_numero_cle_fin- 1 do
        with g_ensemble_de_cles[l_indice] do
          if frequence> 0
            then begin
                write(cle);
                convertis_string_en_chaine_db(cle, 3, l_cle_db);
                cherche_cle(g_index, l_cle_db, l_numero_fiche, l_ok);
                if l_numero_fiche<> l_indice
                  then begin
                      write(' DECALAGE ', l_numero_fiche, ' ', l_indice);
                      readln;
                    end
                  else writeln(l_numero_fiche: 7);
              end; 
    end; 

  procedure teste_suivant;
    var l_indice: integer;
        l_cle_db: t_cle_db;
        l_cle_precedente: string;
        l_ok: boolean;
        l_numero_fiche: longint;
    begin
      write('RECH ');
      for l_indice:= k_numero_debut to g_numero_cle_fin- 1 do
        with g_ensemble_de_cles[l_indice] do
          if frequence> 0
            then begin
                write(cle);
                convertis_string_en_chaine_db(cle, 3, l_cle_db);
                cherche_cle(g_index, l_cle_db, l_numero_fiche, l_ok);
                if l_numero_fiche<> l_indice
                  then begin
                      write(' DECALAGE ', l_numero_fiche, ' ', l_indice);
                      readln;
                    end
                  else
                    begin
                      writeln;
                      write(' SUIVANT ');
                      l_cle_precedente:= cle;
                      repeat
                        cherche_cle_suivante(g_index, l_numero_fiche);
                        if (l_numero_fiche>= 0)
                          then begin
                              write(g_ensemble_de_cles[l_numero_fiche].cle, ' ');
                              if g_ensemble_de_cles[l_numero_fiche].cle< l_cle_precedente
                                then begin
                                    affiche_les_erreurs(' suivantes pas dans l''ordre ');
                                  end;
                              l_cle_precedente:= g_ensemble_de_cles[l_numero_fiche].cle;
                            end
                          else write(l_numero_fiche, ' ');
                      until l_numero_fiche= -99;
                      writeln;
                    end;
              end; 
    end; 

  procedure teste_precedant;
    var l_indice: integer;
        l_cle_db: t_cle_db;
        l_cle_precedente: string;
        l_ok: boolean;
        l_numero_fiche: longint;
    begin
      writeln('RECH ET PREC');
      for l_indice:= k_numero_debut to g_numero_cle_fin- 1 do
        with g_ensemble_de_cles[l_indice] do
          if frequence> 0
            then begin
                write('--- ', cle);
                convertis_string_en_chaine_db(cle, 3, l_cle_db);
                cherche_cle(g_index, l_cle_db, l_numero_fiche, l_ok);
                write(' ', l_numero_fiche, ' ');
                if l_numero_fiche<> l_indice
                  then begin
                      write(' DECALAGE ', l_numero_fiche, ' ', l_indice);
                      readln;
                    end
                  else
                    begin
                      write(' PREC: ');
                      l_cle_precedente:= cle;
                      repeat
                        cherche_cle_precedante(g_index, l_numero_fiche);
                        if (l_numero_fiche>= 0)
                          then begin
                              write(': ', g_ensemble_de_cles[l_numero_fiche].cle, '=',
                                  l_numero_fiche, ' ');
                              if g_ensemble_de_cles[l_numero_fiche].cle> l_cle_precedente
                                then begin
                                    affiche_les_erreurs(' prcdantes pas dans l''ordre ');
                                  end;
                              l_cle_precedente:= g_ensemble_de_cles[l_numero_fiche].cle;
                            end
                          else write(l_numero_fiche, ' ');
                      until l_numero_fiche= -99;
                      writeln;
                    end;
              end; 
    end; 

  procedure ajoute_une_fiche(p_cle: t_cle_string; p_numero_fiche, p_nombre_fiches: integer);
    var l_cle_db: t_cle_db;
    begin
      writeln('AJOUTE ', p_numero_fiche, ' ', p_nombre_fiches, ' ');
      convertis_string_en_chaine_db(p_cle, 3, l_cle_db);
      ajoute_cle(g_index, l_cle_db, p_numero_fiche);
      if 't' in k_type_test
        then teste_recursif(p_nombre_fiches);
      if 's' in k_type_test
        then teste_suivant;
      if 'p' in k_type_test
        then teste_precedant;
      if 'r' in k_type_test
        then teste_recherche;
    end; 

  procedure efface_une_fiche(p_cle: t_cle_string; p_nombre_fiches: integer);
    var l_cle_db: t_cle_db;
    begin 
      writeln('EFFACE: ', p_cle, ' ');
      convertis_string_en_chaine_db(p_cle, 3, l_cle_db);
      write('>=');
      efface_cle(g_index, l_cle_db);
      write('=<');
      teste_recursif(p_nombre_fiches);
    end; 

  procedure teste_ajout_effacement;
    var l_essai, l_nombre_fiches, l_numero_fiche: integer;

    procedure ajoute_quelques_fiches(p_nombre_ajouts: integer);
      var l_cle: t_cle_string;
          l_fiche: t_fiche;
      begin
        write('va ajouter ', p_nombre_ajouts);
        repeat
          l_cle:= f_genere_cle_unique_et_ajoute_ensemble;
          g_fiche_journal.la_cle:= l_cle;
          g_fiche_journal.ajoute_efface:= 'a';
          write(g_journal_ajoute_efface, g_fiche_journal);
          l_nombre_fiches:= l_nombre_fiches+ 1;
          ajoute_une_fiche(l_cle, l_numero_fiche, l_nombre_fiches);
          l_numero_fiche:= l_numero_fiche+ 1;
          p_nombre_ajouts:= p_nombre_ajouts- 1;
        until (g_nombre_erreurs> 0) or (p_nombre_ajouts= 0)
          or (g_numero_cle_fin>= k_nombre_cles_essai_max);
      end; 

    procedure efface_quelques_fiches(p_nombre_effacements: integer);
      var l_indice_cle: integer;
          l_cle: t_cle_string;
      begin 
        writeln('va effacer ', p_nombre_effacements);
        repeat
          l_cle:= f_genere_ancienne_cle(l_indice_cle);
          retire_ensemble(l_indice_cle);
          g_fiche_journal.la_cle:= l_cle;
          g_fiche_journal.ajoute_efface:= 'e';
          write(g_journal_ajoute_efface, g_fiche_journal);
          l_nombre_fiches:= l_nombre_fiches- 1;
          efface_une_fiche(l_cle, l_nombre_fiches);
          p_nombre_effacements:= p_nombre_effacements- 1;
        until (g_nombre_erreurs> 0) or (p_nombre_effacements= 0)
          or (g_numero_cle_fin= k_nombre_cles_essai_max);
      end; 

    begin 
      writeln;
      cree_un_index(4);
      fillchar(g_ensemble_de_cles, sizeof(g_ensemble_de_cles), 0);
      g_numero_cle_fin:= k_numero_debut;
      ouvre_index(g_index, g_nom_index+ '.NDX');
      assign(g_journal_ajoute_efface, 'journal.ae');
      rewrite(g_journal_ajoute_efface);
      g_nombre_erreurs:= 0; l_essai:= 1;
      l_nombre_fiches:= 0; l_numero_fiche:= k_numero_debut;
      repeat
        ajoute_quelques_fiches(1+ random(k_nombre_ajouts));
        if g_nombre_erreurs= 0
          then efface_quelques_fiches(1+ random(l_nombre_fiches));
        l_essai:= l_essai+ 1;
      until (l_essai> k_nombre_de_passes) or (g_nombre_erreurs> 0);
      writeln('essais: ', l_essai, ', erreurs: ', g_nombre_erreurs);
      close(g_journal_ajoute_efface);
      ferme_index(g_index);
    end; 
