(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program analyse_format_memo;
  uses crt;
  type t_string_80= string[80];
       t_type_page_memo= (en_tete_memo, debut_texte_memo, suite_texte_memo, page_effacee_memo);
       t_page_memo= record
                      case t_type_page_memo of
                        en_tete_memo : (numero_premiere_page_libre: word);
                        debut_texte_memo : (signature_texte: word; bidon: integer;
                                            taille: longint;
                                            debut_texte: array[0..503] of char);
                        suite_texte_memo : (suite_texte: array[0..511] of char);
                        page_effacee_memo : (page_libre_suivante: longint;
                                             nombre_pages_libres: longint);
                    end;
       t_fichier_memo= record
                         nom_fichier: string;
                         fichier_memo: file;
                         numero_page_memo, indice_page_memo: integer;
                         fiche_memo: t_page_memo;
                       end;
  var g_choix: char;
      g_fichier_memo: t_fichier_memo;
      g_nom_memo: string;
  (*$i a:isortie *)

  procedure analyse_structure_pages_memo;
    const k_tabule= #9;
          k_interligne= 10;
          k_return= #13;
    var l_en_tete_memo: t_page_memo;
        l_premiere_page_libre: longint;
        l_numero_page: longint;
        l_taille: longint;
    begin 
      writeln('analyse du fichier mmo');
      with g_fichier_memo do
      begin
        assign(fichier_memo, g_nom_memo+ '.DBT');
        reset(fichier_memo, 512);
        numero_page_memo:= 0; indice_page_memo:= 0;
        blockread(fichier_memo, fiche_memo, 1);
        l_premiere_page_libre:= fiche_memo.numero_premiere_page_libre;
        writeln(g_sortie, 'premire page libre: ',  l_premiere_page_libre, ' ',
            filesize(fichier_memo));
        if l_premiere_page_libre= filesize(fichier_memo)
          then writeln(g_sortie, 'toutes les pages sont prises')
          else begin
              writeln(g_sortie, 'affiche les pages libres:');
              while l_premiere_page_libre< filesize(fichier_memo) do
                with fiche_memo do
                begin
                  write(g_sortie, l_premiere_page_libre: 5, ' ');
                  seek(fichier_memo, l_premiere_page_libre);
                  blockread(fichier_memo, fiche_memo, 1);
                  if page_libre_suivante= filesize(fichier_memo)
                    then write(g_sortie, ' fin fichier');
                  writeln(g_sortie);
                  l_premiere_page_libre:= page_libre_suivante;
                end; 
            end;
        writeln(g_sortie);
        writeln(g_sortie, 'liste squentiellement les pages utilises: ');
        l_numero_page:= 1;
        seek(fichier_memo, 1);
        while l_numero_page< filesize(fichier_memo) do
        begin
          blockread(fichier_memo, fiche_memo, 1);
          with fiche_memo do
          begin
            write(g_sortie, l_numero_page: 4, ' ', l_numero_page* 512: 6,
               signature_texte: 6, ' ');
            if (signature_texte= 65535) and (bidon= 8)
              then begin
                  writeln(g_sortie, 'un texte de       ', taille: 6, ' octets');
                  for l_taille:= 1 to ((taille+ 511) div 512)- 1 do
                  begin
                    l_numero_page:= l_numero_page+ 1;
                    blockread(fichier_memo, fiche_memo, 1);
                  end
                end
              else
                if bidon= 0
                  then begin
                      writeln(g_sortie, 'une page libre de ', taille: 6, ' * 512 octets');
                      for l_taille:= 2 to nombre_pages_libres do
                      begin
                        l_numero_page:= l_numero_page+ 1;
                        blockread(fichier_memo, fiche_memo, 1);
                      end
                    end
                  else begin
                      writeln(g_sortie, 'bug ');
                    end;
          end; 
          l_numero_page:= l_numero_page+ 1;
        end; 
        close(fichier_memo);
      end; 
    end; 

  procedure affiche_texte_memo;
    const k_tabule= #9;
          k_interligne= 10;
          k_return= #13;
          k_return_d_base= #141;
    var l_en_tete_memo: t_page_memo;
        l_premiere_page_libre: longint;
        l_numero_page: longint;
        l_taille, l_reste, l_quantite, l_page: longint;
        l_colonne: integer;

    procedure affiche_regle;
      var l_indice: integer;
          l_colonne: integer;
      begin
        writeln(g_sortie); write(g_sortie, '0');
        for l_colonne:= 1 to 50 do
           write(g_sortie, l_colonne mod 8);
        writeln(g_sortie); write(g_sortie, '|');
        for l_colonne:= 1 to 50 do
          if l_colonne mod 8 = 0
            then write(g_sortie, '|')
            else write(g_sortie, ' ');
        writeln(g_sortie);
      end; 

    procedure affiche_texte(var v_page_memo; p_quantite: integer);
      const k_taille_tabulation= 8;
      var l_tampon_texte: array[0..511] of char absolute v_page_memo;
          l_indice: integer;
      begin
        with g_fichier_memo do
        begin
          with fiche_memo do
          begin
            l_indice:= 0;
            while l_indice<= p_quantite- 1 do
            begin
              case l_tampon_texte[l_indice] of
                k_tabule : begin
                             while l_colonne mod k_taille_tabulation<> 0 do
                             begin
                               write(g_sortie, '.');
                               l_colonne:= l_colonne+ 1;
                             end;
                           end;
                k_return,
                  k_return_d_base : begin
                                      l_colonne:= 0;
                                      writeln(g_sortie);
                                    end;
                else begin
                    write(g_sortie, l_tampon_texte[l_indice]);
                    l_colonne:= l_colonne+ 1;
                  end; 
              end; 
              l_indice:= l_indice+ 1;
            end; 
          end; 
          writeln(g_sortie, '<-- ');
        end; 
      end; 

    begin 
      writeln(g_sortie, 'analyse du texte des zones mmo');
      with g_fichier_memo, fiche_memo do
      begin
        assign(fichier_memo, g_nom_memo+ '.DBT');
        reset(fichier_memo, 512);
        numero_page_memo:= 0;
        blockread(fichier_memo, fiche_memo, 1);
        l_numero_page:= 1;
        writeln;
        while l_numero_page< filesize(fichier_memo) do
        begin
          blockread(fichier_memo, fiche_memo, 1);
          with fiche_memo do
          begin
            if (signature_texte= 65535) and (bidon= 8)
              then begin
                  l_taille:= taille- 8;
                  writeln(g_sortie, l_numero_page: 4, ' ', l_numero_page* 512: 6,
                     l_taille, ' octets');
                  affiche_regle; l_colonne:= 1;
                  l_reste:= l_taille;
                  l_quantite:= l_taille;
                  if l_quantite> 504
                    then l_quantite:= 504;
                  affiche_texte(debut_texte, l_quantite);
                  l_reste:= l_reste- l_quantite;
                  for l_page:= 1 to ((taille+ 511) div 512)- 1 do
                  begin
                    l_quantite:= l_taille;
                    if l_quantite> 512
                      then l_quantite:= 512;
                    affiche_texte(suite_texte, l_quantite);
                    l_numero_page:= l_numero_page+ 1;
                    blockread(fichier_memo, fiche_memo, 1);
                  end
                end
              else
                if bidon= 0
                  then begin
                      for l_page:= 2 to nombre_pages_libres do
                      begin
                        l_numero_page:= l_numero_page+ 1;
                        blockread(fichier_memo, fiche_memo, 1);
                      end
                    end
                  else begin
                      writeln('bug ');
                    end;
          end; 
          l_numero_page:= l_numero_page+ 1;
        end; 
        close(fichier_memo);
      end; 
    end; 

  procedure initialise;
    begin 
      initialise_sortie;
      g_nom_memo:= 'A:EXMEMO2';
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_memo);
      write('Analyse pages, affiche Texte, Sortie, Quitte ? ');
      g_choix:= upcase(readkey); writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'S' : choisis_sortie;
        'T' : affiche_texte_memo;
        'A' : analyse_structure_pages_memo;
      end;
    until g_choix= 'Q';
    ferme_sortie;
  end. 
