(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit ubalaye;
  interface
    uses crt,
         utypcons,
         uhex,
         uclavier, uerreur,
         uecran, uaffiche,
         udonnees, usaisis, uchamps, umemo;
    type t_fiche_balayage= record
                             nouvelle_fiche: boolean;
                             fiche_modifiee: boolean;
                             donnee: array[0..0] of byte;
                           end;
         t_pt_fiche_balayage= ^t_fiche_balayage;
         t_table_fiches= array[0..24] of t_pt_fiche_balayage;
         t_tampon_balayage= record
                              teste_balayage: boolean;
                              numero_fiche_debut: integer;
                              taille_fiche_tampon: integer;
                              ligne_debut, ligne_fin, ligne_fin_max, colonne_max: integer;
                              pt_table_fiches: ^t_table_fiches;
                            end;

    procedure balaye_fichier(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_pt_fichier_memo: t_pt_fichier_memo);

    procedure affiche_parametres_de_balayage(p_tampon_balayage: t_tampon_balayage);

    procedure initialise_balayage(var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_ligne_debut, p_ligne_fin_max, p_colonne_max: integer);

    procedure initialise_champ_et_titre(var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
        p_gabarit: t_gabarit_max; p_titre: t_texte_titre);

    procedure initialise_balayage_standard(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_ligne_debut, p_ligne_fin_max, p_colonne_max: integer);
  implementation

    procedure balaye_fichier(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_pt_fichier_memo: t_pt_fichier_memo);
      var l_ligne: integer;
          l_pt_page: t_pt_page;
          l_pt_champ: t_pt_champ;
          l_sommet_tas: ^integer;

      procedure met_ligne_courante_en_video_inverse(p_pt_page: t_pt_page);
        var l_pt_champ_1: t_pt_champ;
        begin
          with p_pt_page^ do
          begin
            l_pt_champ_1:= pt_champ_debut;
            while l_pt_champ_1<> nil do
            begin
              with l_pt_champ_1^ do
                inverse_champ(l_ligne, colonne_champ, taille_champ);
              l_pt_champ_1:= l_pt_champ_1^.pt_champ_suivant;
            end; 
          end ; 
        end; 

      procedure met_ligne_courante_en_video_normale(p_pt_page: t_pt_page);
        var l_pt_champ_1: t_pt_champ;
        begin
          with p_pt_page^ do
          begin
            l_pt_champ_1:= pt_champ_debut;
            while l_pt_champ_1<> nil do
            begin
              with l_pt_champ_1^ do
                met_champ_en_video_normale(l_ligne, colonne_champ, taille_champ);
              l_pt_champ_1:= l_pt_champ_1^.pt_champ_suivant;
            end; 
          end; 
        end; 

      procedure affiche_les_titres(p_pt_page: t_pt_page);
        var l_numero_champ: integer;
        var l_pt_titre: t_pt_titre;
        begin
          with p_pt_page^ do
          begin
            l_pt_titre:= pt_titre_debut;
            while l_pt_titre<> nil do
            begin
              affiche_titre(l_pt_titre);
              l_pt_titre:= l_pt_titre^.pt_titre_suivant;
            end; 
          end; 
        end; 

      procedure affiche_ligne(p_pt_page: t_pt_page; p_ligne: integer);
        var l_pt_champ_1: t_pt_champ;
            l_pt_valeur: pointer;
        begin
          with p_pt_page^ do
          begin
            l_pt_champ_1:= pt_champ_debut;
            while l_pt_champ_1<> nil do
            begin
              with l_pt_champ_1^, pv_tampon_balayage do
              begin
                gotoxy(colonne_champ, p_ligne);
                (*$r-*)
                l_pt_valeur:= addr(pt_table_fiches^[p_ligne- ligne_debut]^.donnee[position_tampon]);
                (*$r+*)
                case pt_descripteur_de_zone^.type_zone of
                  'C' : affiche_chaine_db(l_pt_valeur^, taille_champ);
                  'N' : affiche_chaine_db_numerique(l_pt_valeur^, taille_champ, decimales_champ,
                             gabarit_champ);
                  'L' : affiche_chaine_db(l_pt_valeur^, 1);
                  'D' : affiche_chaine_db_date(l_pt_valeur^);
                  'M' : write('M');
                end; 
              end; 
              l_pt_champ_1:= l_pt_champ_1^.pt_champ_suivant;
            end; 
          end; 
        end; 

      procedure affiche_page(p_pt_page: t_pt_page);
        var l_ligne_affichage: integer;
        begin
          clrscr;
          affiche_les_titres(p_pt_page);
          with pv_groupe_champs, pv_tampon_balayage do
          begin
            l_ligne_affichage:= ligne_debut;
            (*$r-*)
            while l_ligne_affichage<= ligne_fin do
            (*$r+*)
            begin
              affiche_ligne(p_pt_page, l_ligne_affichage);
              l_ligne_affichage:= l_ligne_affichage+ 1;
            end; 
          end; 
        end; 

      procedure dump_tampon;
        var l_ligne: integer;
        begin
          gotoxy(1, 14);
          with pv_groupe_champs, pv_tampon_balayage do
            for l_ligne:= ligne_debut to ligne_fin do
              with pt_table_fiches^[l_ligne- ligne_debut]^ do
                affiche_memoire(pt_table_fiches^[l_ligne- ligne_debut]^, 8);
        end; 

      procedure saisis_les_champs;
        var l_pt_valeur: ^t_fiche_balayage;

        procedure teste_page_est;
          begin
            with pv_groupe_champs do
            begin
              l_pt_page:= l_pt_page^.pt_page_suivante;
              if l_pt_page<> nil
                then begin
                    l_pt_champ:= l_pt_page^.pt_champ_debut;
                    affiche_page(l_pt_page);
                    g_parametres_saisie.caractere_sortie_de_champ:= k_rien_faire;
                  end;
            end; 
          end; 

        procedure teste_page_ouest;
          begin
            with pv_groupe_champs do
            begin
              l_pt_page:= l_pt_page^.pt_page_precedente;
              if l_pt_page<> nil
                then begin
                    l_pt_champ:= l_pt_page^.pt_champ_fin;
                    affiche_page(l_pt_page);
                    g_parametres_saisie.caractere_sortie_de_champ:= k_rien_faire;
                  end;
            end; 
          end; 

        procedure traite_sortie_de_groupe;
          begin
            with g_parametres_saisie, pv_groupe_champs, pv_tampon_balayage do
            begin
              if (l_pt_champ= nil)
                  and (caractere_sortie_de_champ in [k_curseur_est, k_return, k_page_est])
                then begin
                    caractere_sortie_de_champ:= k_curseur_sud;
                    l_pt_page:= pt_page_debut;
                    l_pt_champ:= pt_page_debut^.pt_champ_debut;
                    position_dans_champ:= 0;
                    affiche_page(l_pt_page);
                  end;
              if (l_pt_champ= nil)
                  and (caractere_sortie_de_champ
                       in [k_curseur_ouest, k_efface_avant_curseur, k_page_ouest])
                then begin
                    l_pt_page:= pt_page_fin;
                    l_pt_champ:= pt_page_fin^.pt_champ_fin;
                    position_dans_champ:= l_pt_champ^.taille_champ- 1;
                    affiche_page(l_pt_page);
                  end;
            end; 
          end; 

        begin 
          with g_parametres_saisie, pv_groupe_champs, pv_tampon_balayage do
          begin
            a_modifie_un_champ_du_groupe:= false;
            caractere_sortie_de_champ:= ' ';
            repeat
              with l_pt_champ^ do
              begin
                if teste_balayage
                  then begin
                      gotoxy(50, 1);
                      write(l_ligne: 3, numero_fiche_debut+ (l_ligne- ligne_debut): 3);
                      dump_tampon;
                    end;
                (*$r-*)
                l_pt_valeur:= addr(pt_table_fiches^[l_ligne- ligne_debut]^.donnee[position_tampon]);
                (*$r+*)
                met_ligne_courante_en_video_inverse(l_pt_page);
                with pt_descripteur_de_zone^ do
                  case type_zone of
                    'C' : saisis_chaine_db(l_ligne, colonne_champ, position_dans_champ, taille_champ,
                            l_pt_valeur^, gabarit_champ, 'C');
                    'N' : saisis_chaine_db_numerique(l_ligne, colonne_champ, position_dans_champ,
                            taille_champ, decimales_champ,
                            taille_zone, decimales_zone,
                            l_pt_valeur^, gabarit_champ);
                    'L' : saisis_booleen(l_ligne, colonne_champ, position_dans_champ,
                            l_pt_valeur^);
                    'D' : saisis_chaine_db_date(l_ligne, colonne_champ, position_dans_champ,
                            taille_champ, l_pt_valeur^, gabarit_champ);
                    'M' : saisis_zone_memo(l_ligne, colonne_champ, l_pt_valeur^, p_pt_fichier_memo);
                  end; 
                met_ligne_courante_en_video_normale(l_pt_page);
                a_modifie_un_champ_du_groupe:=
                  a_modifie_un_champ_du_groupe or a_modifie_le_champ;
                case caractere_sortie_de_champ of
                  k_efface_avant_curseur,
                    k_curseur_ouest :
                      begin
                        l_pt_champ:= l_pt_champ^.pt_champ_precedent;
                        if l_pt_champ= nil
                          then teste_page_ouest
                          else begin
                              position_dans_champ:= l_pt_champ^.taille_champ- 1;
                              caractere_sortie_de_champ:= k_rien_faire;
                            end;
                      end;
                  k_curseur_est,
                    k_return : begin
                                 l_pt_champ:= l_pt_champ^.pt_champ_suivant;
                                 position_dans_champ:= 0;
                                 if l_pt_champ= nil
                                   then teste_page_est
                                   else 
                                       caractere_sortie_de_champ:= k_rien_faire;
                               end;
                  k_page_est : begin
                                 teste_page_est;
                                 if l_pt_page= nil
                                   then l_pt_champ:= nil;
                               end;
                  k_page_ouest : begin
                                   teste_page_ouest;
                                   if l_pt_page= nil
                                     then l_pt_champ:= nil;
                                 end;
                  k_page_suivante, k_page_precedente,
                    k_curseur_sud, k_curseur_nord,
                    k_escape, k_controle_end : ;
                  else
                    affiche_erreur('mauvaise touche de sortie de ligne ');
                    affiche_touche(caractere_sortie_de_champ);
                    caractere_sortie_de_champ:= k_rien_faire;
                end; 
                traite_sortie_de_groupe;
              end; 
            until (caractere_sortie_de_champ in caracteres_sortie_de_champ)
              or (l_pt_champ= nil);
            with pt_table_fiches^[l_ligne- ligne_debut]^ do
              fiche_modifiee:= a_modifie_un_champ_du_groupe
                and (caractere_sortie_de_champ<> k_escape);
          end; 
        end; 

      procedure sauve_fiche_du_tampon(p_ligne: integer);
        var l_pt_page: t_pt_page;
            l_pt_champ: t_pt_champ;
        begin
          with pv_groupe_champs, pv_tampon_balayage, pt_table_fiches^[p_ligne- ligne_debut]^ do
          begin
            if not fiche_modifiee and teste_balayage
              then begin
                  write('.'); exit;
                end;
            if nouvelle_fiche
              then initialise_fiche_courante(p_pt_fichier_donnees)
              else begin
                  positionne_fiche_courante(p_pt_fichier_donnees,
                      numero_fiche_debut+ (p_ligne- ligne_debut));
                  lis_fiche_courante(p_pt_fichier_donnees);
                end;
            l_pt_page:= pt_page_debut;
            while l_pt_page<> nil do
            begin
              with l_pt_page^ do
              begin
                l_pt_champ:= pt_champ_debut;
                while l_pt_champ<> nil do
                begin
                  (*$r-*)
                  with l_pt_champ^ do
                    move(donnee[position_tampon],
                           pt_descripteur_de_zone^.pt_valeur_zone^,
                           taille_champ);
                  (*$r+*)
                  l_pt_champ:= l_pt_champ^.pt_champ_suivant;
                end; 
              end; 
              l_pt_page:= l_pt_page^.pt_page_suivante;
            end; 
            positionne_fiche_courante(p_pt_fichier_donnees,
                numero_fiche_debut+ (p_ligne- ligne_debut));
            ecris_fiche_courante(p_pt_fichier_donnees);
          end; 
        end; 

      procedure charge_et_affiche_fiche(p_numero_fiche: integer);
        var l_pt_valeur: pointer;

        procedure fais_place_dans_tampon;
          var l_pointeur: t_pt_fiche_balayage;
          begin 
            with pv_groupe_champs, pv_tampon_balayage do
            begin
              if ligne_fin< ligne_fin_max
                then begin
                    if (l_ligne= ligne_fin+ 1)
                       or
                         ((l_ligne= ligne_fin)
                          and not
                            (     (l_ligne= ligne_debut)
                              and (g_parametres_saisie.caractere_sortie_de_champ
                                    in [k_curseur_nord, k_page_precedente, k_page_ouest,
                                        k_curseur_ouest, k_efface_avant_curseur])))
                      then getmem(pt_table_fiches^[l_ligne- ligne_debut],
                          taille_fiche_tampon+ 2)
                      else begin
                          move(pt_table_fiches^[0],
                              pt_table_fiches^[1], (ligne_fin+ 1- ligne_debut)* 4);
                          getmem(pt_table_fiches^[0], taille_fiche_tampon+ 2)
                        end;
                    ligne_fin:= ligne_fin+ 1;
                  end
                else
                  if l_ligne= ligne_fin_max
                    then begin
                        l_pointeur:= pt_table_fiches^[ligne_debut- ligne_debut];
                        move(pt_table_fiches^[ligne_debut+ 1- ligne_debut],
                            pt_table_fiches^[ligne_debut- ligne_debut],
                            (ligne_fin_max- ligne_debut)* 4);
                        pt_table_fiches^[ligne_fin_max- ligne_debut]:= l_pointeur;
                      end
                    else begin
                        l_pointeur:= pt_table_fiches^[ligne_fin_max- ligne_debut];
                        move(pt_table_fiches^[ligne_debut- ligne_debut],
                            pt_table_fiches^[ligne_debut+ 1- ligne_debut],
                            (ligne_fin_max- ligne_debut)* 4);
                        pt_table_fiches^[ligne_debut- ligne_debut]:= l_pointeur;
                      end;
            end; 
          end; 

        procedure lis_fiche_dans_tampon(p_numero_fiche: integer);
          var l_pt_page: t_pt_page;
              l_pt_champ: t_pt_champ;
          begin
            with pv_groupe_champs, pv_tampon_balayage, pt_table_fiches^[l_ligne- ligne_debut]^ do
            begin
              positionne_fiche_courante(p_pt_fichier_donnees, p_numero_fiche);
              if p_numero_fiche< f_nombre_fiches(p_pt_fichier_donnees)
                then begin
                    lis_fiche_courante(p_pt_fichier_donnees);
                    nouvelle_fiche:= false;
                    if teste_balayage
                      then begin
                          gotoxy(70, 10+ l_ligne); write('charge ', p_numero_fiche);
                        end;
                  end
                else begin
                    if l_ligne> ligne_debut
                      then
                        with pt_table_fiches^[l_ligne- 1- ligne_debut]^ do
                          if nouvelle_fiche
                            then begin
                                fiche_modifiee:= true;
                                sauve_fiche_du_tampon(l_ligne- 1);
                              end;
                    nouvelle_fiche:= true;
                    initialise_fiche_courante(p_pt_fichier_donnees);
                  end;
              fiche_modifiee:= false;
              fillchar(donnee, taille_fiche_tampon, ' ');
              l_pt_page:= pt_page_debut;
              while l_pt_page<> nil do
              begin
                with l_pt_page^ do
                begin
                  l_pt_champ:= pt_champ_debut;
                  while l_pt_champ<> nil do
                  begin
                    (*$r-*)
                    with l_pt_champ^ do
                      move(pt_descripteur_de_zone^.pt_valeur_zone^,
                             donnee[position_tampon],
                             taille_champ);
                    (*$r+*)
                    l_pt_champ:= l_pt_champ^.pt_champ_suivant;
                  end; 
                end; 
                l_pt_page:= l_pt_page^.pt_page_suivante;
              end; 
            end; 
          end; 

        begin 
          fais_place_dans_tampon;
          lis_fiche_dans_tampon(p_numero_fiche);
          affiche_ligne(l_pt_page, l_ligne);
        end; 

      procedure avance_dans_le_fichier;
        begin
          with pv_groupe_champs, pv_tampon_balayage do
          begin
            sauve_fiche_du_tampon(ligne_debut);
            deroule_ecran(1, ligne_debut, 80, ligne_fin_max, k_deroule_vers_le_nord);
            charge_et_affiche_fiche(numero_fiche_debut+ (l_ligne- ligne_debut)+ 1);
            numero_fiche_debut:= numero_fiche_debut+ 1;
          end; 
        end; 

      procedure recule_dans_le_fichier;
        begin
          with pv_groupe_champs, pv_tampon_balayage do
          begin
            if numero_fiche_debut= 0
              then begin
                  sonne; exit;
                end;
            if ligne_fin= ligne_fin_max
              then sauve_fiche_du_tampon(ligne_fin_max);
            deroule_ecran(1, ligne_debut, 80, ligne_fin_max, k_deroule_vers_le_sud);
            numero_fiche_debut:= numero_fiche_debut- 1;
            charge_et_affiche_fiche(numero_fiche_debut);
          end; 
        end; 

      procedure sauve_les_fiches_du_tampon;
        begin
          with pv_groupe_champs, pv_tampon_balayage do
          begin
            if teste_balayage
              then gotoxy(1, 2);
            (*$r-*)
            while (ligne_fin>= ligne_debut)
              and not pv_tampon_balayage.pt_table_fiches^[ligne_fin- ligne_debut]^.fiche_modifiee do
            (*$r+*)
              ligne_fin:= ligne_fin- 1;
            l_ligne:= ligne_debut;
            (*$r-*)
            while l_ligne<= ligne_fin do
            (*$r+*)
            begin
              sauve_fiche_du_tampon(l_ligne);
              l_ligne:= l_ligne+ 1;
            end; 
          end; 
        end; 

      procedure teste_page_precedente;
        var l_nombre: integer;
        begin
          with pv_tampon_balayage do
          begin
            l_nombre:= ligne_fin_max+ 1- ligne_debut;
            l_ligne:= ligne_debut;
            while (l_nombre> 0) and (numero_fiche_debut> 0) do
            begin
              recule_dans_le_fichier;
              l_nombre:= l_nombre- 1;
            end;
          end; 
        end; 

      procedure teste_page_suivante;
        var l_nombre: integer;
        begin
          with pv_tampon_balayage do
          begin
            l_nombre:= ligne_fin_max+ 1- ligne_debut;
            l_ligne:= ligne_fin;
            while (l_nombre> 0)
              and (numero_fiche_debut+ l_ligne- ligne_debut
                   < f_nombre_fiches(p_pt_fichier_donnees)) do
            begin
              avance_dans_le_fichier;
              l_ligne:= ligne_fin;
              l_nombre:= l_nombre- 1;
            end;
          end; 
        end; 

      procedure libere_balayage;
        var l_ligne: integer;
        begin
          with pv_tampon_balayage do
          begin
            for l_ligne:= ligne_debut to ligne_fin do
              freemem(pt_table_fiches^[l_ligne- ligne_debut], taille_fiche_tampon+ 2);
            freemem(pt_table_fiches, (ligne_fin_max+ 1- ligne_debut)* 4);
          end;
        end; 

      begin 
        with g_parametres_saisie, pv_groupe_champs, pv_tampon_balayage do
        begin
          getmem(pt_table_fiches, (ligne_fin_max+ 1- ligne_debut)* 4);
          fillchar(pt_table_fiches^, (ligne_fin_max+ 1- ligne_debut)* 4, 0);
          l_ligne:= ligne_debut;
          ligne_fin:= ligne_debut- 1;
          l_pt_page:= pt_page_debut; l_pt_champ:= l_pt_page^.pt_champ_debut;
          position_dans_champ:= 0;
          numero_fiche_debut:= f_nombre_fiches(p_pt_fichier_donnees);
          clrscr;
          affiche_les_titres(l_pt_page);
          repeat
            (*$r-*)
            if l_ligne> ligne_fin
              then charge_et_affiche_fiche(numero_fiche_debut+ (l_ligne- ligne_debut));
            (*$r+*)
            saisis_les_champs;
            case caractere_sortie_de_champ of
              k_page_suivante : teste_page_suivante;
              k_page_precedente : teste_page_precedente;
              k_return, k_curseur_est, k_curseur_sud, k_page_est :
                  if l_ligne< ligne_fin_max
                    then l_ligne:= l_ligne+ 1
                    else avance_dans_le_fichier;
              k_curseur_nord, k_efface_avant_curseur, k_page_ouest,
                k_curseur_ouest : if l_ligne> ligne_debut
                                    then l_ligne:= l_ligne- 1
                                    else recule_dans_le_fichier;
              k_escape, k_controle_end : ;
              else
                affiche_erreur('SYST: mauvaise touche de sortie');
                affiche_touche(caractere_sortie_de_champ);
            end;
          until caractere_sortie_de_champ in caracteres_sortie_fiche_a_fiche;
          sauve_les_fiches_du_tampon;
          libere_balayage;
        end; 
      end; 

    procedure affiche_parametres_de_balayage(p_tampon_balayage: t_tampon_balayage);
      var l_champ: integer;
      begin
        with p_tampon_balayage do
        begin
          write(numero_fiche_debut: 6);
        end;
      end; 

    procedure initialise_balayage(var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_ligne_debut, p_ligne_fin_max, p_colonne_max: integer);
      begin 
        initialise_groupe_de_champs(pv_groupe_champs);
        fillchar(pv_tampon_balayage, sizeof(pv_tampon_balayage), 0);
        pv_tampon_balayage.ligne_debut:= p_ligne_debut;
        pv_tampon_balayage.ligne_fin_max:= p_ligne_fin_max;
        pv_tampon_balayage.colonne_max:= p_colonne_max;
      end; 

    procedure initialise_champ_et_titre(var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
        p_gabarit: t_gabarit_max; p_titre: t_texte_titre);
      const kt_colonne_courante: integer= 1;
            kt_page_balayage: integer= 0;
      begin 
        with pv_tampon_balayage, p_pt_descripteur_de_zone^ do
        begin
          if pv_groupe_champs.pt_page_debut= nil
            then begin
                kt_page_balayage:= 0;
                kt_colonne_courante:= 1;
              end;
          if 1+ kt_colonne_courante+ taille_zone> colonne_max
            then begin
                kt_page_balayage:= kt_page_balayage+ 1;
                kt_colonne_courante:= 1;
              end;
          case type_zone of
            'C' : initialise_champ(pv_groupe_champs,
                      p_pt_descripteur_de_zone,
                      kt_page_balayage, 0, kt_colonne_courante,
                      taille_zone, 0,
                      p_gabarit, taille_fiche_tampon);
            'N' : initialise_champ(pv_groupe_champs,
                      p_pt_descripteur_de_zone,
                      kt_page_balayage, 0, kt_colonne_courante,
                      taille_zone, decimales_zone,
                      p_gabarit, taille_fiche_tampon);
            'L' : initialise_champ(pv_groupe_champs,
                      p_pt_descripteur_de_zone,
                      kt_page_balayage, 0, kt_colonne_courante,
                      1, 0,
                      p_gabarit, taille_fiche_tampon);
            'D' : initialise_champ(pv_groupe_champs,
                      p_pt_descripteur_de_zone,
                      kt_page_balayage, 0, kt_colonne_courante,
                      8, 0,
                      p_gabarit, taille_fiche_tampon);
            'M' : initialise_champ(pv_groupe_champs,
                      p_pt_descripteur_de_zone,
                      kt_page_balayage, 0, kt_colonne_courante,
                      1, 0,
                      p_gabarit, taille_fiche_tampon);
          end; 
          initialise_titre(pv_groupe_champs, kt_page_balayage, 1, kt_colonne_courante,
                        nom_zone);
          kt_colonne_courante:= kt_colonne_courante+ taille_zone+ 1;
          taille_fiche_tampon:= taille_fiche_tampon+ taille_zone;
        end; 
      end; 

    procedure initialise_balayage_standard(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_ligne_debut, p_ligne_fin_max, p_colonne_max: integer);
      var l_numero_zone: integer;
          l_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
      begin
        initialise_balayage(pv_groupe_champs, pv_tampon_balayage,
          p_ligne_debut, p_ligne_fin_max, p_colonne_max);
        for l_numero_zone:= 0 to f_nombre_zones(p_pt_fichier_donnees)- 1 do
        begin
          l_pt_descripteur_de_zone:=
              f_pt_descripteur_zone(p_pt_fichier_donnees, l_numero_zone);
          initialise_champ_et_titre(pv_groupe_champs, pv_tampon_balayage,
            l_pt_descripteur_de_zone,
            '', l_pt_descripteur_de_zone^.nom_zone);
        end; 
        pv_tampon_balayage.teste_balayage:= false;
      end; 

  begin 
  end. 




