(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit ubalayei;
  interface
    uses crt,
         uclavier, uerreur, uhex,
         utypcons, uchained,
         uecran, uaffiche, usaisis,
         udonnees, uchamps,
         umemo,
         uindex;
    const k_taille_fiche_tampon_fixe= 6; 
    type t_numero_fiche= longint;
         t_type_balayage= (balayage_sequentiel, balayage_indexe);
         t_fiche_balayage= record
                             numero_fiche: t_numero_fiche;
                             nouvelle_fiche: boolean;
                             fiche_modifiee: boolean;
                             donnee: array[0..0] of byte;
                           end;
         t_pt_fiche_balayage= ^t_fiche_balayage;
         t_table_fiches= array[0..24] of t_pt_fiche_balayage;
         t_tampon_balayage= record
                              teste_balayage: boolean;
                              position_cle: integer;
                              taille_fiche_tampon: integer;
                              ligne_debut,
                                ligne_fin,
                                ligne_fin_max,
                                colonne_max: integer;
                              pt_table_fiches: ^t_table_fiches;
                            end;

    procedure balaye_fichier(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        var pv_index: t_index;
        p_type_balayage: t_type_balayage;
        p_pt_fichier_memo: t_pt_fichier_memo);

    procedure affiche_parametres_de_balayage(p_tampon_balayage: t_tampon_balayage);

    procedure initialise_balayage(var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_ligne_debut, p_ligne_fin_max, p_colonne_max: integer);

    procedure initialise_champ_et_titre(var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
        p_gabarit: t_gabarit_max; p_titre: t_texte_titre);

    procedure initialise_balayage_standard(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        p_ligne_debut, p_ligne_fin_max, p_colonne_max: integer);
  implementation
    var s_direction: (aucune, debut, fin);

    procedure balaye_fichier(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_groupe_champs: t_groupe_champs;
        var pv_tampon_balayage: t_tampon_balayage;
        var pv_index: t_index;
        p_type_balayage: t_type_balayage;
        p_pt_fichier_memo: t_pt_fichier_memo);
      var l_ligne: integer;
          l_pt_page: t_pt_page;
          l_pt_champ: t_pt_champ;
          l_cle_precedente_db: t_cle_db;
          l_a_modifie_cle: boolean;
          l_nouvelle_cle: boolean;
      (*$i a:isaisisb *)

      procedure cherche_cle_tampon(p_ligne: integer; var pv_cle_db: t_cle_db);
        begin
          with pv_tampon_balayage, pt_table_fiches^[p_ligne- ligne_debut]^ do
            (*$r-*)
            move(donnee[position_cle], pv_cle_db, pv_index.taille_cle);
            (*$r+*)
        end; 

      procedure reconstruis_chemin(p_ligne: integer);
        var l_cle_db: t_cle_db;
            l_numero_fiche: t_numero_fiche;
            l_ok: boolean;
        begin
          with pv_groupe_champs, pv_tampon_balayage, pt_table_fiches^[p_ligne- ligne_debut]^ do
          begin
            cherche_cle_tampon(p_ligne, l_cle_db);
            cherche_cle(pv_index, l_cle_db, l_numero_fiche, l_ok);
          end; 
        end; 

      procedure sauve_fiche_du_tampon_modifiee(p_ligne: integer);
        var l_pt_page: t_pt_page;
            l_pt_champ: t_pt_champ;
        begin
          with pv_groupe_champs, pv_tampon_balayage, pt_table_fiches^[p_ligne- ligne_debut]^ do
          begin
            if fiche_modifiee
              then begin
                  if teste_balayage
                    then begin
                        write(' v ', numero_fiche, nouvelle_fiche);
                      end;
                  if nouvelle_fiche
                    then initialise_fiche_courante(p_pt_fichier_donnees)
                    else begin
                        positionne_fiche_courante(p_pt_fichier_donnees, numero_fiche);
                        if (numero_fiche< 0)
                             or (numero_fiche> f_nombre_fiches(p_pt_fichier_donnees))
                          then begin
                              gotoxy(1, 1);
                              write(numero_fiche, ' ');
                              affiche_erreur('SYST ');
                            end;
                        lis_fiche_courante(p_pt_fichier_donnees);
                      end; 
                  l_pt_page:= pt_page_debut;
                  while l_pt_page<> nil do
                  begin
                    with l_pt_page^ do
                    begin
                      l_pt_champ:= pt_champ_debut;
                      while l_pt_champ<> nil do
                      begin
                        (*$r-*)
                        with l_pt_champ^ do
                          move(donnee[position_tampon],
                                 pt_descripteur_de_zone^.pt_valeur_zone^,
                                 taille_champ);
                        (*$r+*)
                        l_pt_champ:= l_pt_champ^.pt_champ_suivant;
                      end; 
                    end; 
                    l_pt_page:= l_pt_page^.pt_page_suivante;
                  end; 
                  positionne_fiche_courante(p_pt_fichier_donnees, numero_fiche);
                  ecris_fiche_courante(p_pt_fichier_donnees);
                end; 
          end; 
        end; 

      procedure lis_fiche_dans_tampon(p_ligne, p_numero_fiche: integer);
        var l_pt_page: t_pt_page;
            l_pt_champ: t_pt_champ;
        begin
          with pv_groupe_champs, pv_tampon_balayage, pt_table_fiches^[p_ligne- ligne_debut]^ do
          begin
            if teste_balayage
              then begin
                  gotoxy(70, 15); write('CH ', p_ligne: 3, p_numero_fiche: 3);
                end;
            numero_fiche:= p_numero_fiche;
            positionne_fiche_courante(p_pt_fichier_donnees, p_numero_fiche);
            if numero_fiche< f_nombre_fiches(p_pt_fichier_donnees)
              then begin
                  lis_fiche_courante(p_pt_fichier_donnees);
                  nouvelle_fiche:= false;
                end
              else begin
                  if p_ligne> ligne_debut
                    then
                      with pt_table_fiches^[p_ligne- 1- ligne_debut]^ do
                        if nouvelle_fiche
                          then begin
                              fiche_modifiee:= true;
                              sauve_fiche_du_tampon_modifiee(p_ligne- 1);
                            end;
                  nouvelle_fiche:= true;
                  initialise_fiche_courante(p_pt_fichier_donnees);
                end;
            fiche_modifiee:= false;
            fillchar(donnee[0], taille_fiche_tampon, ' ');
            l_pt_page:= pt_page_debut;
            while l_pt_page<> nil do
            begin
              with l_pt_page^ do
              begin
                l_pt_champ:= pt_champ_debut;
                while l_pt_champ<> nil do
                begin
                  (*$r-*)
                  with l_pt_champ^ do
                    move(pt_descripteur_de_zone^.pt_valeur_zone^,
                           donnee[position_tampon],
                           taille_champ);
                  (*$r+*)
                  l_pt_champ:= l_pt_champ^.pt_champ_suivant;
                end; 
              end; 
              l_pt_page:= l_pt_page^.pt_page_suivante;
            end; 
            numero_fiche:= p_numero_fiche;
          end; 
        end; 

      procedure charge_et_affiche_fiche(p_ligne, p_numero_fiche: integer);

        procedure prepare_tampon;
          var l_pointeur: t_pt_fiche_balayage;
          begin 
            with pv_groupe_champs, pv_tampon_balayage do
            begin
              if ligne_fin< ligne_fin_max
                then begin
                    ligne_fin:= ligne_fin+ 1;
                  end
                else
                  if p_ligne= ligne_fin_max
                    then begin
                        l_pointeur:= pt_table_fiches^[ligne_debut- ligne_debut];
                        move(pt_table_fiches^[ligne_debut+ 1- ligne_debut],
                             pt_table_fiches^[ligne_debut- ligne_debut],
                             (ligne_fin_max- ligne_debut)* 4);
                        pt_table_fiches^[ligne_fin_max- ligne_debut]:= l_pointeur;
                      end
                    else begin
                        l_pointeur:= pt_table_fiches^[ligne_fin_max- ligne_debut];
                        move(pt_table_fiches^[ligne_debut- ligne_debut],
                             pt_table_fiches^[ligne_debut+ 1- ligne_debut],
                             (ligne_fin_max- ligne_debut)* 4);
                        pt_table_fiches^[ligne_debut- ligne_debut]:= l_pointeur;
                      end;
            end; 
          end; 

        begin 
          prepare_tampon;
          lis_fiche_dans_tampon(p_ligne, p_numero_fiche);
          affiche_ligne(l_pt_page, p_ligne);
        end; 

      procedure avance_dans_le_fichier;
        var l_numero_fiche: t_numero_fiche;
        begin
          with pv_groupe_champs, pv_tampon_balayage do
          begin
            if ligne_fin= ligne_fin_max
              then begin
                  sauve_fiche_du_tampon_modifiee(ligne_debut);
                  deroule_ecran(1, ligne_debut, 80, ligne_fin_max, k_deroule_vers_le_nord);
                end
              else begin
                  sonne;
                  l_ligne:= l_ligne+ 1;
                  with pt_table_fiches^[l_ligne- ligne_debut]^ do
                    numero_fiche:= pt_table_fiches^[l_ligne- 1- ligne_debut]^.numero_fiche;
                end;
            if p_type_balayage= balayage_indexe
              then begin
                  if s_direction= debut
                    then reconstruis_chemin(l_ligne);
                  s_direction:= fin;
                  cherche_cle_suivante(pv_index, l_numero_fiche);
                  if l_numero_fiche= k_fin_fichier
                    then begin
                        l_numero_fiche:= f_nombre_fiches(p_pt_fichier_donnees);
                        l_nouvelle_cle:= true;
                      end
                    else l_nouvelle_cle:= false;
                  charge_et_affiche_fiche(l_ligne, l_numero_fiche);
                end 
              else begin
                  with pt_table_fiches^[l_ligne- ligne_debut]^ do
                    charge_et_affiche_fiche(l_ligne, numero_fiche+ 1);
                end;
          end; 
        end; 

      procedure recule_dans_le_fichier;
        var l_numero_fiche: t_numero_fiche;
        begin
          with pv_groupe_champs, pv_tampon_balayage do
          begin
            if p_type_balayage= balayage_indexe
              then begin
                  if s_direction= fin
                    then reconstruis_chemin(ligne_debut);
                  s_direction:= debut;
                  cherche_cle_precedante(pv_index, l_numero_fiche);
                  if l_numero_fiche= k_fin_fichier
                    then begin
                        sonne; exit;
                      end;
                  if ligne_fin= ligne_fin_max
                    then sauve_fiche_du_tampon_modifiee(ligne_fin_max);
                  deroule_ecran(1, ligne_debut, 80, ligne_fin_max, k_deroule_vers_le_sud);
                  charge_et_affiche_fiche(l_ligne, l_numero_fiche);
                end
              else begin 
                  if pt_table_fiches^[ligne_debut- ligne_debut]^.numero_fiche= 0
                    then begin
                        sonne; exit;
                      end;
                  if ligne_fin= ligne_fin_max
                    then sauve_fiche_du_tampon_modifiee(ligne_fin_max);
                  deroule_ecran(1, ligne_debut, 80, ligne_fin_max, k_deroule_vers_le_sud);
                  with pt_table_fiches^[ligne_debut- ligne_debut]^ do
                    charge_et_affiche_fiche(l_ligne, numero_fiche- 1);
                end; 
          end; 
        end; 

      procedure teste_page_precedente;
        var l_nombre: integer;
        begin
          with pv_tampon_balayage do
          begin
            l_nombre:= ligne_fin_max+ 1- ligne_debut;
            l_ligne:= ligne_debut;
            while (l_nombre> 0) and (pt_table_fiches^[ligne_debut]^.numero_fiche> 0) do
            begin
              recule_dans_le_fichier;
              l_nombre:= l_nombre- 1;
            end; 
          end; 
        end; 

      procedure teste_page_suivante;
        var l_nombre: integer;
        begin
          with pv_tampon_balayage do
          begin
            l_nombre:= ligne_fin_max+ 1- ligne_debut;
            l_ligne:= ligne_fin;
            while (l_nombre> 0)
              and (pt_table_fiches^[ligne_debut]^.numero_fiche
                    < f_nombre_fiches(p_pt_fichier_donnees)) do
            begin
              avance_dans_le_fichier;
              l_ligne:= ligne_fin;
              l_nombre:= l_nombre- 1;
            end;
          end; 
        end; 

      procedure sauve_les_fiches_du_tampon;
        var l_ligne_5: integer;
        begin
          with pv_groupe_champs, pv_tampon_balayage do
          begin
            l_ligne_5:= ligne_debut;
            (*$r-*)
            while l_ligne_5< ligne_fin do
            (*$r+*)
            begin
              sauve_fiche_du_tampon_modifiee(l_ligne_5);
              l_ligne_5:= l_ligne_5+ 1;
            end; 
            with pt_table_fiches^[ligne_fin- ligne_debut]^ do
              if fiche_modifiee and (numero_fiche= f_nombre_fiches(p_pt_fichier_donnees))
                then sauve_fiche_du_tampon_modifiee(ligne_fin);
          end; 
        end; 

      procedure rafraichis_ecran;
        var l_ligne_3: integer;
        begin
          clrscr;
          affiche_les_titres(l_pt_page);
          with pv_groupe_champs, pv_tampon_balayage do
            for l_ligne_3:= ligne_debut to ligne_fin do
              affiche_ligne(l_pt_page, l_ligne_3);
        end; 

      procedure modifie_cle;
        var l_cle_db, l_cle_debut_db: t_cle_db;
            l_numero_fiche: t_numero_fiche;
            l_a_trouve: boolean;
            l_encore: boolean;
        begin
          with pv_tampon_balayage do
          begin
            if not l_nouvelle_cle
              then begin
                  efface_cle(pv_index, l_cle_precedente_db);
                end;
            cherche_cle_tampon(l_ligne, l_cle_db);
            with pt_table_fiches^[l_ligne- ligne_debut]^ do
              ajoute_cle(pv_index, l_cle_db, numero_fiche);
            cherche_cle_tampon(ligne_debut, l_cle_debut_db);
            affiche_chaine_db(l_cle_debut_db, pv_index.taille_cle);
            cherche_cle(pv_index, l_cle_debut_db, l_numero_fiche, l_a_trouve);
            if not l_a_trouve
              then affiche_erreur('SYST: pas trouv cl dbut');
            l_ligne:= ligne_debut;
            lis_fiche_dans_tampon(l_ligne, l_numero_fiche);
            l_ligne:= l_ligne+ 1;
            l_encore:= true;
            repeat
              cherche_cle_suivante(pv_index, l_numero_fiche);
              if l_numero_fiche= k_fin_fichier
                then l_encore:= false
                else begin
                    lis_fiche_dans_tampon(l_ligne, l_numero_fiche);
                    l_ligne:= l_ligne+ 1;
                  end;
            until not l_encore or (l_ligne> ligne_fin_max);
            ligne_fin:= l_ligne- 1;
            l_nouvelle_cle:= false;
            l_ligne:= ligne_debut;
            rafraichis_ecran;
          end; 
        end; 

      procedure alloue_et_initialise_tampon;
        var l_ligne_6: integer;
        begin
          with pv_tampon_balayage do
          begin
            getmem(pt_table_fiches, (ligne_fin_max+ 1- ligne_debut)* 4);
            for l_ligne_6:= ligne_debut to ligne_fin_max do
              getmem(pt_table_fiches^[l_ligne_6- ligne_debut],
                  k_taille_fiche_tampon_fixe+ taille_fiche_tampon);
          end; 
        end; 

      procedure initialise_sequentiel;
        var l_numero_fiche: t_numero_fiche;
        begin
          with pv_groupe_champs, pv_tampon_balayage do
          begin
            l_numero_fiche:= 0;
            while (l_ligne<= ligne_fin_max)
                and (l_numero_fiche< f_nombre_fiches(p_pt_fichier_donnees)) do
            begin
              lis_fiche_dans_tampon(l_ligne, l_numero_fiche);
              l_numero_fiche:= l_numero_fiche+ 1;
              l_ligne:= l_ligne+ 1;
            end; 
            if l_numero_fiche= 0
              then begin
                  ligne_fin:= ligne_debut;
                  with pt_table_fiches^[ligne_debut- ligne_debut]^ do
                  begin
                    numero_fiche:= 0; fiche_modifiee:= false; nouvelle_fiche:= true;
                    fillchar(donnee[0], taille_fiche_tampon, ' ');
                  end;
                end
              else ligne_fin:= ligne_debut+ l_numero_fiche- 1;
          end; 
        end; 

      procedure initialise_indexe;

        procedure cherche_position_cle;
          var l_pt_page: t_pt_page;
              l_pt_champ_1: t_pt_champ;
              l_pt_valeur: pointer;
              l_trouve: boolean;
          begin
            with pv_index, pv_groupe_champs, pv_tampon_balayage do
            begin
              l_trouve:= false;
              l_pt_page:= pt_page_debut;
              while not l_trouve and (l_pt_page<> nil) do
                with l_pt_page^ do
                begin
                  l_pt_champ_1:= pt_champ_debut;
                  while not l_trouve and (l_pt_champ_1<> nil) do
                  begin
                    with l_pt_champ_1^ do
                    begin
                      if f_egal(pt_descripteur_de_zone^.nom_zone, nom_cle, 10)
                        then begin
                            l_trouve:= true;
                            position_cle:= position_tampon;
                          end;
                    end; 
                  l_pt_champ_1:= l_pt_champ_1^.pt_champ_suivant;
                end; 
                l_pt_page:= l_pt_page^.pt_page_suivante;
              end; 
              if not l_trouve
                then begin
                    affiche_erreur('il faut que la cl soit dans la tampon');
                  end;
            end; 
          end; 

        procedure charge_tampon;
          var l_premiere_cle_db: t_cle_db;
              l_numero_fiche: t_numero_fiche;
              l_a_trouve: boolean;
          begin
            with pv_groupe_champs, pv_tampon_balayage do
            begin
              if f_nombre_fiches(p_pt_fichier_donnees)= 0
                then begin
                    ligne_fin:= ligne_debut;
                    with pt_table_fiches^[ligne_debut- ligne_debut]^ do
                    begin
                      numero_fiche:= 0; fiche_modifiee:= false; nouvelle_fiche:= true;
                      fillchar(donnee[0], taille_fiche_tampon, ' ');
                    end;
                    l_nouvelle_cle:= true;
                  end
                else begin
                    fillchar(l_premiere_cle_db, pv_index.taille_cle, #0);
                    cherche_cle(pv_index, l_premiere_cle_db, l_numero_fiche, l_a_trouve);
                    lis_fiche_dans_tampon(l_ligne, l_numero_fiche);
                    l_ligne:= l_ligne+ 1;
                    while (l_ligne<= ligne_fin_max)
                        and (l_ligne+ 1- ligne_debut< f_nombre_fiches(p_pt_fichier_donnees)) do
                    begin
                      cherche_cle_suivante(pv_index, l_numero_fiche);
                      lis_fiche_dans_tampon(l_ligne, l_numero_fiche);
                      l_ligne:= l_ligne+ 1;
                    end; 
                    ligne_fin:= l_ligne- 1;
                    l_nouvelle_cle:= false;
                  end; 
            end; 
          end; 

        begin 
          cherche_position_cle;
          charge_tampon;
        end; 

      procedure libere_balayage;
        var l_ligne_1: integer;
        begin
          with pv_tampon_balayage do
          begin
            for l_ligne_1:= ligne_debut to ligne_fin do
              freemem(pt_table_fiches^[l_ligne_1- ligne_debut],
                  k_taille_fiche_tampon_fixe+ taille_fiche_tampon);
            freemem(pt_table_fiches, (ligne_fin_max+ 1- ligne_debut)* 4);
          end;
        end; 

      begin 
        with g_parametres_saisie, pv_groupe_champs, pv_tampon_balayage do
        begin
          alloue_et_initialise_tampon;
          l_ligne:= ligne_debut;
          if p_type_balayage= balayage_indexe
            then initialise_indexe
            else initialise_sequentiel;
          l_pt_page:= pt_page_debut; l_pt_champ:= l_pt_page^.pt_champ_debut;
          position_dans_champ:= 0;
          l_ligne:= ligne_debut;
          rafraichis_ecran;
          s_direction:= aucune;
          repeat
            if p_type_balayage= balayage_indexe
              then cherche_cle_tampon(l_ligne, l_cle_precedente_db);
            saisis_les_champs;
            with pt_table_fiches^[l_ligne- ligne_debut]^ do
            begin
              fiche_modifiee:= fiche_modifiee
                or (a_modifie_un_champ_du_groupe and (caractere_sortie_de_champ<> k_escape));
              if (p_type_balayage= balayage_indexe) and (caractere_sortie_de_champ<> k_escape)
                  and (l_a_modifie_cle or (l_nouvelle_cle and fiche_modifiee))
                then modifie_cle;
            end; 
            case caractere_sortie_de_champ of
              k_page_suivante : teste_page_suivante;
              k_page_precedente : teste_page_precedente;
              k_return, k_curseur_est, k_curseur_sud, k_page_est :
                if l_ligne< ligne_fin
                  then l_ligne:= l_ligne+ 1
                  else avance_dans_le_fichier;
              k_curseur_nord, k_efface_avant_curseur, k_page_ouest,
                k_curseur_ouest : if l_ligne> ligne_debut
                                    then l_ligne:= l_ligne- 1
                                    else recule_dans_le_fichier;
              k_escape, k_controle_end : ;
              else
                affiche_erreur('SYST: mauvaise touche de sortie');
                affiche_touche(caractere_sortie_de_champ);
            end;
          until caractere_sortie_de_champ in caracteres_sortie_fiche_a_fiche;
          sauve_les_fiches_du_tampon;
          libere_balayage;
        end; 
      end; 
    (*$i a:iinitbal *)

  begin 
  end. 




