(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

unit uchained;
  interface
    uses utypcons;

    procedure convertis_chaine_0_en_string(var pv_chaine_0; var pv_string: string);

    procedure convertis_string_en_chaine_0(var v_string: string; var pv_chaine_0);

    procedure convertis_chaine_db_en_string(var pv_chaine_db; p_taille: integer;
        var pv_string: string);

    procedure convertis_string_en_chaine_db(var v_string: string; p_taille: integer;
        var pv_chaine_db);

    procedure convertis_chaine_db_en_longint(var pv_chaine_db; p_taille: byte;
        var pv_entier: longint; var pv_erreur: integer);

    procedure convertis_longint_en_chaine_db(p_entier: longint; p_taille: byte;
        var pv_chaine_db);

    procedure convertis_chaine_db_en_reel(var pv_chaine_db; p_taille: byte;
        var pv_reel: real; var pv_erreur: integer);

    procedure convertis_reel_en_chaine_db(p_reel: real;
        p_taille, p_decimales: byte;
        var pv_chaine_db);

    function f_inferieur_ou_egal(var pv_tableau_1, pv_tableau_2; p_taille: integer): boolean;

    function f_egal(var pv_tableau_1, pv_tableau_2; p_taille: integer): boolean;
  implementation

    procedure convertis_chaine_0_en_string(var pv_chaine_0; var pv_string: string);
      var l_chaine_surtypee: t_chaine_db_max absolute pv_chaine_0;
          l_taille: integer;
      begin
        l_taille:= 0;
        while l_chaine_surtypee[l_taille]<> chr(0) do
          l_taille:= l_taille+ 1;
        move(pv_chaine_0, pv_string[1], l_taille);
        pv_string[0]:= chr(l_taille);
      end; 

    procedure convertis_string_en_chaine_0(var v_string: string; var pv_chaine_0);
      var l_chaine_surtypee: t_chaine_db_max absolute pv_chaine_0;
          l_taille: integer;
      begin
        l_taille:= length(v_string);
        move(v_string[1], pv_chaine_0, l_taille);
        l_chaine_surtypee[l_taille]:= chr(0);
      end; 

    procedure convertis_chaine_db_en_string(var pv_chaine_db; p_taille: integer;
        var pv_string: string);
      begin
        move(pv_chaine_db, pv_string[1], p_taille);
        pv_string[0]:= chr(p_taille);
      end; 

    procedure convertis_string_en_chaine_db(var v_string: string; p_taille: integer;
        var pv_chaine_db);
      var l_taille: integer;
          l_chaine_db: t_chaine_db_max absolute pv_chaine_db;
      begin
        l_taille:= length(v_string);
        move(v_string[1], pv_chaine_db, l_taille);
        fillchar(l_chaine_db, p_taille- l_taille, ' ');
      end; 

    procedure convertis_chaine_db_en_longint(var pv_chaine_db; p_taille: byte;
        var pv_entier: longint; var pv_erreur: integer);
      var l_string: string;
      begin
        move(pv_chaine_db, l_string[1], p_taille);
        l_string[0]:= chr(p_taille);
        val(l_string, pv_entier, pv_erreur);
      end; 

    procedure convertis_longint_en_chaine_db(p_entier: longint; p_taille: byte;
        var pv_chaine_db);
      var l_string: string;
          l_indice: integer;
      begin
        str(p_entier: p_taille, l_string);
        for l_indice:= 1 to p_taille do
          if l_string[l_indice]= ' '
            then l_string[l_indice]:= '0';
        move(l_string[1], pv_chaine_db, p_taille);
      end; 

    procedure convertis_chaine_db_en_reel(var pv_chaine_db; p_taille: byte;
        var pv_reel: real; var pv_erreur: integer);
      var l_string: string;
      begin
        move(pv_chaine_db, l_string[1], p_taille);
        l_string[0]:= chr(p_taille);
        val(l_string, pv_reel, pv_erreur);
      end; 

    procedure convertis_reel_en_chaine_db(p_reel: real;
        p_taille, p_decimales: byte;
        var pv_chaine_db);
      var l_string: string;
          l_indice: integer;
      begin
        str(p_reel: p_taille: p_decimales, l_string);
        for l_indice:= 1 to p_taille do
          if l_string[l_indice]= ' '
            then l_string[l_indice]:= ' ';
        move(l_string[1], pv_chaine_db, p_taille);
      end; 

    function f_inferieur_ou_egal(var pv_tableau_1, pv_tableau_2; p_taille: integer): boolean;
      var l_tableau_1: t_chaine_db_max absolute pv_tableau_1;
          l_tableau_2: t_chaine_db_max absolute pv_tableau_2;
          l_indice: integer;
      begin
        l_indice:= 0;
        while (l_indice<= p_taille- 1) and (l_tableau_1[l_indice]= l_tableau_2[l_indice]) do
          l_indice:= l_indice+ 1;
        f_inferieur_ou_egal:= ((l_indice< p_taille) and (l_tableau_1[l_indice]< l_tableau_2[l_indice]))
                           or (l_indice= p_taille);
      end; 

    function f_egal(var pv_tableau_1, pv_tableau_2; p_taille: integer): boolean;
      var l_tableau_1: t_chaine_db_max absolute pv_tableau_1;
          l_tableau_2: t_chaine_db_max absolute pv_tableau_2;
          l_indice: integer;
      begin
        l_indice:= 0;
        while (l_indice<= p_taille- 1) and (l_tableau_1[l_indice]= l_tableau_2[l_indice]) do
          l_indice:= l_indice+ 1;
         f_egal:= l_indice= p_taille;
      end; 

  begin 
  end. 









