(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit uchamps;
  interface
    uses crt,
         uclavier, uerreur,
         utypcons,
         uecran, uaffiche, usaisis,
         udonnees,
         umemo;
    const k_taille_titre_max= 80;
          k_video_normale= false;
          k_video_inverse= true;
    type t_pt_champ= ^t_champ;
         t_champ= record
                    ligne_champ, colonne_champ,
                      taille_champ, decimales_champ: integer;
                    pt_descripteur_de_zone: t_pt_descripteur_de_zone;
                    position_tampon: integer;
                    pt_champ_suivant, pt_champ_precedent: t_pt_champ;
                    gabarit_champ: t_gabarit_max;
                  end;
         t_texte_titre= string[k_taille_titre_max];
         t_pt_titre= ^t_titre;
         t_titre= record
                    ligne_titre, colonne_titre: integer;
                    pt_titre_suivant, pt_titre_precedent: t_pt_titre;
                    texte_titre: t_texte_titre;
                  end;
         t_pt_page= ^t_page;
         t_page= record
                   numero_page: word;
                   pt_titre_page: t_pt_titre;
                   pt_champ_debut, pt_champ_fin: t_pt_champ;
                   pt_titre_debut, pt_titre_fin: t_pt_titre;
                   pt_page_suivante, pt_page_precedente: t_pt_page;
                 end;
         t_groupe_champs= record
                            pt_titre: t_pt_titre;
                            pt_page_debut, pt_page_fin: t_pt_page;
                            teste_saisie_champs: boolean;
                          end;

    procedure affiche_champ(p_pt_champ: t_pt_champ; p_video_inverse: boolean);

    procedure affiche_titre(p_pt_titre: t_pt_titre);

    procedure affiche_champs_de_la_page(p_pt_page: t_pt_page);

    procedure saisis_groupe_de_champs(p_groupe_champs: t_groupe_champs;
        var pv_pt_page: t_pt_page; var pv_pt_champ: t_pt_champ;
        var pv_position_dans_champ: integer;
        p_derniere_fiche: boolean;
        p_pt_fichier_memo: t_pt_fichier_memo);

    procedure affiche_parametres_un_champ(p_pt_champ: t_pt_champ);

    procedure affiche_parametres_des_champs(p_groupe_champs: t_groupe_champs);

    procedure initialise_groupe_de_champs(var pv_groupe_champs: t_groupe_champs);

    procedure libere_groupe_de_champs(var pv_groupe_champs: t_groupe_champs);

    procedure initialise_champ(var pv_groupe_champs: t_groupe_champs;
        p_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
        p_numero_page, p_ligne, p_colonne, p_taille, p_decimales: integer;
        p_gabarit: t_gabarit_max;
        p_position_tampon: integer);

    procedure initialise_titre(var pv_groupe_champs: t_groupe_champs;
        p_numero_page, p_ligne, p_colonne: integer;
        p_texte_titre: t_texte_titre);

    procedure initialise_champ_et_titre_saisie(p_pt_fichier_donnees: t_pt_fichier_donnees;
            var pv_groupe_champs: t_groupe_champs;
            p_numero_zone, p_numero_page, p_ligne, p_colonne, p_taille, p_decimales: integer;
            p_gabarit: t_gabarit_max; p_texte_titre: t_texte_titre);

    procedure initialise_le_masque_standard(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_groupe_champs: t_groupe_champs);
  implementation

    procedure affiche_champ(p_pt_champ: t_pt_champ; p_video_inverse: boolean);
      begin
        with p_pt_champ^ do
        begin
          gotoxy(colonne_champ, ligne_champ);
          with pt_descripteur_de_zone^ do
          begin
             case type_zone of
               'C' : affiche_chaine_db(pt_valeur_zone^, taille_champ);
               'N' : affiche_chaine_db_numerique(pt_valeur_zone^, taille_champ, decimales_champ,
                        gabarit_champ);
               'L' : write(pt_valeur_zone^[0]);
               'D' : affiche_chaine_db_date(pt_valeur_zone^);
               'M' : write('M');
             end; 
           end;
          if p_video_inverse
            then inverse_champ(ligne_champ, colonne_champ, taille_champ);
        end; 
      end; 

    procedure affiche_titre(p_pt_titre: t_pt_titre);
      begin
        with p_pt_titre^ do
        begin
          gotoxy(colonne_titre, ligne_titre);
          write(texte_titre);
        end; 
      end; 

    procedure affiche_champs_de_la_page(p_pt_page: t_pt_page);
      var l_pt_champ: t_pt_champ;
          l_pt_titre: t_pt_titre;
      begin
        clrscr;
        with p_pt_page^ do
        begin
          l_pt_champ:= pt_champ_debut;
          while l_pt_champ<> nil do
          begin
            affiche_champ(l_pt_champ, k_video_inverse);
            l_pt_champ:= l_pt_champ^.pt_champ_suivant;
          end; 
          l_pt_titre:= pt_titre_debut;
          while l_pt_titre<> nil do
          begin
            affiche_titre(l_pt_titre);
            l_pt_titre:= l_pt_titre^.pt_titre_suivant;
          end; 
        end; 
      end; 

    procedure saisis_groupe_de_champs(p_groupe_champs: t_groupe_champs;
        var pv_pt_page: t_pt_page; var pv_pt_champ: t_pt_champ;
        var pv_position_dans_champ: integer;
        p_derniere_fiche: boolean;
        p_pt_fichier_memo: t_pt_fichier_memo);

      procedure teste_page_suivante;
        begin
          pv_pt_champ:= pv_pt_champ^.pt_champ_suivant;
          if pv_pt_champ= nil
            then begin
                pv_pt_page:= pv_pt_page^.pt_page_suivante;
                if pv_pt_page<> nil
                  then begin
                      pv_pt_champ:= pv_pt_page^.pt_champ_debut;
                      affiche_champs_de_la_page(pv_pt_page);
                    end; 
              end; 
        end; 

      procedure teste_page_precedente;
        begin
          pv_pt_champ:= pv_pt_champ^.pt_champ_precedent;
          if pv_pt_champ= nil
            then begin
                pv_pt_page:= pv_pt_page^.pt_page_precedente;
                if pv_pt_page<> nil
                  then begin
                      pv_pt_champ:= pv_pt_page^.pt_champ_fin;
                      affiche_champs_de_la_page(pv_pt_page);
                    end; 
              end; 
        end; 

      procedure traite_sortie_de_groupe;
        begin
          with g_parametres_saisie, p_groupe_champs do
          begin
            case caractere_sortie_de_champ of
              k_curseur_sud,
                k_page_suivante : begin
                                    pv_pt_page:= pt_page_debut;
                                    pv_pt_champ:= pv_pt_page^.pt_champ_debut;
                                  end;
              k_curseur_est,
                k_return : begin
                             pv_pt_page:= pt_page_debut;
                             pv_pt_champ:= pv_pt_page^.pt_champ_debut;
                             position_dans_champ:= 0;
                           end;
              k_curseur_nord,
                k_page_precedente : begin
                                      pv_pt_page:= pt_page_fin;
                                      pv_pt_champ:= pv_pt_page^.pt_champ_fin;
                                    end;
              k_curseur_ouest : begin
                                  pv_pt_page:= pt_page_fin;
                                  pv_pt_champ:= pv_pt_page^.pt_champ_fin;
                                  position_dans_champ:=
                                    pv_pt_champ^.taille_champ- 1;
                                end;
              k_controle_end, k_escape : ;
              else affiche_erreur('SYST: mauvais caractre sortie groupe');
            end; 
          end; 
        end; 

      begin 
        with g_parametres_saisie, p_groupe_champs do
        begin
          a_modifie_un_champ_du_groupe:= false;
          caractere_sortie_de_champ:= ' ';
          while not (caractere_sortie_de_champ in caracteres_sortie_fiche_a_fiche)
              and (pv_pt_champ<> nil) do
            with pv_pt_champ^ do
            begin
              if teste_saisie_champs
                then begin
                    gotoxy(70, 2); write('T', pt_descripteur_de_zone^.type_zone, 'T');
                  end;
              with pt_descripteur_de_zone^ do
                 case type_zone of
                   'C' : saisis_chaine_db(ligne_champ, colonne_champ, pv_position_dans_champ,
                           taille_champ, pt_valeur_zone^, gabarit_champ, 'C');
                   'N' : saisis_chaine_db_numerique(ligne_champ, colonne_champ,
                           pv_position_dans_champ,
                           taille_champ, decimales_champ,
                           taille_zone, decimales_zone,
                           pt_valeur_zone^, gabarit_champ);
                   'L' : saisis_booleen(ligne_champ, colonne_champ, pv_position_dans_champ,
                             pt_valeur_zone^[0]);
                   'D' : saisis_chaine_db_date(ligne_champ, colonne_champ, pv_position_dans_champ,
                             taille_champ, pt_valeur_zone^, gabarit_champ);
                   'M' : saisis_zone_memo(ligne_champ, colonne_champ, pt_valeur_zone^, p_pt_fichier_memo);
                   else affiche_erreur('pas ce type de champ '+ type_zone);
                 end; 
              case caractere_sortie_de_champ of
                k_curseur_est,
                  k_return :
                    if p_derniere_fiche and (caractere_sortie_de_champ= k_return)
                        and (pv_pt_champ= p_groupe_champs.pt_page_debut^.pt_champ_debut)
                        and (position_dans_champ= 0)
                      then 
                           pv_pt_champ:= nil
                      else begin
                          caractere_sortie_de_champ:= k_curseur_est;
                          teste_page_suivante;
                          pv_position_dans_champ:= 0;
                        end;
                k_curseur_sud :
                  begin
                    teste_page_suivante;
                    if pv_pt_champ<> nil
                      then
                        with pv_pt_champ^ do
                          if position_dans_champ>= taille_champ
                            then pv_position_dans_champ:= taille_champ- 1;
                  end;
                k_efface_avant_curseur,
                  k_curseur_ouest, k_mot_precedent :
                    begin
                      teste_page_precedente;
                      if pv_pt_champ<> nil
                        then 
                          pv_position_dans_champ:=
                            pv_pt_champ^.taille_champ- 1
                        else sonne;
                    end;
                k_curseur_nord:
                  begin
                    teste_page_precedente;
                    if pv_pt_champ<> nil
                      then 
                        with pv_pt_champ^ do
                          if position_dans_champ>= taille_champ
                            then pv_position_dans_champ:= taille_champ- 1;
                  end; 
                k_page_suivante :
                  begin
                    pv_pt_page:= pv_pt_page^.pt_page_suivante;
                    if pv_pt_page<> nil
                      then begin
                          pv_pt_champ:= pv_pt_page^.pt_champ_debut;
                          affiche_champs_de_la_page(pv_pt_page);
                        end
                      else 
                          pv_pt_champ:= nil;
                  end;
                k_page_precedente :
                  begin
                    pv_pt_page:= pv_pt_page^.pt_page_precedente;
                    if pv_pt_page<> nil
                      then begin
                          pv_pt_champ:= pv_pt_page^.pt_champ_fin;
                          affiche_champs_de_la_page(pv_pt_page);
                        end
                      else 
                          pv_pt_champ:= nil;
                  end;
                k_controle_end, k_escape,
                  k_page_ouest, k_page_est : ;
                else 
                  write(' ', ord(caractere_sortie_de_champ), ' ');
                  affiche_erreur('SYST: mauvaise touche de sortie');
                  affiche_touche(caractere_sortie_de_champ);
              end; 
              a_modifie_un_champ_du_groupe:=
                a_modifie_un_champ_du_groupe or a_modifie_le_champ;
          end; 
          traite_sortie_de_groupe;
        end; 
      end; 

    procedure affiche_parametres_un_champ(p_pt_champ: t_pt_champ);
      begin
        with p_pt_champ^ do
          write(pt_descripteur_de_zone^.nom_zone, pt_descripteur_de_zone^.type_zone: 3,
                ligne_champ: 7, colonne_champ: 6, taille_champ: 8, decimales_champ: 8,
                ' ', gabarit_champ);
      end; 

    procedure affiche_parametres_un_titre(p_pt_titre: t_pt_titre);
      begin
        with p_pt_titre^ do
          write(ligne_titre: 7, colonne_titre: 6, ' ', texte_titre);
      end; 

    procedure affiche_parametres_des_champs(p_groupe_champs: t_groupe_champs);
      var l_pt_page: t_pt_page;
          l_pt_champ: t_pt_champ;
          l_pt_titre: t_pt_titre;
      begin
        with p_groupe_champs do
        begin
          writeln(' page nom-zone  type ligne colonne taille dcimales gabarit');
          l_pt_page:= pt_page_debut;
          while l_pt_page<> nil do
          begin
            with l_pt_page^ do
            begin
              l_pt_champ:= pt_champ_debut;
              while l_pt_champ<> nil do
              begin
                write(numero_page: 3, ' ');
                affiche_parametres_un_champ(l_pt_champ); writeln;
                l_pt_champ:= l_pt_champ^.pt_champ_suivant;
              end; 
            end; 
            l_pt_page:= l_pt_page^.pt_page_suivante;
          end; 
          writeln(' page ligne colonne titre');
          l_pt_page:= pt_page_debut;
          while l_pt_page<> nil do
          begin
            with l_pt_page^ do
            begin
              l_pt_titre:= pt_titre_debut;
              while l_pt_titre<> nil do
              begin
                write(numero_page: 3, ' ');
                affiche_parametres_un_titre(l_pt_titre); writeln;
                l_pt_titre:= l_pt_titre^.pt_titre_suivant;
              end; 
            end; 
            l_pt_page:= l_pt_page^.pt_page_suivante;
          end; 
        end; 
      end; 

    procedure initialise_groupe_de_champs(var pv_groupe_champs: t_groupe_champs);
      begin
        pv_groupe_champs.pt_page_debut:= nil;
        pv_groupe_champs.pt_page_fin:= nil;
      end; 

    procedure cree_page(var pv_groupe_champs: t_groupe_champs; p_numero_page: word);
      var l_pt_page: t_pt_page;
      begin
        new(l_pt_page);
        with l_pt_page^ do
        begin
          pt_champ_debut:= nil; pt_champ_fin:= nil;
          pt_titre_debut:= nil; pt_titre_fin:= nil;
          pt_page_suivante:= nil;
          numero_page:= p_numero_page;
        end; 
        with pv_groupe_champs do
        begin
          if pt_page_debut= nil
            then begin
                pt_page_debut:= l_pt_page;
                l_pt_page^.pt_page_precedente:= nil;
              end
            else begin
                pt_page_fin^.pt_page_suivante:= l_pt_page;
                l_pt_page^.pt_page_precedente:= pt_page_fin;
              end;
          pt_page_fin:= l_pt_page;
        end; 
      end; 

    procedure initialise_champ(var pv_groupe_champs: t_groupe_champs;
        p_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
        p_numero_page, p_ligne, p_colonne, p_taille, p_decimales: integer;
        p_gabarit: t_gabarit_max;
        p_position_tampon: integer);
      var l_pt_champ: t_pt_champ;

      procedure ajoute_champ(p_pt_page: t_pt_page; p_pt_champ: t_pt_champ);
        begin
          with p_pt_page^ do
          begin
            if pt_champ_debut= nil
              then begin
                  pt_champ_debut:= p_pt_champ;
                  p_pt_champ^.pt_champ_precedent:= nil;
                end
              else begin
                  pt_champ_fin^.pt_champ_suivant:= p_pt_champ;
                  p_pt_champ^.pt_champ_precedent:= pt_champ_fin;
                end;
            pt_champ_fin:= p_pt_champ;
          end; 
        end; 

      begin 
        getmem(l_pt_champ, sizeof(t_champ)- k_taille_gabarit_max+ length(p_gabarit));
        with l_pt_champ^ do
        begin
          pt_descripteur_de_zone:= p_pt_descripteur_de_zone;
          ligne_champ:= p_ligne; colonne_champ:= p_colonne;
          taille_champ:= p_taille;
          decimales_champ:= p_decimales;
          gabarit_champ:= p_gabarit;
          pt_champ_suivant:= nil;
          position_tampon:= p_position_tampon;
          with pv_groupe_champs do
          begin
            if pt_page_debut= nil
              then begin
                  cree_page(pv_groupe_champs, p_numero_page);
                  teste_saisie_champs:= false;
                end
              else
                if p_numero_page> pt_page_fin^.numero_page
                  then cree_page(pv_groupe_champs, p_numero_page);
            ajoute_champ(pv_groupe_champs.pt_page_fin, l_pt_champ);
          end; 
        end; 
      end; 

    procedure initialise_titre(var pv_groupe_champs: t_groupe_champs;
        p_numero_page, p_ligne, p_colonne: integer;
        p_texte_titre: t_texte_titre);
      var l_pt_titre: t_pt_titre;

      procedure ajoute_titre(p_pt_page: t_pt_page; p_pt_titre: t_pt_titre);
        begin
          with p_pt_page^ do
          begin
            if pt_titre_debut= nil
              then begin
                  pt_titre_debut:= p_pt_titre;
                  p_pt_titre^.pt_titre_precedent:= nil;
                end
              else begin
                  pt_titre_fin^.pt_titre_suivant:= p_pt_titre;
                  p_pt_titre^.pt_titre_precedent:= pt_titre_fin;
                end;
            pt_titre_fin:= p_pt_titre;
          end; 
        end; 

      begin 
        getmem(l_pt_titre, sizeof(t_titre)- k_taille_titre_max+ length(p_texte_titre));
        with l_pt_titre^do
        begin
          ligne_titre:= p_ligne; colonne_titre:= p_colonne;
          texte_titre:= p_texte_titre;
          pt_titre_suivant:= nil;
          with pv_groupe_champs do
          begin
            if pt_page_debut= nil
              then cree_page(pv_groupe_champs, p_numero_page)
              else
                if p_numero_page> pt_page_fin^.numero_page
                  then cree_page(pv_groupe_champs, p_numero_page);
            ajoute_titre(pv_groupe_champs.pt_page_fin, l_pt_titre);
          end; 
        end; 
      end; 

    procedure initialise_champ_et_titre_saisie(p_pt_fichier_donnees: t_pt_fichier_donnees;
            var pv_groupe_champs: t_groupe_champs;
            p_numero_zone, p_numero_page, p_ligne, p_colonne, p_taille, p_decimales: integer;
            p_gabarit: t_gabarit_max; p_texte_titre: t_texte_titre);
      begin
        initialise_champ(pv_groupe_champs,
            f_pt_descripteur_zone(p_pt_fichier_donnees, p_numero_zone),
            p_numero_page, p_ligne, p_colonne, p_taille, p_decimales, p_gabarit, 0);
        initialise_titre(pv_groupe_champs, p_numero_page, p_ligne, 1, p_texte_titre);
      end; 

    procedure initialise_le_masque_standard(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_groupe_champs: t_groupe_champs);
      var l_numero_zone: integer;
          l_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
          l_date: t_date;
      begin
        initialise_groupe_de_champs(pv_groupe_champs);
        for l_numero_zone:= 0 to f_nombre_zones(p_pt_fichier_donnees)- 1 do
        begin
          l_pt_descripteur_de_zone:=
              f_pt_descripteur_zone(p_pt_fichier_donnees, l_numero_zone);
          with l_pt_descripteur_de_zone^ do
          begin
            case type_zone of
              'C' : initialise_champ(pv_groupe_champs,
                      l_pt_descripteur_de_zone,
                      0, l_numero_zone+ 1, 12, taille_zone, 0,
                       '', 0);
              'N' : initialise_champ(pv_groupe_champs,
                      l_pt_descripteur_de_zone,
                      0, l_numero_zone+ 1, 12, taille_zone, decimales_zone,
                      '', 0);
              'L' : initialise_champ(pv_groupe_champs,
                      l_pt_descripteur_de_zone,
                      0, l_numero_zone+ 1, 12, 1, 0,
                      '', 0);
              'D' : initialise_champ(pv_groupe_champs,
                      l_pt_descripteur_de_zone,
                      0, l_numero_zone+ 1, 12, 8, 0,
                      '', 0);
              'M' : initialise_champ(pv_groupe_champs,
                      l_pt_descripteur_de_zone,
                      0, l_numero_zone+ 1, 12, 1, 0,
                      '', 0);
            end; 
            initialise_titre(pv_groupe_champs, 0, l_numero_zone+ 1, 1,
                        nom_zone);
          end; 
        end; 
      end; 

    procedure libere_groupe_de_champs(var pv_groupe_champs: t_groupe_champs);
      var l_pt_page, l_pt_page_a_liberer: t_pt_page;
          l_pt_champ, l_pt_champ_a_liberer: t_pt_champ;
          l_pt_titre, l_pt_titre_a_liberer: t_pt_titre;
      begin
        with pv_groupe_champs do
        begin
          l_pt_page:= pt_page_debut;
          while l_pt_page<> nil do
          begin
            with l_pt_page^ do
            begin
              l_pt_champ:= pt_champ_debut;
              while l_pt_champ<> nil do
              begin
                l_pt_champ_a_liberer:= l_pt_champ;
                l_pt_champ:= l_pt_champ^.pt_champ_suivant;
                with l_pt_champ_a_liberer^ do
                  freemem(l_pt_champ_a_liberer,
                      sizeof(t_champ)- k_taille_gabarit_max+ length(gabarit_champ));
              end; 
            end; 
            l_pt_page:= l_pt_page^.pt_page_suivante;
          end; 
          l_pt_page:= pt_page_debut;
          while l_pt_page<> nil do
          begin
            with l_pt_page^ do
            begin
              l_pt_titre:= pt_titre_debut;
              while l_pt_titre<> nil do
              begin
                l_pt_titre_a_liberer:= l_pt_titre;
                l_pt_titre:= l_pt_titre^.pt_titre_suivant;
                with l_pt_titre_a_liberer^ do
                  freemem(l_pt_titre_a_liberer,
                      sizeof(t_titre)- k_taille_titre_max+ length(texte_titre));
              end; 
            end; 
            l_pt_page_a_liberer:= l_pt_page;
            l_pt_page:= l_pt_page^.pt_page_suivante;
            dispose(l_pt_page_a_liberer);
          end; 
        end; 
      end; 

  begin 
  end. 











