(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit udonnees;
  interface
    uses dos, uerreur, utypcons, uaffiche;
    const k_taille_en_tete_fixe= 32;
          k_taille_descripteur_zone= 32;
          k_taille_nom_zone_max= 10;
          k_descripteur_max= 127;
          k_taille_fiche_max= 3999;
    type t_nom_zone= array[0..k_taille_nom_zone_max] of char;
         t_pt_valeur_zone= ^t_chaine_db_max;
         t_descripteur_de_zone= record
                                  case integer of
                                    1 : (signature_fin: byte);
                                    2 : (nom_zone: t_nom_zone;
                                         type_zone: char;
                                         pt_valeur_zone: t_pt_valeur_zone;
                                         taille_zone: byte;
                                         case char of
                                           'N' : (decimales_zone: byte;
                                                  valeur_numerique: real);
                                           ' ' : (remplissage: array[17..31] of byte));
                                end;
         t_pt_descripteur_de_zone= ^t_descripteur_de_zone;
         t_en_tete_donnees= record
                              signature: byte;
                              date_derniere_mise_a_jour: record
                                                           annee, mois, jour: byte;
                                                         end;
                              nombre_fiches: longint;
                              taille_en_tete: word;
                              taille_fiche: word;
                              remplissage: array[12..31] of byte;
                              tableau_descripteurs_zones: array[0..127]
                                of t_descripteur_de_zone;
                            end;
         t_fiche_courante_max= array[0..k_taille_fiche_max] of char;
         t_pt_fiche_courante= ^t_fiche_courante_max;
         t_fichier_donnees= record
                              fichier: file;
                              nom_chemin: t_string_80;
                              nom_base: string[8]; nom_extension: string[3];
                              numero_fiche_courante: longint;
                              position_fiche_courante: longint;
                              a_modifie_fiche, a_modifie_fichier: boolean;
                              pt_fiche_courante: t_pt_fiche_courante;
                              nombre_zones: integer;
                              en_tete: t_en_tete_donnees;
                            end;
         t_pt_fichier_donnees= ^t_fichier_donnees;

    procedure affiche_en_tete_fichier_donnees(p_pt_fichier_donnees: t_pt_fichier_donnees);

    procedure ajoute_definition_de_zone(p_pt_fichier_donnees: t_pt_fichier_donnees;
        p_nom_zone: t_string_80; p_type_zone: char;
        p_taille_zone, p_decimales_zones: integer);

    procedure cree_fichier_donnees(var pv_pt_fichier_donnees: t_pt_fichier_donnees;
        p_nom_fichier: t_string_80);

    procedure ouvre_fichier_donnees(var pv_pt_fichier_donnees: t_pt_fichier_donnees;
        p_nom_fichier: t_string_80);

    function f_fin_fichier_donnees(p_pt_fichier_donnees: t_pt_fichier_donnees): boolean;

    function f_nombre_fiches(p_pt_fichier_donnees: t_pt_fichier_donnees): longint;

    procedure ferme_fichier_donnees(p_pt_fichier_donnees: t_pt_fichier_donnees);

    function f_numero_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees): longint;

    procedure positionne_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees;
        p_numero_fiche: longint);

    procedure lis_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees);

    procedure ecris_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees);

    procedure initialise_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees);

    procedure efface_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees);

    function f_nombre_zones(p_pt_fichier_donnees: t_pt_fichier_donnees): word;

    procedure affiche_zone(p_pt_fichier_donnees: t_pt_fichier_donnees;
        p_numero_zone: integer);

    function f_pt_descripteur_zone(p_pt_fichier_donnees: t_pt_fichier_donnees;
        p_numero_zone: integer): t_pt_descripteur_de_zone;
  implementation

    procedure affiche_en_tete_fichier_donnees(p_pt_fichier_donnees: t_pt_fichier_donnees);

      procedure affiche_les_descripteurs_de_zone;
        var l_numero_zone, l_taille: integer;
        begin
          with p_pt_fichier_donnees^ , p_pt_fichier_donnees^.en_tete do
          begin
            writeln('numro   nom      type taille dcimales');
            for l_numero_zone:= 0 to nombre_zones- 1 do
              with tableau_descripteurs_zones[l_numero_zone] do
              begin
                write(l_numero_zone: 4, '':3);
                affiche_chaine_0(nom_zone, l_taille);
                writeln('': k_taille_nom_zone_max- l_taille,
                       type_zone: 5, taille_zone: 6, decimales_zone: 8);
              end; 
          end; 
        end; 

      begin 
        with p_pt_fichier_donnees^, en_tete do
        begin
          writeln('fichier:          ', nom_chemin, '-', nom_base, '-', nom_extension);
          writeln('signature:        ', signature);
          writeln('dernire anne:   ', 1900+ date_derniere_mise_a_jour.annee);
          writeln('dernier mois:     ', date_derniere_mise_a_jour.mois);
          writeln('dernier jour:     ', date_derniere_mise_a_jour.annee);
          writeln('nombre de fiches: ', nombre_fiches);
          writeln('taille en-tte:   ', taille_en_tete);
          writeln('taille fiche:     ', taille_fiche);
          affiche_les_descripteurs_de_zone;
        end; 
      end; 

    procedure ajoute_definition_de_zone(p_pt_fichier_donnees: t_pt_fichier_donnees;
        p_nom_zone: t_string_80; p_type_zone: char;
        p_taille_zone, p_decimales_zones: integer);
      begin 
        with p_pt_fichier_donnees^, p_pt_fichier_donnees^.en_tete do
        begin
          fillchar(en_tete.tableau_descripteurs_zones[nombre_zones],
                   k_taille_descripteur_zone, 0);
          with tableau_descripteurs_zones[nombre_zones] do
          begin
            move(p_nom_zone[1], nom_zone, length(p_nom_zone));
            type_zone:= p_type_zone;
            if upcase(p_type_zone)= 'M'
              then signature:= $83;
            taille_zone:= p_taille_zone;
            decimales_zone:= p_decimales_zones;
          end; 
          tableau_descripteurs_zones[nombre_zones+ 1].signature_fin:= $0D;
          taille_fiche:= taille_fiche+ p_taille_zone;
          taille_en_tete:= taille_en_tete+ k_taille_descripteur_zone;
          nombre_zones:= nombre_zones+ 1;
        end; 
      end; 

    procedure cree_fichier_donnees(var pv_pt_fichier_donnees: t_pt_fichier_donnees;
        p_nom_fichier: t_string_80);
      begin 
        getmem(pv_pt_fichier_donnees, sizeof(t_fichier_donnees));
        fillchar(pv_pt_fichier_donnees^, sizeof(t_fichier_donnees), 0);
        with pv_pt_fichier_donnees^ do
        begin
          assign(fichier, p_nom_fichier);
          rewrite(fichier, 1);
          with en_tete do
          begin
            signature:= $03;
            date_derniere_mise_a_jour.annee:= 88;
            date_derniere_mise_a_jour.mois:= 08;
            date_derniere_mise_a_jour.jour:= 09;
            taille_en_tete:= k_taille_en_tete_fixe+ 1;
            taille_fiche:= 1;
            tableau_descripteurs_zones[0].signature_fin:= $0D;
          end; 
        end; 
      end; 

    procedure ouvre_fichier_donnees(var pv_pt_fichier_donnees: t_pt_fichier_donnees;
        p_nom_fichier: t_string_80);
      var l_en_tete: t_en_tete_donnees;
          l_fichier: file;

      procedure calcule_adresses_valeurs_des_zones;
        type t_adresse= record
                            decalage, segment: integer;
                          end;
        var l_numero_zone: integer;
            l_decalage: integer;
        begin 
          l_decalage:= 1;
          with pv_pt_fichier_donnees^ do
            for l_numero_zone:= 0 to nombre_zones- 1 do
              with en_tete.tableau_descripteurs_zones[l_numero_zone] do
              begin
                pt_valeur_zone:= t_pt_valeur_zone(pt_fiche_courante);
                t_adresse(pt_valeur_zone).decalage:=
                  t_adresse(pt_valeur_zone).decalage+ l_decalage;
                l_decalage:= l_decalage+ taille_zone;
              end; 
        end; 

      begin 
        assign(l_fichier, p_nom_fichier);
        reset(l_fichier, 1);
        blockread(l_fichier, l_en_tete, k_taille_en_tete_fixe);
        close(l_fichier);
        getmem(pv_pt_fichier_donnees,
               sizeof(t_fichier_donnees)- sizeof(t_en_tete_donnees)+ l_en_tete.taille_en_tete);
        with pv_pt_fichier_donnees^ do
        begin
          getmem(pt_fiche_courante, l_en_tete.taille_fiche);
          assign(fichier, p_nom_fichier);
          reset(fichier, 1);
          blockread(fichier, en_tete, l_en_tete.taille_en_tete);
          nombre_zones:= (en_tete.taille_en_tete- 1) div k_taille_descripteur_zone- 1;
          calcule_adresses_valeurs_des_zones;
          numero_fiche_courante:= 0;
          position_fiche_courante:= en_tete.taille_en_tete;
          nom_chemin:= p_nom_fichier; nom_base:= ''; nom_extension:= '';
          a_modifie_fiche:= false; a_modifie_fichier:= true;
        end; 
      end; 

    function f_fin_fichier_donnees(p_pt_fichier_donnees: t_pt_fichier_donnees): boolean;
      begin
        f_fin_fichier_donnees:= eof(p_pt_fichier_donnees^.fichier);
      end; 

    procedure ferme_fichier_donnees(p_pt_fichier_donnees: t_pt_fichier_donnees);
      begin
        with p_pt_fichier_donnees^ do
        begin
          seek(fichier, 0);
          blockwrite(fichier, en_tete, en_tete.taille_en_tete);
          close(fichier);
          if pt_fiche_courante= nil
            then freemem(p_pt_fichier_donnees, sizeof(t_fichier_donnees))
            else begin
                if p_pt_fichier_donnees= nil
                  then affiche_erreur('pt_fichier_donnees NIL')
                  else begin
                      freemem(pt_fiche_courante, en_tete.taille_fiche);
                      freemem(p_pt_fichier_donnees,
                          sizeof(t_fichier_donnees)- sizeof(t_en_tete_donnees)
                          + en_tete.taille_en_tete);
                    end;
             end;
        end; 
      end; 

    function f_nombre_fiches(p_pt_fichier_donnees: t_pt_fichier_donnees): longint;
      begin
        f_nombre_fiches:= p_pt_fichier_donnees^.en_tete.nombre_fiches;
      end; 

    function f_numero_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees): longint;
      begin
        f_numero_fiche_courante:= p_pt_fichier_donnees^.numero_fiche_courante;
      end; 

    procedure positionne_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees;
        p_numero_fiche: longint);
      begin
        with p_pt_fichier_donnees^, p_pt_fichier_donnees^.en_tete do
        begin
          position_fiche_courante:= taille_en_tete+ p_numero_fiche* taille_fiche;
          numero_fiche_courante:= p_numero_fiche;
          seek(fichier, position_fiche_courante);
        end; 
      end; 

    procedure lis_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees);
      begin
        with p_pt_fichier_donnees^, p_pt_fichier_donnees^.en_tete do
        begin
          blockread(fichier, pt_fiche_courante^, taille_fiche);
          a_modifie_fiche:= false;
          numero_fiche_courante:= numero_fiche_courante+ 1;
          position_fiche_courante:= position_fiche_courante+ taille_fiche;
        end; 
      end; 

    procedure ecris_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees);
      begin
        with p_pt_fichier_donnees^, p_pt_fichier_donnees^.en_tete do
        begin
          blockwrite(fichier, pt_fiche_courante^, taille_fiche);
          a_modifie_fiche:= false; a_modifie_fichier:= true;
          numero_fiche_courante:= numero_fiche_courante+ 1;
          position_fiche_courante:= position_fiche_courante+ taille_fiche;
          if numero_fiche_courante> nombre_fiches
            then nombre_fiches:= nombre_fiches+ 1;
        end; 
      end; 

    procedure initialise_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees);
      begin
        with p_pt_fichier_donnees^ do
        begin
          fillchar(pt_fiche_courante^, en_tete.taille_fiche, ' ');
          a_modifie_fiche:= true;
        end;
      end; 

    procedure efface_fiche_courante(p_pt_fichier_donnees: t_pt_fichier_donnees);
      begin
        with p_pt_fichier_donnees^ do
        begin
          pt_fiche_courante^[0]:= '*'; a_modifie_fiche:= true;
          ecris_fiche_courante(p_pt_fichier_donnees);
          positionne_fiche_courante(p_pt_fichier_donnees, numero_fiche_courante- 1);
        end; 
      end; 

    function f_nombre_zones(p_pt_fichier_donnees: t_pt_fichier_donnees): word;
      begin
        f_nombre_zones:= p_pt_fichier_donnees^.nombre_zones;
      end; 

    procedure affiche_zone(p_pt_fichier_donnees: t_pt_fichier_donnees;
        p_numero_zone: integer);
      var l_gabarit: t_gabarit_max;
      begin
        with p_pt_fichier_donnees^.en_tete.tableau_descripteurs_zones[p_numero_zone] do
          case type_zone of
            'C' : affiche_chaine_db(pt_valeur_zone^, taille_zone);
            'N' : begin
                    l_gabarit:= '';
                    affiche_chaine_db_numerique(pt_valeur_zone^, taille_zone, decimales_zone,
                        l_gabarit);
                  end;
            'L' : write(pt_valeur_zone^[0]);
            'D' : affiche_chaine_db_date(pt_valeur_zone^);
            'M' : affiche_chaine_db(pt_valeur_zone^, 10);
          end; 
      end; 

    function f_pt_descripteur_zone(p_pt_fichier_donnees: t_pt_fichier_donnees;
        p_numero_zone: integer): t_pt_descripteur_de_zone;
      begin
        f_pt_descripteur_zone:=
          addr(p_pt_fichier_donnees^.en_tete.tableau_descripteurs_zones[p_numero_zone]);
      end; 

  begin 
  end. 















