(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit uecran;
  interface
    uses dos;
    const 
          k_segment_ecran= $B800;
          k_deroule_vers_le_nord= 6;
          k_deroule_vers_le_sud= 7;
    type t_ecran= array[1..25, 1..80] of record
                                           caractere: char;
                                           attribut: byte;
                                         end;

    procedure inverse_champ(p_ligne, p_colonne, p_taille: integer);

    procedure met_champ_en_video_normale(p_ligne, p_colonne, p_taille: integer);

    procedure deroule_ecran(p_x1, p_y1, p_x2, p_y2, p_direction: byte);

    procedure sauve_ecran(var pv_ecran: t_ecran);

    procedure restaure_ecran(var pv_ecran: t_ecran);
    var g_ecran: t_ecran absolute k_segment_ecran:$0000;
  implementation

    procedure inverse_champ(p_ligne, p_colonne, p_taille: integer);
      var l_indice: integer;
      begin
        for l_indice:= 0 to p_taille- 1 do
          g_ecran[p_ligne, p_colonne+ l_indice].attribut:= $78;
      end; 

    procedure met_champ_en_video_normale(p_ligne, p_colonne, p_taille: integer);
      var l_indice: integer;
      begin
        for l_indice:= 0 to p_taille- 1 do
          g_ecran[p_ligne, p_colonne+ l_indice].attribut:= $07;
      end; 

    procedure deroule_ecran(p_x1, p_y1, p_x2, p_y2, p_direction: byte);
      var l_registres_8086: registers;
      begin
        with l_registres_8086 do
        begin
          al:= 1; ah:= p_direction;
          ch:= p_y1- 1; cl:= p_x1- 1;
          dh:= p_y2- 1; dl:= p_x2- 1;
          bh:= $07;
          intr($10, l_registres_8086);
        end; 
      end; 

    procedure sauve_ecran(var pv_ecran: t_ecran);
      begin
        pv_ecran:= g_ecran;
      end; 

    procedure restaure_ecran(var pv_ecran: t_ecran);
      begin
        g_ecran:= pv_ecran;
      end; 

  begin 
  end. 




