(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

unit uediteur;
  interface
    uses crt,
         uhex,
         uclavier, uerreur,
         utypcons;
    const k_texte_max= 8096;
    type t_tampon_texte= array[0..k_texte_max] of char;
         t_texte= record
                    nom_chemin: t_string_80;
                    nom_texte: string[8]; nom_extension: string[3];
                    fin_texte: integer;
                    texte_max: integer;
                    indice_courant: integer;
                    distance_fin_ligne: integer;
                    indice_debut_page, indice_fin_page: integer;
                    colonne_debut_fenetre, ligne_debut_fenetre,
                      largeur_fenetre, hauteur_fenetre: integer;
                    colonne_debut_texte: word;
                    ligne_relative_curseur, colonne_relative_curseur: integer;
                    a_modifie_texte: boolean;
                    teste_editeur: boolean;
                    pt_tampon_texte: ^t_tampon_texte;
                  end;
         t_pt_texte= ^t_texte;

    procedure alloue_texte(var pv_pt_texte: t_pt_texte; p_nom_texte: t_string_80;
        p_texte_max: integer);

    procedure initialise_texte(var pv_pt_texte: t_pt_texte);

    procedure charge_texte(var pv_pt_texte: t_pt_texte;
        p_nom_texte: t_string_80; p_texte_max: integer);

    procedure dimensionne_fenetre(var pv_pt_texte: t_pt_texte;
         p_colonne_debut_fenetre, p_ligne_debut_fenetre,
         p_largeur_fenetre, p_hauteur_fenetre: integer);

    procedure edite_texte(var pv_pt_texte: t_pt_texte;
         var pv_nom_texte: t_string_80);

    procedure libere_texte(var pv_pt_texte: t_pt_texte);
  implementation

    procedure dimensionne_fenetre(var pv_pt_texte: t_pt_texte;
         p_colonne_debut_fenetre, p_ligne_debut_fenetre,
         p_largeur_fenetre, p_hauteur_fenetre: integer);
      begin
        with pv_pt_texte^ do
        begin
          colonne_debut_fenetre:= p_colonne_debut_fenetre;
          ligne_debut_fenetre:= p_ligne_debut_fenetre;
          largeur_fenetre:= p_largeur_fenetre; hauteur_fenetre:= p_hauteur_fenetre;
        end; 
      end; 

    procedure alloue_texte(var pv_pt_texte: t_pt_texte;
              p_nom_texte: t_string_80; p_texte_max: integer);
      begin
        getmem(pv_pt_texte, sizeof(t_texte));
        with pv_pt_texte^ do
        begin
          fin_texte:= 0;
          texte_max:= p_texte_max;
          nom_chemin:= p_nom_texte; nom_texte:= ''; nom_extension:= '';
          getmem(pt_tampon_texte, texte_max);
          fillchar(pt_tampon_texte^, texte_max, 0);
          dimensionne_fenetre(pv_pt_texte, 10, 7, 20, 5);
          teste_editeur:= false;
        end; 
      end; 

    procedure libere_texte(var pv_pt_texte: t_pt_texte);
      begin
        with pv_pt_texte^ do
          freemem(pt_tampon_texte, texte_max);
        freemem(pv_pt_texte, sizeof(t_texte));
      end; 

    procedure charge_texte(var pv_pt_texte: t_pt_texte;
          p_nom_texte: t_string_80; p_texte_max: integer);
      var l_texte: file;
      begin
        writeln('charge ', p_nom_texte);
        assign(l_texte, p_nom_texte);
        reset(l_texte, 1);
        alloue_texte(pv_pt_texte, p_nom_texte, p_texte_max);
        with pv_pt_texte^ do
        begin
          fin_texte:= filesize(l_texte);
          if fin_texte> p_texte_max
            then begin
                writeln('trop gros. Ne charge que ', p_texte_max);
                readln;
                fin_texte:= p_texte_max;
              end;
          blockread(l_texte, pt_tampon_texte^, fin_texte);
          if pt_tampon_texte^[fin_texte- 1]= #26
            then fin_texte:= fin_texte- 1;
          if (pt_tampon_texte^[fin_texte- 1]<> #10)
              or (pt_tampon_texte^[fin_texte- 2]<> #13)
            then begin
                write('AJ'); stoppe;
                if pt_tampon_texte^[fin_texte- 1]<> k_RETURN
                  then begin
                      pt_tampon_texte^[fin_texte]:= k_return;
                      fin_texte:= fin_texte+ 1;
                    end;
                pt_tampon_texte^[fin_texte]:= #10;
                fin_texte:= fin_texte+ 1;
              end;
        end; 
        close(l_texte);
      end; 

    procedure edite_texte(var pv_pt_texte: t_pt_texte;
         var pv_nom_texte: t_string_80);
      const k_debut_texte= #04; 
            k_controle_q= #17; 
            k_controle_read= #18; 
            k_controle_write= #23; 
            k_controle_v= #22; 
            k_controle_y= #25; 
            k_controle_t= #20;
            k_texte_max= 512;
            kt_colonne_fin_fenetre: char= '-';
      var l_touche: char;
          l_message_erreur_est_affiche: boolean;

      procedure dumpe_texte(p_ligne, p_indice, p_quantite: integer);
        var l_indice: integer;
        begin
          with pv_pt_texte^ do
          begin
            gotoxy(5, 19); clreol;
            for l_indice:= 0 to 23 do
              write(f_octet_hexadecimal(l_indice), ' ');
            gotoxy(1, p_ligne);
            write(f_octet_hexadecimal(p_indice), ': ');
            for l_indice:= p_indice to p_indice+ p_quantite- 1 do
              write(f_octet_hexadecimal(ord(pt_tampon_texte^[l_indice])), ' ');
          end; 
        end; 

      procedure affiche_tampon;
        var l_indice: integer;
        begin
          with pv_pt_texte^ do
          begin
            gotoxy(1, 19); clreol;
            for l_indice:= 0 to 33 do
              write(f_octet_hexadecimal(l_indice));
            gotoxy(1, 20);
            for l_indice:= 0 to 33 do
              write(f_octet_hexadecimal(ord(pt_tampon_texte^[l_indice])));
            gotoxy(1, 21);
            for l_indice:= 0 to 33 do
              case pt_tampon_texte^[l_indice] of
                #13 : write(' ', chr(27)); 
                #10 : write(' ', chr(25)); 
                ' '..'z' : write(' ', pt_tampon_texte^[l_indice]);
                else write(' .');
              end; 
            gotoxy(1, 22);
            if indice_courant* 2< 78
              then write('^': 2+ indice_courant* 2);
            if ((indice_courant+ distance_fin_ligne)* 2< 78) and (distance_fin_ligne> 0)
              then write('|': distance_fin_ligne* 2)
              else write('<');
            clreol;
            gotoxy(1, 23);
            if (indice_debut_page* 2< 78) and (indice_fin_page* 2< 78)
              then write('d': 2+ indice_debut_page* 2,
                  'f': (indice_fin_page- indice_debut_page)* 2);
            if fin_texte= indice_fin_page
              then write('=')
              else
                if indice_fin_page* 2< 78
                  then write('!': (fin_texte- indice_fin_page)* 2);
            clreol;
          end; 
        end; 

      procedure affiche_commande(p_colonne: integer; p_commande: string);
        begin
          if pv_pt_texte^.teste_editeur
            then begin
                gotoxy(p_colonne, 1);
                write(p_commande, '     ');
              end;
        end; 

      procedure affiche_invite(p_commande: char);
        begin
          gotoxy(1, 1); clreol;
          case p_commande of
            'g' : write('<touche>, <curseur>, <CTRL-Q>');
            'c' : write('nom <C:\STOCK\QUESTION.PRG> ? ');
            's' : write('sauve sous le nom de ', pv_nom_texte, ' Oui, Non ? ');
          end;
        end; 

      procedure affiche_position;
        begin
          gotoxy(32, 1);
          with pv_pt_texte^ do
          begin
            if teste_editeur
              then begin
                  gotoxy(5, 2); clreol;
                  write('lig rel cur: ', f_entier_hexadecimal(ligne_relative_curseur): 5,
                        ', col rel cur: ', f_entier_hexadecimal(colonne_relative_curseur): 5,
                        ', col deb tex: ', f_entier_hexadecimal(colonne_debut_texte): 5);
                  gotoxy(5, 3); clreol;
                  write('ind cur      ', f_entier_hexadecimal(indice_courant): 5,
                        ', d fin lig:   ', f_entier_hexadecimal(distance_fin_ligne): 5,
                        ', fin pg:      ', f_entier_hexadecimal(fin_texte): 5);
                  gotoxy(5, 4); clreol;
                  write('ind deb pag: ', f_entier_hexadecimal(indice_debut_page): 5,
                        ', ind_fin_pag: ', f_entier_hexadecimal(indice_fin_page): 5);
                end
              else write('L= ', ligne_relative_curseur: 2, ', C= ', colonne_relative_curseur: 3,
                         ', F= ', distance_fin_ligne: 3,
                         indice_courant: 5, fin_texte: 5);
          end; 
        end; 

      procedure affiche_message_et_sonne(p_message: string);
        begin
          gotoxy(1, 1); clreol; write(p_message, '<<< '); sonne;
          l_message_erreur_est_affiche:= true;
        end; 

      procedure affiche_page;
        var l_indice, l_ligne, l_colonne, l_colonne_1, l_indice_ligne: integer;
        begin
          with pv_pt_texte^ do
          begin
            gotoxy(colonne_debut_fenetre+ 1, ligne_debut_fenetre);
            if teste_editeur
              then begin
                  for l_colonne:= 0 to largeur_fenetre- 1 do
                    write(l_colonne mod 10);
                  write(' ', f_entier_hexadecimal(indice_debut_page): 6,
                        f_entier_hexadecimal(indice_fin_page): 6);
                end;
            l_indice:= indice_debut_page; l_ligne:= 0;
            while (l_indice<= fin_texte- 3) and (l_ligne<= hauteur_fenetre- 1) do
            begin
              if teste_editeur
                then begin
                    gotoxy(colonne_debut_fenetre+ 1- 3, ligne_debut_fenetre+ l_ligne+ 1);
                    write(l_ligne: 2, ' ');
                  end;
              l_indice_ligne:= 0;
              while (l_indice<= fin_texte- 3) and (l_indice_ligne<  colonne_debut_texte)
                  and (pt_tampon_texte^[l_indice]<> k_return) do
              begin
                l_indice:= l_indice+ 1; l_indice_ligne:= l_indice_ligne+ 1;
              end; 
              l_colonne:= 0;
              gotoxy(colonne_debut_fenetre+ 1, ligne_debut_fenetre+ l_ligne+ 1);
              while (l_indice<= fin_texte- 3) and (l_colonne<= largeur_fenetre- 1)
                  and (pt_tampon_texte^[l_indice]<> k_return) do
              begin
                write(pt_tampon_texte^[l_indice]);
                l_indice:= l_indice+ 1; l_colonne:= l_colonne+ 1;
              end; 
              for l_colonne_1:= l_colonne+ 1 to largeur_fenetre do
                if teste_editeur
                  then write('~')
                  else write(' ');
              if teste_editeur
                then write(kt_colonne_fin_fenetre);
              while pt_tampon_texte^[l_indice]<> k_return do
                l_indice:= l_indice+ 1;
              l_indice:= l_indice+ 2;
              l_ligne:= l_ligne+ 1;
            end; 
            indice_fin_page:= l_indice;
            for l_ligne:= l_ligne to hauteur_fenetre- 1 do
            begin
              gotoxy(colonne_debut_fenetre+ 1, ligne_debut_fenetre+ l_ligne+ 1);
              for l_colonne:= 0 to largeur_fenetre- 1 do
                if teste_editeur
                  then write('.')
                  else write(' ');
            end;
            if teste_editeur
              then begin
                  kt_colonne_fin_fenetre:= succ(kt_colonne_fin_fenetre);
                  gotoxy(60, ligne_debut_fenetre);
                  write(f_entier_hexadecimal(indice_fin_page): 6, ' >');
                  for l_colonne:= indice_fin_page- 1 to indice_fin_page+ 1 do
                    write(f_octet_hexadecimal(ord(pt_tampon_texte^[l_colonne])): 3);
                  write('< ');
                end;
          end; 
        end; 

      procedure positionne_curseur_dans_la_ligne;
        var l_taille_ligne: integer;
        begin
          with pv_pt_texte^ do
          begin
            l_taille_ligne:= 0;
            while (pt_tampon_texte^[indice_courant+ l_taille_ligne]<> k_return)
                and (indice_courant+ l_taille_ligne<= fin_texte- 3) do
              l_taille_ligne:= l_taille_ligne+ 1;
            distance_fin_ligne:= l_taille_ligne- (colonne_debut_texte+ colonne_relative_curseur);
            if distance_fin_ligne>= 0
              then begin
                  indice_courant:= indice_courant+ colonne_debut_texte+ colonne_relative_curseur;
                end
              else begin
                  indice_courant:= indice_courant+ l_taille_ligne;
                end;
          end; 
        end; 

      procedure positionne_curseur_dans_la_page;
        var l_ligne, l_colonne: integer;
            l_indice_debut_ligne_fin: integer;
        begin
          affiche_commande(60, 'pos');
          with pv_pt_texte^ do
          begin
            indice_courant:= indice_debut_page;
            l_ligne:= 0;
            while (indice_courant<= fin_texte- 3) and (l_ligne< ligne_relative_curseur) do
            begin
              while (indice_courant<= fin_texte- 3)
                  and (pt_tampon_texte^[indice_courant]<> k_return) do
              begin
                indice_courant:= indice_courant+ 1;
              end; 
              indice_courant:= indice_courant+ 2;
              if indice_courant= fin_texte
                then ligne_relative_curseur:= l_ligne
                else l_indice_debut_ligne_fin:= indice_courant;
              l_ligne:= l_ligne+ 1;
            end; 
            if indice_courant= fin_texte
              then indice_courant:= l_indice_debut_ligne_fin;
            positionne_curseur_dans_la_ligne;
          end; 
        end; 

      procedure saute_debut_texte;
        begin
          with pv_pt_texte^ do
          begin
            indice_courant:= 0;
            ligne_relative_curseur:= 0; colonne_relative_curseur:= 0;
            distance_fin_ligne:= 0;
            while (pt_tampon_texte^[indice_courant+ distance_fin_ligne]<> k_return) do
              distance_fin_ligne:= distance_fin_ligne+ 1;
          end; 
        end; 

      procedure avance_d_une_page_par_PgDn;
        begin
          with pv_pt_texte^ do
          begin
            if indice_fin_page= fin_texte
              then affiche_message_et_sonne('peut pas avancer aprs dernire ligne. Insrer RET')
              else begin
                  indice_debut_page:= indice_fin_page;
                  affiche_page;
                  positionne_curseur_dans_la_page;
                end;
          end; 
        end; 

      procedure recule_d_une_page_par_PgUp;
        var l_indice, l_ligne: integer;
        begin
          with pv_pt_texte^ do
          begin
            indice_fin_page:= indice_debut_page;
            l_indice:= indice_fin_page;
            l_ligne:= hauteur_fenetre;
            while (l_ligne>= 0) and (l_indice> 0) do
            begin
              l_indice:= l_indice- 1;
              if pt_tampon_texte^[l_indice]= k_return
                then l_ligne:= l_ligne- 1;
            end; 
            if l_indice= 0
              then indice_debut_page:= l_indice
              else indice_debut_page:= l_indice+ 2;
            affiche_page;
            positionne_curseur_dans_la_page;
          end; 
        end; 

      procedure recule_au_debut_de_la_ligne;
        begin
          with pv_pt_texte^ do
          begin
            if (indice_debut_page= 0) and (ligne_relative_curseur= 0)
              then 
                  indice_courant:= 0
              else begin
                  while pt_tampon_texte^[indice_courant- 1]<> k_return do
                    indice_courant:= indice_courant- 1;
                  indice_courant:= indice_courant+ 1;
                end;
            colonne_debut_texte:= 0;
            colonne_relative_curseur:= 0;
            affiche_page;
            positionne_curseur_dans_la_ligne;
          end; 
        end; 

      procedure avance_a_la_fin_de_la_ligne;
        var l_taille_ligne: integer;
        begin
          with pv_pt_texte^ do
          begin
            if distance_fin_ligne> 0
              then indice_courant:= indice_courant+ distance_fin_ligne;
            distance_fin_ligne:= 0;
            if (indice_debut_page= 0) and (ligne_relative_curseur= 0)
              then begin
                  l_taille_ligne:= indice_courant;
                end
              else begin
                  l_taille_ligne:= 0;
                  while pt_tampon_texte^[indice_courant- l_taille_ligne- 1]
                      <> k_return do
                    l_taille_ligne:= l_taille_ligne+ 1;
                  l_taille_ligne:= l_taille_ligne- 1;
                end;
            if l_taille_ligne<= colonne_debut_texte+ colonne_relative_curseur
              then begin
                  if l_taille_ligne<= colonne_debut_texte
                    then begin
                        if l_taille_ligne< largeur_fenetre
                          then begin
                              colonne_relative_curseur:= l_taille_ligne;
                              colonne_debut_texte:= 0;
                              affiche_page;
                            end
                          else begin
                              colonne_debut_texte:= l_taille_ligne- largeur_fenetre+ 1;
                              colonne_relative_curseur:= largeur_fenetre- 1;
                              affiche_page;
                            end;
                      end
                    else begin
                        colonne_relative_curseur:= l_taille_ligne- colonne_debut_texte;
                      end;
                end 
              else begin
                  if l_taille_ligne>= colonne_debut_texte+ largeur_fenetre
                    then begin
                        colonne_debut_texte:= l_taille_ligne- largeur_fenetre+ 1;
                        colonne_relative_curseur:= largeur_fenetre- 1;
                        affiche_page;
                      end
                    else begin
                        colonne_relative_curseur:= l_taille_ligne- colonne_debut_texte;
                      end;
                end; 
          end; 
        end; 

      procedure descend_curseur_vers_le_sud;
        var l_taille_fin, l_quantite_espaces: integer;
            l_taille_ligne: integer;

        procedure monte_texte;
          begin
            affiche_commande(50, 'mnt');
          with pv_pt_texte^ do
            begin
              if indice_fin_page= fin_texte
                then affiche_message_et_sonne('dernire ligne')
                else begin
                    while (pt_tampon_texte^[indice_debut_page]<> k_return) do
                      indice_debut_page:= indice_debut_page+ 1;
                    indice_debut_page:= indice_debut_page+ 2;
                    while (pt_tampon_texte^[indice_fin_page]<> k_return) do
                      indice_fin_page:= indice_fin_page+ 1;
                    indice_fin_page:= indice_fin_page+ 2;
                    affiche_page;
                    positionne_curseur_dans_la_page;
                  end;
            end; 
          end; 

        begin 
          with pv_pt_texte^ do
          begin
            if ligne_relative_curseur= hauteur_fenetre- 1
              then monte_texte
              else
                if     ((distance_fin_ligne> 0) and (indice_courant+ distance_fin_ligne+ 2>= fin_texte))
                    or
                       ((distance_fin_ligne<= 0) and (indice_courant+ 2>= fin_texte))
                  then begin
                      affiche_message_et_sonne('peut pas descendre aprs dernire ligne. Insrer RET');
                      exit;
                    end
                  else begin
                      affiche_commande(50, 'sud');
                      if distance_fin_ligne< 0
                        then distance_fin_ligne:= 0;
                      indice_courant:= indice_courant+ distance_fin_ligne+ 2;
                      positionne_curseur_dans_la_ligne;
                      ligne_relative_curseur:= ligne_relative_curseur+ 1;
                    end; 
          end; 
        end; 

      procedure monte_curseur_vers_le_nord;
        var l_taille_ligne, l_taille_fin: integer;

        procedure descend_texte;
          begin
            affiche_commande(50, 'dsc');
            with pv_pt_texte^ do
              if indice_debut_page= 0
                then affiche_message_et_sonne('premire ligne')
                else begin
                    indice_debut_page:= indice_debut_page- 3;
                    while (indice_debut_page> 0)
                        and (pt_tampon_texte^[indice_debut_page]<> k_return) do
                      indice_debut_page:= indice_debut_page- 1;
                    if indice_debut_page<> 0
                      then indice_debut_page:= indice_debut_page+ 2;
                    indice_fin_page:= indice_fin_page- 3;
                    while (indice_fin_page<> 0)
                        and (pt_tampon_texte^[indice_fin_page]<> k_return) do
                      indice_fin_page:= indice_fin_page- 1;
                    if indice_fin_page<> 0
                      then indice_fin_page:= indice_fin_page+ 2;
                    affiche_page;
                    positionne_curseur_dans_la_page;
                  end; 
          end; 

        begin 
          with pv_pt_texte^ do
            if ligne_relative_curseur= 0
              then descend_texte
              else begin
                  affiche_commande(50, 'nor');
                  indice_courant:= indice_courant- 1;
                  while pt_tampon_texte^[indice_courant]<> k_return do
                    indice_courant:= indice_courant- 1;
                  if (indice_debut_page= 0) and (ligne_relative_curseur= 1)
                    then 
                         indice_courant:= 0
                    else begin
                        while pt_tampon_texte^[indice_courant- 1]<> k_return do
                          indice_courant:= indice_courant- 1;
                        indice_courant:= indice_courant+ 1;
                      end;
                  positionne_curseur_dans_la_ligne;
                  ligne_relative_curseur:= ligne_relative_curseur- 1;
                end; 
        end; 

      procedure deplace_texte_vers_ouest;
        begin
          with pv_pt_texte^ do
          begin
            colonne_debut_texte:=  colonne_debut_texte+ 1;
            affiche_page;
          end; 
        end; 

      procedure avance_curseur_vers_l_est;
        var l_taille_fin: integer;
        begin
          with pv_pt_texte^ do
          begin
            distance_fin_ligne:= distance_fin_ligne- 1;
            if distance_fin_ligne>= 0
              then begin
                  indice_courant:= indice_courant+ 1;
                end;
            if colonne_relative_curseur= largeur_fenetre- 1
              then begin
                  deplace_texte_vers_ouest;
                end
              else begin
                  colonne_relative_curseur:= colonne_relative_curseur+ 1;
                end;
              end;
        end; 

      procedure deplace_le_texte_vers_l_est;
        begin
          with pv_pt_texte^ do
          begin
            colonne_debut_texte:=  colonne_debut_texte- 1;
            affiche_page;
          end; 
        end; 

      procedure recule_curseur_vers_l_ouest;
        var l_taille_ligne: integer;
        begin
          with pv_pt_texte^ do
          begin
            if (colonne_relative_curseur= 0) and ( colonne_debut_texte= 0)
              then begin
                   affiche_message_et_sonne('peut pas reculer par <- avec curseur. Utiliser <= ');
                   exit;
                 end;
            distance_fin_ligne:= distance_fin_ligne+ 1;
            if distance_fin_ligne> 0
              then begin
                  indice_courant:= indice_courant- 1;
                end;
            if colonne_relative_curseur= 0
              then begin
                  deplace_le_texte_vers_l_est;
                end
              else begin
                  colonne_relative_curseur:= colonne_relative_curseur- 1;
                end;
          end; 
        end; 

      procedure affiche_la_fin_de_la_ligne;
        var l_indice: integer;
        begin
          with pv_pt_texte^ do
          begin
            l_indice:= 0;
            while (l_indice<= distance_fin_ligne- 1)
                and (colonne_relative_curseur+ l_indice< largeur_fenetre) do
            begin
              write(pt_tampon_texte^[indice_courant+ l_indice]);
              l_indice:= l_indice+ 1;
            end;
            while colonne_relative_curseur+ l_indice< largeur_fenetre do
            begin
              write(' ');
              l_indice:= l_indice+ 1;
            end;
          end; 
        end; 

      procedure insere_un_caractere;
        var l_taille_fin_texte, l_quantite_espaces: integer;
        begin
          with pv_pt_texte^ do
          begin
            l_taille_fin_texte:= fin_texte- indice_courant;
            if distance_fin_ligne>= 0
              then begin
                  if l_taille_fin_texte> 0
                    then move(pt_tampon_texte^[indice_courant],
                              pt_tampon_texte^[indice_courant+ 1],
                              l_taille_fin_texte);
                  l_quantite_espaces:= 0;
                end
              else begin
                  l_quantite_espaces:= -distance_fin_ligne;
                  if l_taille_fin_texte> 0
                    then move(pt_tampon_texte^[indice_courant],
                              pt_tampon_texte^[indice_courant+ l_quantite_espaces+ 1],
                              l_taille_fin_texte);
                  if teste_editeur
                    then fillchar(pt_tampon_texte^[indice_courant], l_quantite_espaces, '=')
                    else fillchar(pt_tampon_texte^[indice_courant], l_quantite_espaces, ' ');
                  fin_texte:= fin_texte+ l_quantite_espaces;
                  indice_courant:= indice_courant+ l_quantite_espaces;
                  indice_fin_page:= indice_fin_page+ l_quantite_espaces;
                  distance_fin_ligne:= 0;
                end;
            pt_tampon_texte^[indice_courant]:= l_touche;
            indice_courant:= indice_courant+ 1;
            indice_fin_page:= indice_fin_page+ 1;
            fin_texte:= fin_texte+ 1;
            write(l_touche);
            if colonne_relative_curseur= largeur_fenetre- 1
              then begin
                  colonne_debut_texte:= colonne_debut_texte+ 1;
                  affiche_page;
                  positionne_curseur_dans_la_page;
                end
              else begin
                  colonne_relative_curseur:= colonne_relative_curseur+ 1;
                  if distance_fin_ligne> 0
                    then affiche_la_fin_de_la_ligne;
                end;
          end; 
        end; 

      procedure insere_return;
        var l_taille_fin: integer;
        begin
          with pv_pt_texte^ do
          begin
            l_taille_fin:= fin_texte- indice_courant;
            if l_taille_fin> 0
              then move(pt_tampon_texte^[indice_courant],
                        pt_tampon_texte^[indice_courant+ 2],
                        l_taille_fin);
            pt_tampon_texte^[indice_courant]:= k_return;
            indice_courant:= indice_courant+ 1;
            pt_tampon_texte^[indice_courant]:= k_interligne;
            indice_courant:= indice_courant+ 1;
            fin_texte:= fin_texte+ 2;
            indice_fin_page:= indice_fin_page+ 2;
            colonne_relative_curseur:= 0;
            colonne_debut_texte:= 0;
            if ligne_relative_curseur= hauteur_fenetre- 1
              then begin
                  while (pt_tampon_texte^[indice_debut_page]<> k_return) do
                    indice_debut_page:= indice_debut_page+ 1;
                  indice_debut_page:= indice_debut_page+ 2;
                  affiche_page;
                end
              else begin
                  if indice_fin_page<> fin_texte
                    then begin
                        while (pt_tampon_texte^[indice_fin_page]<> k_return) do
                          indice_fin_page:= indice_fin_page+ 1;
                        indice_fin_page:= indice_fin_page+ 2;
                      end;
                  ligne_relative_curseur:= ligne_relative_curseur+ 1;
                  affiche_page;
                end; 
          end; 
        end; 

      procedure efface_avant_curseur;

        procedure efface_return;
          var l_taille_fin, l_taille_ligne: integer;
              l_sauve_distance_fin_ligne: integer;
          begin
            with pv_pt_texte^ do
            begin
              l_taille_fin:= fin_texte- indice_courant+ 1;
              move(pt_tampon_texte^[indice_courant],
                   pt_tampon_texte^[indice_courant- 2],
                   l_taille_fin);
              indice_courant:= indice_courant- 2;
              fin_texte:= fin_texte- 2;
              indice_fin_page:= indice_fin_page- 2;
              if ligne_relative_curseur= 0
                then begin
                    indice_debut_page:= indice_debut_page- 3;
                    while (indice_debut_page> 0)
                        and (pt_tampon_texte^[indice_debut_page]<> k_return) do
                      indice_debut_page:= indice_debut_page- 1;
                    if indice_debut_page<> 0
                      then indice_debut_page:= indice_debut_page+ 2;
                    l_sauve_distance_fin_ligne:= distance_fin_ligne;
                    distance_fin_ligne:= 0;
                    avance_a_la_fin_de_la_ligne;
                    distance_fin_ligne:= l_sauve_distance_fin_ligne;
                    affiche_page;
                  end
                else begin
                   if indice_fin_page<> fin_texte
                     then begin
                         while (pt_tampon_texte^[indice_fin_page]<> k_return) do
                           indice_fin_page:= indice_fin_page+ 1;
                         indice_fin_page:= indice_fin_page+ 2;
                       end;
                    ligne_relative_curseur:= ligne_relative_curseur- 1;
                    l_sauve_distance_fin_ligne:= distance_fin_ligne;
                    distance_fin_ligne:= 0;
                    avance_a_la_fin_de_la_ligne;
                    distance_fin_ligne:= l_sauve_distance_fin_ligne;
                    affiche_page;
                  end;
            end; 
          end; 

        procedure efface_dans_la_ligne;
          var l_taille_fin: integer;
          begin
            with pv_pt_texte^ do
            begin
              if distance_fin_ligne< 0
                then begin
                    affiche_message_et_sonne('peut pas effacer aprs RETURN');
                  end
                else begin
                    l_taille_fin:= fin_texte- indice_courant+ 1;
                    move(pt_tampon_texte^[indice_courant],
                         pt_tampon_texte^[indice_courant- 1],
                         l_taille_fin);
                    fin_texte:= fin_texte- 1;
                    indice_courant:= indice_courant- 1;
                    indice_fin_page:= indice_fin_page- 1;
                    if colonne_relative_curseur= 0
                      then begin
                          colonne_debut_texte:= colonne_debut_texte- 1;
                          affiche_page;
                        end
                      else begin
                          write(k_efface_avant_curseur);
                          affiche_la_fin_de_la_ligne;
                          colonne_relative_curseur:= colonne_relative_curseur- 1;
                        end;
                  end;
            end; 
          end; 

        begin 
          with pv_pt_texte^ do
          begin
            if (colonne_relative_curseur= 0) and (colonne_debut_texte= 0)
              then
                if indice_courant= 0
                  then affiche_message_et_sonne('peut pas effacer avant le dbut du texte')
                  else efface_return
              else efface_dans_la_ligne;
          end; 
        end; 

      procedure efface_sous_curseur;
        var l_taille_fin: integer;
        begin
          with pv_pt_texte^ do
          begin
            l_taille_fin:= fin_texte- indice_courant;
            if (distance_fin_ligne<= 0) or (l_taille_fin<= 0)
              then affiche_message_et_sonne('aprs fin de la ligne')
              else begin
                  move(pt_tampon_texte^[indice_courant+ 1],
                       pt_tampon_texte^[indice_courant],
                       l_taille_fin);
                  fin_texte:= fin_texte- 1;
                  distance_fin_ligne:= distance_fin_ligne- 1;
                  affiche_la_fin_de_la_ligne;
                end;
          end; 
        end; 

      procedure efface_ligne;
        var l_indice_debut_ligne, l_indice_fin_ligne: integer;
            l_taille_fin_texte: integer;
        begin
          with pv_pt_texte^ do
          begin
            sonne; exit;
            if (indice_debut_page= 0) and (ligne_relative_curseur= 0)
              then begin
                end
              else begin
                  l_indice_debut_ligne:= indice_courant- 1;
                  while pt_tampon_texte^[l_indice_debut_ligne]<> k_return do
                    l_indice_debut_ligne:= l_indice_debut_ligne- 1;
                  l_indice_debut_ligne:= l_indice_debut_ligne+ 2;
                  l_indice_fin_ligne:= indice_courant+ distance_fin_ligne+ 2;
                  l_taille_fin_texte:= fin_texte- l_indice_fin_ligne;
                  move(pt_tampon_texte^[l_indice_fin_ligne],
                       pt_tampon_texte^[l_indice_debut_ligne],
                       l_taille_fin_texte);
                  fin_texte:= fin_texte- (l_indice_fin_ligne- l_indice_debut_ligne);
                  positionne_curseur_dans_la_ligne;
                end; 
          end; 
        end; 
      procedure initialise_editeur;
        begin
          if pv_pt_texte= nil
            then alloue_texte(pv_pt_texte, pv_nom_texte, k_texte_max);
          with pv_pt_texte^ do
          begin
            if fin_texte= 0
              then begin
                  fillchar(pt_tampon_texte^, 390, 95);
                  pt_tampon_texte^[fin_texte]:= k_return;
                  fin_texte:= fin_texte+ 1;
                  pt_tampon_texte^[fin_texte]:= k_interligne;
                  fin_texte:= fin_texte+ 1;
                end;
            indice_debut_page:= 0; indice_fin_page:= 0;
            colonne_debut_texte:= 0;
            textbackground(white);
            clrscr;
            textbackground(black);
            affiche_page;
            saute_debut_texte;
            l_message_erreur_est_affiche:= false;
            a_modifie_texte:= false;
          end; 
        end; 
      procedure charge_un_texte;
        begin
          with pv_pt_texte^ do
          begin
            affiche_invite('c');
            readln(pv_nom_texte);
            charge_texte(pv_pt_texte, pv_nom_texte, k_texte_max);
            initialise_editeur;
            affiche_invite('g');
          end; 
        end; 
      procedure sauve_le_texte;
        var l_fichier_texte: file;
        begin
          with pv_pt_texte^ do
          begin
            affiche_invite('s');
            repeat
              lis_touche(l_touche);
            until l_touche in ['o', 'n'];
            if l_touche= 'n'
              then begin
                  affiche_invite('c');
                  readln(pv_nom_texte);
                end;
            assign(l_fichier_texte, pv_nom_texte);
            rewrite(l_fichier_texte, 1);
            blockwrite(l_fichier_texte, pt_tampon_texte^, fin_texte);
            close(l_fichier_texte);
            affiche_invite('g');
          end; 
        end; 
      begin 
        clrscr;
        initialise_editeur;
        affiche_invite('g');
        with pv_pt_texte^ do
        begin
          repeat
            if not l_message_erreur_est_affiche
              then affiche_position;
            if teste_editeur
              then affiche_tampon;
            gotoxy(colonne_debut_fenetre+ colonne_relative_curseur+ 1,
                ligne_debut_fenetre+ ligne_relative_curseur+ 1);
            lis_touche(l_touche);
            if l_touche in [k_curseur_est, k_curseur_ouest, k_curseur_nord, k_curseur_sud,
                k_page_suivante, k_page_precedente, k_mot_precedent, k_mot_suivant,
                k_debut_texte]
              then a_modifie_texte:= true;
            if l_message_erreur_est_affiche
              then begin
                  l_message_erreur_est_affiche:= false;
                  affiche_invite('g');
                end;
            case l_touche of
              k_curseur_est : avance_curseur_vers_l_est;
              k_curseur_ouest : recule_curseur_vers_l_ouest;
              k_curseur_nord : monte_curseur_vers_le_nord;
              k_curseur_sud : descend_curseur_vers_le_sud;
              k_page_suivante : avance_d_une_page_par_PgDn;
              k_page_precedente : recule_d_une_page_par_PgUp;
              k_mot_precedent : recule_au_debut_de_la_ligne;
              k_mot_suivant : avance_a_la_fin_de_la_ligne;
              k_debut_texte : saute_debut_texte;
              k_return: insere_return;
              k_efface_avant_curseur : efface_avant_curseur;
              k_efface_sous_curseur : efface_sous_curseur;
              k_controle_y : efface_ligne;
              k_controle_read : charge_un_texte;
              k_controle_write : sauve_le_texte;
              k_controle_t : begin
                               clrscr;
                               teste_editeur:= not teste_editeur;
                               affiche_page; positionne_curseur_dans_la_page;
                               affiche_invite('g');
                             end;
              k_controle_q : ;
              else
                insere_un_caractere;
            end; 
          until l_touche= k_controle_q;
          gotoxy(1, 25); writeln;
        end; 
      end; 
    procedure initialise_texte(var pv_pt_texte: t_pt_texte);
      begin
        pv_pt_texte:= nil;
      end; 
  begin 
  end. 







