(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit uexgest;
  interface
    uses crt,
         utypcons,
         udonnees, uchamps, usaisfic,
         umemo;

    procedure cree_DBF;

    procedure genere_DBF(p_quantite: integer);

    procedure saisis_DBF;

    procedure liste_DBF;

    procedure affiche_descripteur_DBF;
    var g_pt_fichier_donnees: t_pt_fichier_donnees;
        g_nom_fichier: t_string_80;
  implementation

    procedure cree_DBF;
      begin
        cree_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
        ajoute_definition_de_zone(g_pt_fichier_donnees, 'PRENOM',    'C', 15, 0);
        ajoute_definition_de_zone(g_pt_fichier_donnees, 'PASCALIEN', 'L',  1, 0);
        ajoute_definition_de_zone(g_pt_fichier_donnees, 'POIDS',     'N', 13, 4);
        ajoute_definition_de_zone(g_pt_fichier_donnees, 'NAISSANCE', 'D',  8, 0);
        ajoute_definition_de_zone(g_pt_fichier_donnees, 'FIN',       'C',  4, 0);
        ferme_fichier_donnees(g_pt_fichier_donnees);
      end; 

    procedure genere_DBF(p_quantite: integer);
      var l_numero_fiche: integer;

      procedure remplis_fiche(p_numero, p_caractere: char);
        var l_numero_zone: integer;
            l_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
            l_date: t_date;
        begin
          initialise_fiche_courante(g_pt_fichier_donnees);
          for l_numero_zone:= 0 to f_nombre_zones(g_pt_fichier_donnees)- 1 do
          begin
            l_pt_descripteur_de_zone:=
                f_pt_descripteur_zone(g_pt_fichier_donnees, l_numero_zone);
            with l_pt_descripteur_de_zone^ do
              case type_zone of
                'C' : fillchar(pt_valeur_zone^, taille_zone, p_caractere);
                'N' : begin
                        fillchar(pt_valeur_zone^, taille_zone, p_numero);
                        if decimales_zone<> 0
                          then pt_valeur_zone^[taille_zone- decimales_zone- 1]:= '.';
                      end;
                'L' : pt_valeur_zone^[0]:= 'Y';
                'D' : begin
                        l_date:= '19880816';
                        move(l_date, pt_valeur_zone^, 8);
                      end;
              end; 
          end; 
        end; 

      begin 
        cree_DBF;
        ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
        for l_numero_fiche:= 0 to p_quantite do
        begin
          remplis_fiche(chr(48+ (l_numero_fiche mod 10)),
               chr(ord('A')+ random(ord('Z')+ 1- ord('A'))));
          ecris_fiche_courante(g_pt_fichier_donnees);
        end;
        ferme_fichier_donnees(g_pt_fichier_donnees);
      end; 

    procedure saisis_DBF;
      var l_masque: t_groupe_champs;
          l_pt_fichier_memo: t_pt_fichier_memo;
      begin 
        ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
        initialise_le_masque_standard(g_pt_fichier_donnees, l_masque);
        l_pt_fichier_memo:= nil;
        saisis_fiche_a_fiche(g_pt_fichier_donnees, f_nombre_fiches(g_pt_fichier_donnees),
                             l_masque, l_pt_fichier_memo);
        libere_groupe_de_champs(l_masque);
        ferme_fichier_donnees(g_pt_fichier_donnees);
      end; 

    procedure liste_DBF;
      var l_numero_fiche: integer;
          l_numero_zone: integer;
      begin
        ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
        l_numero_fiche:= 0;
        while not f_fin_fichier_donnees(g_pt_fichier_donnees) do
        begin
          lis_fiche_courante(g_pt_fichier_donnees);
          write(l_numero_fiche: 6, ' ');
          for l_numero_zone:= 0 to f_nombre_zones(g_pt_fichier_donnees)- 1 do
          begin
            affiche_zone(g_pt_fichier_donnees, l_numero_zone);
            write('=');
          end;
          writeln('<');
          l_numero_fiche:= l_numero_fiche+ 1;
        end; 
        ferme_fichier_donnees(g_pt_fichier_donnees);
      end; 

    procedure affiche_descripteur_DBF;
      begin
        ouvre_fichier_donnees(g_pt_fichier_donnees, g_nom_fichier);
        affiche_en_tete_fichier_donnees(g_pt_fichier_donnees);
        ferme_fichier_donnees(g_pt_fichier_donnees);
      end; 

  begin 
  end. 




