(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

unit uhex;
  interface
    type t_string_2= string[2];
         t_string_4= string[4];
         t_string_9= string[9];

    function f_octet_hexadecimal(p_octet: byte): t_string_2;

    function f_entier_hexadecimal(p_entier: integer): t_string_4;

    function f_pointeur_hexadecimal(var pv_pointeur): t_string_9;

    function f_pointer_hexadecimal(p_pointeur: pointer): t_string_9;

    function f_pointeur_longint(var pv_pointeur): longint;

    function f_longint_pointeur(p_longint: longint): pointer;

    procedure affiche_memoire(var pv_memoire; p_quantite: integer);
  implementation

    function f_octet_hexadecimal(p_octet: byte): t_string_2;
      const vi_hex: array[0..15] of char= '0123456789ABCDEF';
      begin
        f_octet_hexadecimal:= vi_hex[p_octet div 16]+ vi_hex[p_octet mod 16];
      end; 
  

    function f_entier_hexadecimal(p_entier: integer): t_string_4;
      begin
        f_entier_hexadecimal:= f_octet_hexadecimal(hi(p_entier))
                               + f_octet_hexadecimal(lo(p_entier));
      end; 

    function f_pointeur_hexadecimal(var pv_pointeur): t_string_9;
      type t_adresse= record
                        decalage, segment: integer;
                      end;
      begin
        f_pointeur_hexadecimal:=f_entier_hexadecimal(t_adresse(pv_pointeur).segment)+ ':'+
              + f_entier_hexadecimal(t_adresse(pv_pointeur).decalage);
      end; 

    function f_pointer_hexadecimal(p_pointeur: pointer): t_string_9;
      begin
        f_pointer_hexadecimal:= f_pointeur_hexadecimal(p_pointeur);
      end; 

    function f_pointeur_longint(var pv_pointeur): longint;
      type t_pointeur= record
                         decalage, segment: word;
                       end;
      var l_pointeur: t_pointeur absolute pv_pointeur;
          l_valeur: longint;
      begin
        with l_pointeur do
        begin
          l_valeur:= segment;
          f_pointeur_longint:= l_valeur* 16+ decalage;
        end;
      end; 

    function f_longint_pointeur(p_longint: longint): pointer;
      type t_pointeur= record
                         case integer of
                          1 : (decalage, segment: word);
                          2 : (pointeur: pointer);
                       end;
      var l_pointeur: t_pointeur;
          l_longint: longint;
      begin
        with l_pointeur do
        begin
          l_longint:= p_longint;
          segment:= l_longint shr 4;
          l_longint:= segment;
          l_longint:= p_longint- l_longint* 16;
          decalage:= l_longint;
          f_longint_pointeur:= pointeur;
        end;
      end; 

    procedure affiche_memoire(var pv_memoire; p_quantite: integer);
      var l_colonne, l_indice: integer;
          l_octet: byte;
          l_memoire_surtypee: array[0..1023] of byte absolute pv_memoire;
      begin
        l_indice:= 0;
        while p_quantite> 0 do
        begin
          write(f_entier_hexadecimal(seg(pv_memoire)), ':',
              f_entier_hexadecimal(ofs(pv_memoire)+ l_indice), ' ');
          l_colonne:= 0;
          while (l_colonne<= 7) and (p_quantite- l_colonne> 0) do
          begin
            l_octet:= l_memoire_surtypee[l_indice+ l_colonne];
            write('$', f_octet_hexadecimal(l_octet), ' ');
            l_colonne:= l_colonne+ 1;
          end;
          write('': 4* (8- l_colonne), ':');
          l_colonne:= 0;
          while (l_colonne<= 7) and (p_quantite- l_colonne> 0) do
          begin
            l_octet:= l_memoire_surtypee[l_indice+ l_colonne];
            if l_octet in [32..127]
              then write(chr(l_octet))
              else write('.');
            l_colonne:= l_colonne+ 1;
          end;
          writeln;
          p_quantite:= p_quantite- 8;
          l_indice:= l_indice+ 8;
        end;
      end; 

  begin 
  end. 






