(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+,v-*)
unit uindex;
  interface
    uses crt,
         utypcons, uerreur, uaffiche, uchained;
    const k_nil= 0;
          k_fin_fichier= -99; 
          k_longueur_cle_max= 100;
          k_taille_page= 512;
    type t_cle_db= array[0..k_longueur_cle_max] of char;
         t_numero_page= longint;
         t_nom_variable= array[0..10] of char;
         t_en_tete_index= record
                            numero_racine: longint;
                            numero_derniere_page: longint;
                            reserve_1: longint;
                            taille_cle: integer;
                            nombre_cles_max: integer;
                            reserve_2: integer;
                            taille_cellule: integer;
                            reserve_3: longint;
                            nom_cle: t_nom_variable;
                            remplissage: array[0..476] of byte;
                          end;
         t_cellule= record
                      numero_fiche: longint;
                      cle_db: t_cle_db;
                    end;
         t_page= record
                   nombre_cellules_utilisees: longint;
                   numero_page_0: t_numero_page;
                   tableau_positions: array[0..503] of byte;
                 end;
         t_index= record
                    fichier_b_arbre: file;
                    nom_chemin: t_string_80; nom_index: string[8]; nom_extension: string[3];
                    nom_cle: t_nom_variable;
                    taille_cle: integer;
                    taille_cellule: integer;
                    nombre_cles_max: integer;
                    moitie_nombre_cles_max: integer;
                    numero_racine: t_numero_page;
                    numero_derniere_page: t_numero_page;
                  end;

    procedure affiche_descripteur_index(var pv_index: t_index);

    procedure cree_index(var pv_index: t_index;
               p_nom: t_string_80; p_taille_cle: integer; p_nom_cle: t_nom_variable);

    procedure ouvre_index(var pv_index: t_index; p_nom: t_string_80);
    type t_pt_cellule= ^t_cellule;
         t_pt_fille= ^t_numero_page;

    function f_pt_cellule(var pv_index: t_index; var pv_page: t_page;
         p_indice_cellule: integer; var pv_pt_fille: t_pt_fille): t_pt_cellule;

    function f_pt_fille(var pv_index: t_index; var pv_cellule: t_cellule): t_pt_fille;

    procedure affiche_une_page(var pv_index: t_index; p_numero_page: t_numero_page;
           p_page: t_page);

    procedure lis_et_affiche_page(var pv_index: t_index; p_numero_page: t_numero_page);

    procedure liste_pages_index(var pv_index: t_index);

    procedure liste_index(var pv_index: t_index);

    procedure ajoute_cle(var pv_index: t_index; p_cle_db: t_cle_db; p_numero_fiche: t_numero_page);

    procedure efface_cle(var pv_index: t_index; p_cle_db: t_cle_db);

    procedure cherche_cle(var pv_index: t_index; p_cle_db: t_cle_db;
         var pv_numero_fiche: t_numero_page;
         var pv_a_trouve: boolean);

    procedure cherche_cle_suivante(var pv_index: t_index;
         var pv_numero_fiche: t_numero_page);

    procedure cherche_cle_precedante(var pv_index: t_index;
        var pv_numero_fiche: t_numero_page);

    procedure ferme_index(var pv_index: t_index);
  implementation

    procedure affiche_descripteur_index(var pv_index: t_index);
      begin
        with pv_index do
        begin
          writeln('racine           ', numero_racine);
          writeln('dernire page    ', numero_derniere_page);
          writeln('taille cl       ', taille_cle);
          writeln('taille cellule   ', taille_cellule);
          writeln('cl par page max ', nombre_cles_max);
          writeln('moiti cl/page  ', moitie_nombre_cles_max);
          write  ('cle              ');
          affiche_chaine_db(nom_cle, 10); writeln;
        end; 
      end; 

    procedure cree_index(var pv_index: t_index;
               p_nom: t_string_80; p_taille_cle: integer; p_nom_cle: t_nom_variable);
      var l_en_tete: t_en_tete_index;
      begin
        with pv_index do
        begin
          nom_chemin:= p_nom; nom_chemin:= ''; nom_extension:= '';
          taille_cle:= p_taille_cle;
          taille_cellule:= 4+ 4+ p_taille_cle;
          nombre_cles_max:= (k_taille_page- 2*4) div taille_cellule;
          moitie_nombre_cles_max:= nombre_cles_max div 2;
          numero_racine:= k_nil;
          numero_derniere_page:= 1;
          assign(fichier_b_arbre, p_nom);
          rewrite(fichier_b_arbre, k_taille_page);
          fillchar(l_en_tete, sizeof(l_en_tete), 0);
          l_en_tete.numero_racine:= numero_racine;
          l_en_tete.numero_derniere_page:= numero_derniere_page;
          l_en_tete.taille_cle:= taille_cle;
          l_en_tete.nombre_cles_max:= nombre_cles_max;
          l_en_tete.taille_cellule:= taille_cellule;
          l_en_tete.nom_cle:= p_nom_cle;
          blockwrite(fichier_b_arbre, l_en_tete, 1);
        end; 
      end; 

    procedure ouvre_index(var pv_index: t_index; p_nom: t_string_80);
      var l_en_tete: t_en_tete_index;
      begin
        with pv_index do
        begin
          nom_chemin:= p_nom; nom_index:= ''; nom_extension:= '';
          assign(fichier_b_arbre, p_nom);
          reset(fichier_b_arbre, k_taille_page);
          blockread(fichier_b_arbre, l_en_tete, 1);
          with pv_index do
          begin
            nombre_cles_max:= l_en_tete.nombre_cles_max;
            taille_cle:= l_en_tete.taille_cle;
            taille_cellule:= l_en_tete.taille_cellule;
            nom_cle:= l_en_tete.nom_cle;
            numero_racine:= l_en_tete.numero_racine;
            numero_derniere_page:= l_en_tete.numero_derniere_page;
            moitie_nombre_cles_max:= nombre_cles_max div 2;
          end; 
        end; 
      end; 

    function f_pt_cellule(var pv_index: t_index; var pv_page: t_page;
        p_indice_cellule: integer; var pv_pt_fille: t_pt_fille): t_pt_cellule;
      var l_position: integer;
      begin
        l_position:= (p_indice_cellule- 1)* pv_index.taille_cellule;
        f_pt_cellule:= addr(pv_page.tableau_positions[l_position]);
        pv_pt_fille:= addr(pv_page.tableau_positions[l_position+ pv_index.taille_cellule- 4]);
      end; 

    function f_pt_fille(var pv_index: t_index; var pv_cellule: t_cellule): t_pt_fille;
      begin
        f_pt_fille:= addr(pv_cellule.cle_db[pv_index.taille_cle]);
      end; 

    procedure affiche_cellule(var pv_index: t_index; var pv_page: t_page;
          p_numero_cellule: integer);
      var l_pt_fille: t_pt_fille;
      begin
        with pv_index, pv_page do
        begin
          if (p_numero_cellule< 1) or (p_numero_cellule> nombre_cles_max)
            then begin
                writeln(' ERREUR: num cell ', p_numero_cellule);
                readln;
              end
            else
              with f_pt_cellule(pv_index, pv_page, p_numero_cellule, l_pt_fille)^ do
              begin
                write(numero_fiche: 6, ' ');
                affiche_chaine_db(cle_db, taille_cle);
                writeln(' ', l_pt_fille^: 6);
              end; 
        end; 
      end; 

    procedure affiche_une_page(var pv_index: t_index; p_numero_page: t_numero_page;
          p_page: t_page);

      procedure affiche_contenu;
        var l_indice_cellule: integer;
            l_pt_fille: t_pt_fille;
        begin
          with pv_index, p_page do
          begin
            if p_numero_page= pv_index.numero_racine
              then write(' racine ')
              else write('        ');
            if numero_page_0= k_nil
              then write('F | ')
              else write('N | ', numero_page_0, ' ');
            for l_indice_cellule:= 1 to nombre_cellules_utilisees do
            begin
              with f_pt_cellule(pv_index, p_page, l_indice_cellule, l_pt_fille)^ do
              begin
                if numero_page_0= k_nil
                  then begin
                      affiche_chaine_db(cle_db, taille_cle);
                      write(':', numero_fiche, ' ');
                    end
                  else begin
                      write('-');
                      affiche_chaine_db(cle_db, taille_cle);
                      write('-', l_pt_fille^);
                    end;
              end; 
            end; 
            writeln;
          end; 
        end; 

      begin 
        with pv_index do
        begin
          if wherex>= 20
            then writeln;
          gotoxy(20, wherey);
          write(p_numero_page: 2);
          if p_page.nombre_cellules_utilisees= 0
            then writeln(' vide')
            else affiche_contenu;
        end; 
      end; 

    procedure lis_et_affiche_page(var pv_index: t_index; p_numero_page: t_numero_page);
      var l_page: t_page;
          l_taille_page: integer;
      begin
        seek(pv_index.fichier_b_arbre, p_numero_page);
        blockread(pv_index.fichier_b_arbre, l_page, 1);
        affiche_une_page(pv_index, p_numero_page, l_page);
      end; 

    procedure liste_pages_index(var pv_index: t_index);
      var l_numero_page: t_numero_page;
      begin 
        if pv_index.numero_racine<> k_nil
          then begin
              l_numero_page:= 1; seek(pv_index.fichier_b_arbre, l_numero_page);
              while not eof(pv_index.fichier_b_arbre) do
              begin
                lis_et_affiche_page(pv_index, l_numero_page);
                l_numero_page:= l_numero_page+ 1;
              end; 
            end; 
      end; 

    procedure liste_index(var pv_index: t_index);

      procedure affiche_page(p_numero_page: t_numero_page);
        var l_indice: integer;
            l_page: t_page;
            l_pt_fille: t_pt_fille;
        begin
          seek(pv_index.fichier_b_arbre, p_numero_page);
          blockread(pv_index.fichier_b_arbre, l_page, 1);
          with l_page do
          begin
            if numero_page_0<> k_nil
              then affiche_page(numero_page_0);
            for l_indice:= 1 to nombre_cellules_utilisees do
              with f_pt_cellule(pv_index, l_page, l_indice, l_pt_fille)^  do
                if l_pt_fille^<> k_nil
                  then affiche_page(l_pt_fille^)
                  else begin
                      affiche_chaine_db(cle_db, pv_index.taille_cle);
                      write(': ', numero_fiche, ', ');
                    end;
          end; 
        end; 

      begin 
        if pv_index.numero_racine<> k_nil
          then affiche_page(pv_index.numero_racine);
        writeln;
      end; 

  procedure efface_page(var pv_index: t_index; p_numero_page: t_numero_page);
    var l_page: t_page;
    begin
      with pv_index do
      begin
        fillchar(l_page, sizeof(t_page), 0);
        l_page.nombre_cellules_utilisees:= numero_derniere_page;
        seek(fichier_b_arbre, p_numero_page);
        blockwrite(fichier_b_arbre, l_page, 1);
        numero_derniere_page:= p_numero_page;
      end; 
    end; 

  procedure alloue_page(var pv_index: t_index; var pv_numero_page: t_numero_page);
    begin
    end; 
  (*$i a:iefface *)
  procedure ajoute_cle(var pv_index: t_index; p_cle_db: t_cle_db; p_numero_fiche: t_numero_page);
    const k_hauteur_pile_max= 100;
    type t_pile= record
                   numero_page_mere: t_numero_page;
                   indice_mere: integer;
                 end;
    var l_numero_page: t_numero_page;
        l_page: t_page;
        l_indice_superieur, l_indice_inferieur, l_indice_milieu: integer;
        l_ajouter_au_dessus: boolean;
        l_nouvelle_cellule: t_cellule;
        l_meme_cle: boolean;
        l_pile: array[0..k_hauteur_pile_max] of t_pile;
        l_sommet_pile: integer;
        l_cellule: t_cellule;
        l_pt_fille: t_pt_fille;

    procedure cree_racine(p_numero_page: t_numero_page);
      begin
        with pv_index do
        begin
          with l_page do
          begin
            nombre_cellules_utilisees:= 1;
            numero_page_0:= p_numero_page;
           move(l_nouvelle_cellule, l_page.tableau_positions, taille_cellule);
          end;
          numero_racine:= numero_derniere_page;
          seek(fichier_b_arbre, numero_derniere_page);
          blockwrite(fichier_b_arbre, l_page, 1);
          numero_derniere_page:= numero_derniere_page+ 1;
        end; 
      end; 

   procedure ajoute_une_cellule(p_numero_page: t_numero_page; p_indice: integer);
      var l_nouvelle_page: t_page;
          l_prochaine_nouvelle_cellule: t_cellule;
          l_numero_page_suivante: t_numero_page;
      begin
        with pv_index do
        begin
          seek(fichier_b_arbre, p_numero_page);
          blockread(fichier_b_arbre, l_page, 1);
          with l_page do
          begin
            if nombre_cellules_utilisees< nombre_cles_max
              then begin
                  if p_indice< nombre_cellules_utilisees+ 1
                    then move(tableau_positions[(p_indice- 1)* taille_cellule],
                              tableau_positions[(p_indice- 1+ 1)* taille_cellule],
                              (nombre_cellules_utilisees+ 1- p_indice)* taille_cellule);
                  move(l_nouvelle_cellule,
                       tableau_positions[(p_indice- 1)* taille_cellule],
                       taille_cellule);
                  nombre_cellules_utilisees:= nombre_cellules_utilisees+ 1;
                  seek(fichier_b_arbre, p_numero_page);
                  blockwrite(fichier_b_arbre, l_page, 1);
                  l_ajouter_au_dessus:= false;
                end 
              else begin
                  if p_indice<= moitie_nombre_cles_max+ 1
                    then begin
                        move(tableau_positions[(moitie_nombre_cles_max+ 1- 1)* taille_cellule],
                               l_nouvelle_page.tableau_positions,
                               moitie_nombre_cles_max* taille_cellule);
                        l_nouvelle_page.nombre_cellules_utilisees:=
                            (nombre_cles_max- moitie_nombre_cles_max);
                        if p_indice= moitie_nombre_cles_max+ 1
                          then
                            l_prochaine_nouvelle_cellule.cle_db:= l_nouvelle_cellule.cle_db
                          else begin
                              move(f_pt_cellule(pv_index, l_page, moitie_nombre_cles_max,
                                     l_pt_fille)^,
                                   l_prochaine_nouvelle_cellule, taille_cellule);
                              move(tableau_positions[(p_indice- 1)* taille_cellule],
                                   tableau_positions[(p_indice+ 1- 1)* taille_cellule],
                                   (moitie_nombre_cles_max+ 1 - p_indice)* taille_cellule);
                            end; 
                        move(l_nouvelle_cellule,
                             f_pt_cellule(pv_index, l_page, p_indice, l_pt_fille)^,
                             taille_cellule);
                        if numero_page_0= k_nil
                          then nombre_cellules_utilisees:= moitie_nombre_cles_max+ 1
                          else nombre_cellules_utilisees:= moitie_nombre_cles_max;
                      end 
                    else begin
                        move(f_pt_cellule(pv_index, l_page, moitie_nombre_cles_max+ 1,
                               l_pt_fille)^,
                             l_prochaine_nouvelle_cellule, taille_cellule);
                        p_indice:= p_indice- moitie_nombre_cles_max- 1;
                        if p_indice> 1
                          then move(tableau_positions[(moitie_nombre_cles_max+ 2- 1)
                                        * taille_cellule],
                                    l_nouvelle_page.tableau_positions,
                                    (p_indice- 1)* taille_cellule);
                        move(l_nouvelle_cellule,
                             f_pt_cellule(pv_index, l_nouvelle_page, p_indice, l_pt_fille)^,
                             taille_cellule);
                        if p_indice< nombre_cles_max- moitie_nombre_cles_max
                          then move(tableau_positions[(moitie_nombre_cles_max+ p_indice+ 1- 1)
                                        * taille_cellule],
                                    l_nouvelle_page
                                        .tableau_positions[(p_indice+ 1- 1)* taille_cellule],
                                    (moitie_nombre_cles_max- p_indice) * taille_cellule);
                        if numero_page_0= k_nil
                          then nombre_cellules_utilisees:= moitie_nombre_cles_max+ 1
                          else nombre_cellules_utilisees:= moitie_nombre_cles_max;
                        l_nouvelle_page.nombre_cellules_utilisees:=
                            nombre_cles_max- moitie_nombre_cles_max;
                      end; 
                  l_nouvelle_page.numero_page_0:=
                    f_pt_fille(pv_index, l_prochaine_nouvelle_cellule)^;
                  seek(fichier_b_arbre, pv_index.numero_derniere_page);
                  blockwrite(fichier_b_arbre, l_nouvelle_page, 1);
                  seek(fichier_b_arbre, p_numero_page);
                  blockwrite(fichier_b_arbre, l_page, 1);
                  l_nouvelle_cellule:= l_prochaine_nouvelle_cellule;
                  f_pt_fille(pv_index, l_nouvelle_cellule)^:= numero_derniere_page;
                  numero_derniere_page:= numero_derniere_page+ 1;
                  l_ajouter_au_dessus:= true;
                end; 
          end; 
        end; 
      end; 

    begin 
      with pv_index do
      begin
        l_numero_page:= numero_racine;
        l_sommet_pile:= 0;
        if l_numero_page<> k_nil
          then
            repeat
              seek(fichier_b_arbre, l_numero_page);
              blockread(fichier_b_arbre, l_page, 1);
             with l_page do
              begin
                l_indice_superieur:= 1;
                l_indice_inferieur:= nombre_cellules_utilisees;
                repeat
                  l_indice_milieu:= (l_indice_superieur+l_indice_inferieur) div 2;
                 with f_pt_cellule(pv_index, l_page, l_indice_milieu, l_pt_fille)^ do
                  begin
                    if f_inferieur_ou_egal(p_cle_db, cle_db, taille_cle)
                      then l_indice_inferieur:= l_indice_milieu- 1;
                    if f_inferieur_ou_egal(cle_db, p_cle_db, taille_cle)
                      then l_indice_superieur:= l_indice_milieu+ 1;
                  end; 
                until l_indice_inferieur< l_indice_superieur;
                if l_indice_superieur- 1= l_indice_inferieur+ 1
                  then begin 
                      l_meme_cle:=true;
                      while l_meme_cle and (l_indice_inferieur< nombre_cellules_utilisees) do
                      begin
                        with f_pt_cellule(pv_index, l_page, l_indice_inferieur+ 1, l_pt_fille)^ do
                        begin
                          if f_egal(cle_db, p_cle_db, taille_cle)
                            then l_indice_inferieur:= l_indice_inferieur+ 1
                            else l_meme_cle:= false;
                        end;
                      end; 
                    end; 
                l_pile[l_sommet_pile].numero_page_mere:= l_numero_page;
                l_pile[l_sommet_pile].indice_mere:= l_indice_inferieur;
                l_sommet_pile:= l_sommet_pile+ 1;
                if l_indice_inferieur= 0
                  then l_numero_page:= numero_page_0
                  else begin
                      with f_pt_cellule(pv_index, l_page, l_indice_inferieur, l_pt_fille)^ do
                        l_numero_page:= l_pt_fille^;
                    end;
              end; 
            until l_page.numero_page_0= k_nil;
        with l_nouvelle_cellule do
        begin
          numero_fiche:= p_numero_fiche;
          cle_db:= p_cle_db;
          f_pt_fille(pv_index, l_nouvelle_cellule)^:= k_nil;
        end;
        l_ajouter_au_dessus:= true;
        repeat
          l_sommet_pile:= l_sommet_pile- 1;
          if l_sommet_pile= -1
            then begin
                if pv_index.numero_racine= k_nil
                  then cree_racine(k_nil)
                  else cree_racine(l_pile[0].numero_page_mere);
                l_ajouter_au_dessus:= false;
              end
            else 
              with l_pile[l_sommet_pile] do
                ajoute_une_cellule(numero_page_mere, indice_mere+ 1);
        until not l_ajouter_au_dessus;
      end; 
    end; 
    const k_hauteur_pile_max= 100;
    type t_pile= record
                   numero_page_mere: t_numero_page;
                   indice_mere: integer;
                 end;
    var s_pile_recherche: array[0..k_hauteur_pile_max] of t_pile;
        s_sommet_pile_recherche: integer;

    procedure affiche_pile(var pv_index: t_index);
      var l_indice: integer;
      begin
        writeln('  PILE: ');
        for l_indice:= s_sommet_pile_recherche downto 0 do
          with s_pile_recherche[l_indice] do
          begin
            write(l_indice: 3, ', MI: ', numero_page_mere: 3, indice_mere: 3, ' ');
            lis_et_affiche_page(pv_index, numero_page_mere);
          end;
      end; 

   procedure cherche_cle(var pv_index: t_index; p_cle_db: t_cle_db;
          var pv_numero_fiche: t_numero_page; var pv_a_trouve: boolean);
      var l_numero_page: t_numero_page;
          l_page: t_page;
          l_indice_superieur, l_indice_inferieur, l_indice_milieu: integer;
          l_a_trouve, l_meme_cle: boolean;
          l_pt_fille: t_pt_fille;
      begin
        with pv_index do
        begin
          l_numero_page:= numero_racine;
          l_a_trouve:= false;
          s_sommet_pile_recherche:= 0;
          fillchar(s_pile_recherche, sizeof(s_pile_recherche), 255);
          if l_numero_page<> k_nil
            then
              repeat
                seek(fichier_b_arbre, l_numero_page);
                blockread(fichier_b_arbre, l_page, 1);
                with l_page do
                begin
                  l_indice_superieur:= 1;
                  l_indice_inferieur:= nombre_cellules_utilisees;
                  repeat
                    l_indice_milieu:= (l_indice_superieur+l_indice_inferieur) div 2;
                    with f_pt_cellule(pv_index, l_page, l_indice_milieu, l_pt_fille)^ do
                    begin
                      if f_inferieur_ou_egal(p_cle_db, cle_db, taille_cle)
                        then l_indice_inferieur:= l_indice_milieu- 1;
                      if f_inferieur_ou_egal(cle_db, p_cle_db, taille_cle)
                        then l_indice_superieur:= l_indice_milieu+ 1;
                    end; 
                  until l_indice_inferieur< l_indice_superieur;
                  if l_indice_superieur- l_indice_inferieur> 1
                    then begin
                        l_a_trouve:= true;
                        l_meme_cle:= true;
                        while l_meme_cle and (l_indice_inferieur> 0) do
                        begin
                          with f_pt_cellule(pv_index, l_page, l_indice_inferieur, l_pt_fille)^ do
                            if f_egal(cle_db, p_cle_db, taille_cle)
                              then l_indice_inferieur:= l_indice_inferieur- 1
                              else l_meme_cle:= false;
                        end; 
                      end; 
                  s_pile_recherche[s_sommet_pile_recherche].numero_page_mere:= l_numero_page;
                  s_pile_recherche[s_sommet_pile_recherche].indice_mere:= l_indice_inferieur;
                  s_sommet_pile_recherche:= s_sommet_pile_recherche+ 1;
                  if l_page.numero_page_0<> k_nil
                    then
                      if l_indice_inferieur= 0
                        then l_numero_page:= numero_page_0
                        else
                          with f_pt_cellule(pv_index, l_page, l_indice_inferieur, l_pt_fille)^ do
                            l_numero_page:= l_pt_fille^;
                end; 
              until l_page.numero_page_0= k_nil;
          s_sommet_pile_recherche:= s_sommet_pile_recherche- 1;
          if not l_a_trouve
            then pv_a_trouve:= false;
          with l_page do
          begin
            if l_indice_inferieur+ 1<= nombre_cellules_utilisees
              then begin
                  with f_pt_cellule(pv_index, l_page, l_indice_inferieur+ 1, l_pt_fille)^ do
                    pv_numero_fiche:= numero_fiche;
                  pv_a_trouve:= true;
                end
              else begin
                  pv_a_trouve:= false;
                  pv_numero_fiche:= k_fin_fichier;
                end;
          end; 
        end; 
      end; 

    procedure cherche_cle_suivante(var pv_index: t_index;
        var pv_numero_fiche: t_numero_page);
      var l_page: t_page;
          l_pt_fille: t_pt_fille;
          l_a_trouve: boolean;
      begin
        with pv_index, l_page, s_pile_recherche[s_sommet_pile_recherche] do
        begin
          seek(fichier_b_arbre, numero_page_mere);
          blockread(fichier_b_arbre, l_page, 1);
          indice_mere:= indice_mere+ 1;
          if indice_mere+ 1<= nombre_cellules_utilisees
            then begin
                with f_pt_cellule(pv_index, l_page, indice_mere+ 1, l_pt_fille)^ do
                  pv_numero_fiche:= numero_fiche;
              end
            else begin
                l_a_trouve:= false;
                while not l_a_trouve and (s_sommet_pile_recherche> 0) do
                begin
                  s_sommet_pile_recherche:= s_sommet_pile_recherche- 1;
                  with s_pile_recherche[s_sommet_pile_recherche] do
                  begin
                    seek(fichier_b_arbre, numero_page_mere);
                    blockread(fichier_b_arbre, l_page, 1);
                    if indice_mere+ 1<= nombre_cellules_utilisees
                      then l_a_trouve:= true;
                  end; 
                end; 
                if l_a_trouve
                  then begin
                      s_pile_recherche[s_sommet_pile_recherche].indice_mere:=
                          s_pile_recherche[s_sommet_pile_recherche].indice_mere+ 1;
                      with f_pt_cellule(pv_index, l_page,
                          s_pile_recherche[s_sommet_pile_recherche].indice_mere, l_pt_fille)^ do
                      begin
                        s_sommet_pile_recherche:= s_sommet_pile_recherche+ 1;
                        s_pile_recherche[s_sommet_pile_recherche].numero_page_mere:= l_pt_fille^;
                        s_pile_recherche[s_sommet_pile_recherche].indice_mere:= 0;
                        seek(fichier_b_arbre, l_pt_fille^);
                        blockread(fichier_b_arbre, l_page, 1);
                      end;
                      while numero_page_0<> k_nil do
                      begin
                        s_sommet_pile_recherche:= s_sommet_pile_recherche+ 1;
                        s_pile_recherche[s_sommet_pile_recherche].numero_page_mere:=
                            numero_page_0;
                        s_pile_recherche[s_sommet_pile_recherche].indice_mere:= 0;
                        seek(fichier_b_arbre, numero_page_0);
                        blockread(fichier_b_arbre, l_page, 1);
                      end; 
                      s_pile_recherche[s_sommet_pile_recherche].indice_mere:= 0;
                      with f_pt_cellule(pv_index, l_page, 1, l_pt_fille)^ do
                        pv_numero_fiche:= numero_fiche;
                    end
                  else pv_numero_fiche:= k_fin_fichier;
              end; 
        end; 
      end; 

    procedure cherche_cle_precedante(var pv_index: t_index;
          var pv_numero_fiche: t_numero_page);
      var l_page: t_page;
          l_pt_fille: t_pt_fille;
          l_pt_cellule: t_pt_cellule;
          l_a_trouve: boolean;
      begin
        with pv_index, l_page, s_pile_recherche[s_sommet_pile_recherche] do
        begin
          seek(fichier_b_arbre, numero_page_mere);
          blockread(fichier_b_arbre, l_page, 1);
          if indice_mere> 0
            then begin
                with f_pt_cellule(pv_index, l_page, indice_mere, l_pt_fille)^ do
                  pv_numero_fiche:= numero_fiche;
                indice_mere:= indice_mere- 1;
              end
            else begin
                l_a_trouve:= false;
                while not l_a_trouve and (s_sommet_pile_recherche> 0) do
                begin
                  s_sommet_pile_recherche:= s_sommet_pile_recherche- 1;
                  with s_pile_recherche[s_sommet_pile_recherche] do
                  begin
                    seek(fichier_b_arbre, numero_page_mere);
                    blockread(fichier_b_arbre, l_page, 1);
                    if indice_mere>= 1
                      then l_a_trouve:= true;
                  end; 
                end; 
                if l_a_trouve
                  then begin
                      s_pile_recherche[s_sommet_pile_recherche].indice_mere:=
                          s_pile_recherche[s_sommet_pile_recherche].indice_mere- 1;
                      if s_pile_recherche[s_sommet_pile_recherche].indice_mere> 0
                        then
                          with f_pt_cellule(pv_index, l_page,
                              s_pile_recherche[s_sommet_pile_recherche].indice_mere,
                              l_pt_fille)^ do
                          begin
                            s_sommet_pile_recherche:= s_sommet_pile_recherche+ 1;
                            s_pile_recherche[s_sommet_pile_recherche].numero_page_mere:=
                                l_pt_fille^;
                            seek(fichier_b_arbre, l_pt_fille^);
                            blockread(fichier_b_arbre, l_page, 1);
                            s_pile_recherche[s_sommet_pile_recherche].indice_mere:=
                                nombre_cellules_utilisees- 1;
                          end
                        else begin
                            s_sommet_pile_recherche:= s_sommet_pile_recherche+ 1;
                            s_pile_recherche[s_sommet_pile_recherche].numero_page_mere:=
                                numero_page_0;
                            seek(fichier_b_arbre, numero_page_0);
                            blockread(fichier_b_arbre, l_page, 1);
                            s_pile_recherche[s_sommet_pile_recherche].indice_mere:=
                                nombre_cellules_utilisees- 1;
                          end;
                      while numero_page_0<> k_nil do
                      begin
                        l_pt_cellule:= f_pt_cellule(pv_index, l_page,
                            s_pile_recherche[s_sommet_pile_recherche].indice_mere+ 1,
                            l_pt_fille);
                        s_pile_recherche[s_sommet_pile_recherche+ 1].numero_page_mere:=
                            l_pt_fille^;
                        s_pile_recherche[s_sommet_pile_recherche+ 1].indice_mere:=
                            nombre_cellules_utilisees- 1;
                        s_sommet_pile_recherche:= s_sommet_pile_recherche+ 1;
                        seek(fichier_b_arbre, l_pt_fille^);
                        blockread(fichier_b_arbre, l_page, 1);
                      end; 
                      s_pile_recherche[s_sommet_pile_recherche].indice_mere:=
                          nombre_cellules_utilisees- 1;
                      with f_pt_cellule(pv_index, l_page, nombre_cellules_utilisees, l_pt_fille)^ do
                        pv_numero_fiche:= numero_fiche;
                    end
                  else pv_numero_fiche:= k_fin_fichier;
              end; 
        end; 
      end; 

    procedure ferme_index(var pv_index: t_index);
      var l_en_tete: t_en_tete_index;
      begin
        with pv_index do
        begin
          seek(fichier_b_arbre, 0); blockread(fichier_b_arbre, l_en_tete, 1);
          l_en_tete.numero_racine:= numero_racine;
          l_en_tete.numero_derniere_page:= numero_derniere_page;
          seek(fichier_b_arbre, 0); blockwrite(fichier_b_arbre, l_en_tete, 1);
          close(fichier_b_arbre);
        end; 
      end; 

  begin 
  end. 













