(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit umemo;
  interface
    uses dos, crt,
         uclavier, uerreur, uhex, uecran,
         utypcons, usaisis, uchained,
         usortie,
         uediteur;
    type t_type_page_memo= (en_tete_memo, debut_texte_memo, suite_texte_memo,
             page_effacee_memo);
         t_page_memo= record
                        case t_type_page_memo of
                          en_tete_memo : (numero_premiere_page_libre: longint;
                                          zero: longint;
                                          nom: array[0..9] of char;
                                          deux: byte;
                                          un: word;
                                          deux_deux: word);
                          debut_texte_memo : (signature_texte: word; bidon: integer;
                                              taille: longint;
                                              debut_texte: array[0..503] of char);
                          suite_texte_memo : (suite_texte: array[0..511] of char);
                          page_effacee_memo : (page_libre_suivante: longint;
                                               nombre_pages_libres: longint);
                      end;
         t_fichier_memo= record
                           nom_fichier: t_string_80;
                           fichier_memo: file;
                           numero_page_memo, numero_page_fin, premiere_page_libre: integer;
                           colonne_debut, ligne_debut, colonne_fin, ligne_fin: integer;
                           fiche_memo: t_page_memo;
                         end;
         t_pt_fichier_memo= ^t_fichier_memo;

    procedure cree_fichier_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        p_nom_memo: t_string_80);

    procedure ouvre_fichier_memo(var pv_pt_fichier_memo: t_pt_fichier_memo;
        p_nom_memo: t_string_80);

    procedure dimensionne_fenetre_memo(p_pt_fichier_memo: t_pt_fichier_memo;
          p_colonne_debut, p_ligne_debut, p_colonne_fin, p_ligne_fin: integer);

    procedure analyse_memo(p_nom_memo: t_string_80);

    procedure ferme_fichier_memo(p_pt_fichier_memo: t_pt_fichier_memo);

    procedure charge_page_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        p_numero_page: longint; var pv_pt_memo: t_pt_texte);

    procedure sauve_page_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        var pv_numero_page: longint; var pv_pt_memo: t_pt_texte);

    procedure edite_page_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        var pv_numero_page: longint);

    procedure edite_zone_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        var pv_numero_zone);

    procedure saisis_zone_memo(p_ligne, p_colonne: integer; var pv_numero_zone;
        p_pt_fichier_memo: t_pt_fichier_memo);

    procedure affiche_zone_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        var v_numero_zone);
  implementation
    const k_taille_tabulation= 8;
          k_return_d_base= #$8D;

    procedure lis_page_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        p_numero_page_memo: longint);
      begin
        with p_pt_fichier_memo^ do
        begin
          seek(fichier_memo, p_numero_page_memo);
          blockread(fichier_memo, fiche_memo, 1);
        end; 
      end; 

    procedure ecris_page_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        p_numero_page_memo: longint);
      begin
        with p_pt_fichier_memo^ do
        begin
          seek(fichier_memo, p_numero_page_memo);
          blockwrite(fichier_memo, fiche_memo, 1);
        end; 
      end; 

    procedure cree_fichier_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        p_nom_memo: t_string_80);
      begin
        new(p_pt_fichier_memo);
        with p_pt_fichier_memo^, fiche_memo do
        begin
          assign(fichier_memo, p_nom_memo);
          rewrite(fichier_memo, 512);
          fillchar(fiche_memo, 512, 0);
          numero_premiere_page_libre:= 1;
          delete(p_nom_memo, 1, 2);
          move(p_nom_memo[1], nom, length(p_nom_memo));
          deux:= 2;
          un:= 1;
          deux_deux:= 2;
          colonne_debut:= 6; ligne_debut:= 6; colonne_fin:= 50; ligne_fin:= 18;
          ecris_page_memo(p_pt_fichier_memo, 0);
          close(fichier_memo);
        end; 
        dispose(p_pt_fichier_memo);
      end; 

    procedure ouvre_fichier_memo(var pv_pt_fichier_memo: t_pt_fichier_memo;
        p_nom_memo: t_string_80);
      begin
        new(pv_pt_fichier_memo);
        with pv_pt_fichier_memo^ do
        begin
          assign(fichier_memo, p_nom_memo);
          reset(fichier_memo, 512);
          lis_page_memo(pv_pt_fichier_memo, 0);
          premiere_page_libre:= fiche_memo.numero_premiere_page_libre;
          numero_page_memo:= 0;
        end; 
      end; 

    procedure dimensionne_fenetre_memo(p_pt_fichier_memo: t_pt_fichier_memo;
          p_colonne_debut, p_ligne_debut, p_colonne_fin, p_ligne_fin: integer);
      begin
        with p_pt_fichier_memo^ do
        begin
          colonne_debut:= p_colonne_debut; ligne_debut:= p_ligne_debut;
          colonne_fin:= p_colonne_fin; ligne_fin:= p_ligne_fin;
        end; 
      end; 

    procedure analyse_memo(p_nom_memo: t_string_80);
      var l_pt_fichier_memo: t_pt_fichier_memo;
          l_numero_page: longint;
          l_taille: longint;
      begin 
        ouvre_fichier_memo(l_pt_fichier_memo, p_nom_memo);
        with l_pt_fichier_memo^, g_sortie do
        begin
          writeln(sortie, 'premire page libre: ',  premiere_page_libre, ' ',
              filesize(fichier_memo));
          seek(fichier_memo, 1);
          if premiere_page_libre= filesize(fichier_memo)
            then writeln(sortie, 'toutes les pages sont prises')
            else begin
                writeln(sortie, 'affiche les pages libres:');
                while premiere_page_libre< filesize(fichier_memo) do
                  with fiche_memo do
                  begin
                    write(sortie, premiere_page_libre: 5, ' ');
                    seek(fichier_memo, premiere_page_libre);
                    blockread(fichier_memo, fiche_memo, 1);
                    if page_libre_suivante= filesize(fichier_memo)
                      then write(sortie, ' fin fichier');
                    writeln(sortie);
                    premiere_page_libre:= page_libre_suivante;
                  end; 
              end;
          writeln(sortie);
          writeln(sortie, 'liste squentiellement les pages utilises: ');
          l_numero_page:= 1;
          seek(fichier_memo, 1);
          while l_numero_page< filesize(fichier_memo) do
          begin
            blockread(fichier_memo, fiche_memo, 1);
            with fiche_memo do
            begin
              write(sortie, l_numero_page: 4, ' ', l_numero_page* 512: 6,
                 signature_texte: 6, ' ');
              if (signature_texte= 65535) and (bidon= 8)
                then begin
                    writeln(sortie, 'un texte de       ', taille: 6, ' octets');
                    for l_taille:= 1 to ((taille+ 511) div 512)- 1 do
                    begin
                      l_numero_page:= l_numero_page+ 1;
                      blockread(fichier_memo, fiche_memo, 1);
                    end
                  end
                else
                  if bidon= 0
                    then begin
                        writeln(sortie, 'une page libre de ', taille: 6, ' * 512 octets');
                        for l_taille:= 2 to nombre_pages_libres do
                        begin
                          l_numero_page:= l_numero_page+ 1;
                          blockread(fichier_memo, fiche_memo, 1);
                        end
                      end
                    else begin
                        writeln(sortie, 'bug ');
                      end;
            end; 
            l_numero_page:= l_numero_page+ 1;
          end; 
        end; 
        ferme_fichier_memo(l_pt_fichier_memo);
      end; 

    procedure ferme_fichier_memo(p_pt_fichier_memo: t_pt_fichier_memo);
      begin
        close(p_pt_fichier_memo^.fichier_memo);
        dispose(p_pt_fichier_memo);
      end; 

    procedure charge_page_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        p_numero_page: longint; var pv_pt_memo: t_pt_texte);
      var l_quantite: integer;
          l_taille: integer;

      procedure charge_la_zone_memo;

        procedure ajoute_return_interligne;
          begin
            with pv_pt_memo^ do
            begin
              (*$r-*)
              if pt_tampon_texte^[fin_texte- 1]<> k_RETURN
              (*$r+*)
                then begin
                    pt_tampon_texte^[fin_texte]:= k_return;
                    fin_texte:= fin_texte+ 1;
                  end;
              pt_tampon_texte^[fin_texte]:= #10;
              fin_texte:= fin_texte+ 1;
            end; 
          end; 

        begin 
          with p_pt_fichier_memo^, fiche_memo, pv_pt_memo^ do
          begin
            fin_texte:= 0;
            numero_page_fin:= p_numero_page;
            if numero_page_fin= 0
              then ajoute_return_interligne
              else begin
                  lis_page_memo(p_pt_fichier_memo, numero_page_fin);
                  numero_page_fin:= numero_page_fin+ 1;
                  l_taille:= taille- 8;
                  if l_taille> texte_max
                    then begin
                        writeln('texte trop gros. Tronque  ', texte_max);
                        l_taille:= texte_max;
                      end;
                    l_quantite:= l_taille;
                    if l_quantite> 504
                      then l_quantite:= 504;
                    move(debut_texte, pt_tampon_texte^[fin_texte], l_quantite);
                    l_taille:= l_taille- l_quantite;
                    fin_texte:= fin_texte+ l_quantite;
                    while l_taille> 0 do
                    begin
                      lis_page_memo(p_pt_fichier_memo, numero_page_fin);
                      numero_page_fin:= numero_page_fin+ 1;
                      l_quantite:= l_taille;
                      if l_quantite> 512
                        then l_quantite:= 512;
                      move(suite_texte, pt_tampon_texte^[fin_texte], l_quantite);
                      l_taille:= l_taille- l_quantite;
                      fin_texte:= fin_texte+ l_quantite;
                    end; 
                end; 
            if pt_tampon_texte^[fin_texte- 1]= #26
              then fin_texte:= fin_texte- 1;
            if (pt_tampon_texte^[fin_texte- 1]<> #10)
                or (pt_tampon_texte^[fin_texte- 2]<> #13)
              then ajoute_return_interligne;
          end; 
        end; 

      procedure decompresse_les_tabulations;
        var l_indice: integer;
            l_colonne, l_nombre_espaces, l_taille_fin: integer;
            l_indice_debut_ligne, l_colonne_teste: integer;
        begin
          with pv_pt_memo^ do
          begin
            l_indice:= 0; l_colonne:= 0;
            l_indice_debut_ligne:= 0;
            while l_indice< fin_texte do
            begin
              case pt_tampon_texte^[l_indice] of
                k_tabule : begin
                             l_nombre_espaces:= k_taille_tabulation
                                 - (l_colonne mod k_taille_tabulation);
                             l_colonne:= l_colonne+ l_nombre_espaces;
                             l_taille_fin:= fin_texte- l_indice;
                             if l_taille_fin > 0
                               then begin
                                   move(pt_tampon_texte^[l_indice],
                                        pt_tampon_texte^[l_indice+ l_nombre_espaces- 1],
                                        l_taille_fin);
                                 end;
                             fillchar(pt_tampon_texte^[l_indice], l_nombre_espaces, '+');
                             l_indice:= l_indice+ l_nombre_espaces- 1;
                             fin_texte:= fin_texte+ l_nombre_espaces;
                           end; 
                k_return : begin
                             l_colonne:= -1;
                             l_indice_debut_ligne:= l_indice+ 2;
                           end;
                k_return_d_base : begin
                                    pt_tampon_texte^[l_indice]:= k_return;
                                    l_colonne:= -1;
                                    l_indice_debut_ligne:= l_indice+ 2;
                                  end;
                else
                  l_colonne:= l_colonne+ 1;
              end; 
              l_indice:= l_indice+ 1;
            end; 
          end; 
        end; 

      begin 
        charge_la_zone_memo;
        decompresse_les_tabulations;
      end; 

    procedure sauve_page_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        var pv_numero_page: longint; var pv_pt_memo: t_pt_texte);

      procedure sauve_la_zone_memo;
        var l_nombre_pages, l_nombre_pages_precedent: integer;

        procedure met_a_jour_numero_premiere_page_libre(p_numero_page_libre: word);
          begin
            with p_pt_fichier_memo^, fiche_memo do
            begin
              premiere_page_libre:= p_numero_page_libre;
              lis_page_memo(p_pt_fichier_memo, 0);
              numero_premiere_page_libre:= p_numero_page_libre;
              ecris_page_memo(p_pt_fichier_memo, 0);
            end; 
          end; 

        procedure libere_pages(p_numero_page, p_nombre_pages: longint);
          var l_page_memo: t_page_memo;
          begin
            if p_nombre_pages> 0
              then
                with p_pt_fichier_memo^, fiche_memo do
                begin
                  fillchar(l_page_memo, 512, 0);
                  l_page_memo.page_libre_suivante:= premiere_page_libre;
                  l_page_memo.nombre_pages_libres:= p_nombre_pages;
                  seek(fichier_memo, p_numero_page);
                  blockwrite(fichier_memo, l_page_memo, 1);
                  met_a_jour_numero_premiere_page_libre(p_numero_page);
                end;
          end; 

        procedure cherche_trou(p_nombre_pages: longint; var pv_numero_page: longint);
          var l_page_memo: t_page_memo;
              l_taille_trou: longint;
              l_trou_precedent: longint;
          begin 
            with p_pt_fichier_memo^, fiche_memo do
            begin
              pv_numero_page:= premiere_page_libre; l_taille_trou:= 0;
              while (pv_numero_page< filesize(fichier_memo))
                  and (l_taille_trou< p_nombre_pages) do
              begin
                l_trou_precedent:= pv_numero_page;
                seek(fichier_memo, pv_numero_page);
                blockread(fichier_memo, l_page_memo, 1);
                l_taille_trou:= nombre_pages_libres;
                if l_taille_trou< p_nombre_pages
                  then pv_numero_page:= page_libre_suivante;
              end; 
              if pv_numero_page= filesize(fichier_memo)
                then met_a_jour_numero_premiere_page_libre(premiere_page_libre
                    + p_nombre_pages)
                else
                  if l_taille_trou> p_nombre_pages
                    then begin
                        l_page_memo.nombre_pages_libres:=
                            l_page_memo.nombre_pages_libres- p_nombre_pages;
                        seek(fichier_memo, premiere_page_libre+ p_nombre_pages);
                        blockwrite(fichier_memo, l_page_memo, 1);
                        if pv_numero_page= premiere_page_libre
                          then 
                               met_a_jour_numero_premiere_page_libre(premiere_page_libre
                                   + p_nombre_pages)
                          else begin
                              seek(fichier_memo, l_trou_precedent);
                              blockread(fichier_memo, l_page_memo, 1);
                              l_page_memo.page_libre_suivante:=
                                  premiere_page_libre+ p_nombre_pages;
                              seek(fichier_memo, l_trou_precedent);
                              blockwrite(fichier_memo, l_page_memo, 1);
                            end; 
                      end; 
            end; 
          end; 

        procedure ecris_pages(p_numero_page, p_nombre_pages: longint);
          var l_quantite: longint;
          begin
            with p_pt_fichier_memo^, fiche_memo, pv_pt_memo^ do
            begin
              signature_texte:= $FFFF;
              bidon:= 8;
              taille:= fin_texte+ 8;
              l_quantite:= fin_texte;
              if l_quantite> 504
                then l_quantite:= 504;
              move(pt_tampon_texte^[0], debut_texte, l_quantite);
              ecris_page_memo(p_pt_fichier_memo, p_numero_page);
              if p_nombre_pages> 1
                then blockwrite(fichier_memo,
                    pv_pt_memo^.pt_tampon_texte^[l_quantite], p_nombre_pages- 1);
            end; 
          end; 

        begin 
          with p_pt_fichier_memo^, fiche_memo, pv_pt_memo^ do
          begin
            l_nombre_pages:= (8+ fin_texte+ 511) div 512;
            l_nombre_pages_precedent:= numero_page_fin- pv_numero_page;
            if l_nombre_pages= l_nombre_pages_precedent
              then ecris_pages(pv_numero_page, l_nombre_pages)
              else begin
                  if l_nombre_pages> l_nombre_pages_precedent
                    then begin
                        libere_pages(pv_numero_page, l_nombre_pages_precedent);
                        cherche_trou(l_nombre_pages, pv_numero_page);
                        ecris_pages(pv_numero_page, l_nombre_pages);
                      end
                    else begin
                        ecris_pages(pv_numero_page, l_nombre_pages);
                        numero_page_fin:= pv_numero_page+ l_nombre_pages;
                        libere_pages(numero_page_fin, l_nombre_pages_precedent- l_nombre_pages);
                      end;
                end; 
          end; 
        end; 

      begin 
        sauve_la_zone_memo;
      end; 

    procedure edite_page_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        var pv_numero_page: longint);
      var l_pt_texte_memo: t_pt_texte;
      begin 
        with p_pt_fichier_memo^, fiche_memo do
        begin
          alloue_texte(l_pt_texte_memo, nom_fichier, k_texte_max);
          charge_page_memo(p_pt_fichier_memo, pv_numero_page, l_pt_texte_memo);
          dimensionne_fenetre(l_pt_texte_memo, colonne_debut, ligne_debut, colonne_fin, ligne_fin);
          edite_texte(l_pt_texte_memo, nom_fichier);
          if l_pt_texte_memo^.a_modifie_texte
            then sauve_page_memo(p_pt_fichier_memo, pv_numero_page, l_pt_texte_memo);
          libere_texte(l_pt_texte_memo);
        end; 
      end; 

    procedure edite_zone_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        var pv_numero_zone);
      var l_numero_page_memo: longint;
          l_indice_erreur: integer;
          l_chaine_zero: array[0..9] of char absolute pv_numero_zone;
      begin
        convertis_chaine_db_en_longint(pv_numero_zone, 10, l_numero_page_memo, l_indice_erreur);
        if l_indice_erreur= 11
          then begin
              l_numero_page_memo:= 0;
              l_indice_erreur:= 0;
            end; 
        if l_indice_erreur= 0
          then begin
              edite_page_memo(p_pt_fichier_memo, l_numero_page_memo);
              convertis_longint_en_chaine_db(l_numero_page_memo, 10, l_chaine_zero);
            end
          else begin
              write(' erreur numro mmo ', l_indice_erreur, ' ');
              readln;
            end;
      end; 

    procedure saisis_zone_memo(p_ligne, p_colonne: integer; var pv_numero_zone;
        p_pt_fichier_memo: t_pt_fichier_memo);
      var l_sauve_ecran: t_ecran;
      begin
        with g_parametres_saisie do
        begin
          gotoxy(p_colonne, p_ligne);
          repeat
            lis_touche(caractere_sortie_de_champ);
            if not (caractere_sortie_de_champ in (caracteres_sortie_de_champ+ [k_controle_home]))
              then sonne;
          until caractere_sortie_de_champ in (caracteres_sortie_de_champ+ [k_controle_home]);
          if caractere_sortie_de_champ= k_controle_home
            then begin
                if p_pt_fichier_memo<> nil
                  then begin
                      sauve_ecran(l_sauve_ecran);
                      edite_zone_memo(p_pt_fichier_memo, pv_numero_zone);
                      restaure_ecran(l_sauve_ecran);
                    end;
                gotoxy(p_colonne, p_ligne);
                repeat
                  lis_touche(caractere_sortie_de_champ);
                  if not (caractere_sortie_de_champ in caracteres_sortie_de_champ)
                    then sonne;
                until caractere_sortie_de_champ in caracteres_sortie_de_champ;
              end;
        end; 
      end; 

    procedure affiche_zone_memo(p_pt_fichier_memo: t_pt_fichier_memo;
        var v_numero_zone);
      var l_numero_page_memo: longint;
          l_indice_erreur: integer;
          l_pt_memo: t_pt_texte;
          l_indice: integer;
      begin 
        with p_pt_fichier_memo^, fiche_memo, g_sortie do
        begin
          alloue_texte(l_pt_memo, nom_fichier, k_texte_max);
          convertis_chaine_db_en_longint(v_numero_zone, 10, l_numero_page_memo, l_indice_erreur);
          if l_indice_erreur= 11
            then begin
                write(sortie, '');
              end
            else
              if l_indice_erreur= 0
                then begin
                    charge_page_memo(p_pt_fichier_memo, l_numero_page_memo, l_pt_memo);
                    with l_pt_memo^ do
                      for l_indice:= 0 to fin_texte- 1 do
                        write(sortie, pt_tampon_texte^[l_indice]);
                  end
                else begin
                    write(' erreur numro mmo ', l_indice_erreur, ' ');
                    readln;
                  end;
         libere_texte(l_pt_memo);
       end; 
      end; 

  begin 
  end. 










