(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+,v-*)
unit urapport;
  interface
    uses crt,
         usaisis, uclavier,
         utypcons, uchained,
         uerreur, uhex,
         uecran, usortie, uaffiche,
         udonnees;
    const k_taille_titre_rapport_max= 255;
          k_colonne_max= 512;
          k_avec_cadre= true;
          k_sans_cadre= false;
    type 
         t_type_trait= (simple, double_horizontal, double_vertical, double);
         t_position_trait= (horizontal,
                            nord_ouest, nord,   nord_est,
                            ouest,      centre, est,
                            sud_ouest,  sud,    sud_est,
                            vertical);
         t_trait_cadre= array[0..k_colonne_max] of char;
         t_pt_trait_cadre= ^t_trait_cadre;
    type t_texte_titre_rapport= string[k_taille_titre_rapport_max];
         t_pt_gabarit_max= ^t_gabarit_max;
         t_pt_donnee_rapport= ^t_donnee_rapport;
         t_donnee_rapport= record
                             colonne_trait_gauche: integer;
                             ligne_donnee, colonne_donnee,
                             taille_donnee, decimales_donnee: integer;
                             pt_descripteur_de_zone: t_pt_descripteur_de_zone;
                             pt_donnee_suivante: t_pt_donnee_rapport;
                             gabarit_donnee: t_gabarit_max;
                           end;
         t_pt_titre_rapport= ^t_titre_rapport;
         t_titre_rapport= record
                            ligne_titre, colonne_titre: integer;
                            pt_titre_suivant: t_pt_titre_rapport;
                            titre: t_texte_titre_rapport;
                          end;
         t_pt_page_rapport= ^t_page_rapport;
         t_page_rapport= record
                           numero_page: integer;
                           pt_titre_page: t_pt_titre_rapport;
                           pt_donnee_debut, pt_donnee_fin: t_pt_donnee_rapport;
                           pt_titre_debut, pt_titre_fin: t_pt_titre_rapport;
                           taille_ligne: integer;
                           pt_trait_cadre_superieur, pt_trait_cadre_debut_donnees,
                             pt_trait_cadre_inferieur: t_pt_trait_cadre;
                           pt_page_rapport_suivante: t_pt_page_rapport;
                         end;
         t_rapport= record
                      teste_rapport: boolean;
                      pt_titre_rapport: t_pt_titre_rapport;
                      marge_haute, hauteur_titre_debut_page_rapport, hauteur_titres_donnees,
                        marge_basse, hauteur_cadre: integer;
                      lignes_par_page: integer;
                      colonne_max: integer;
                      pt_page_debut, pt_page_fin: t_pt_page_rapport;
                    end;

    procedure initialise_rapport_standard(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_rapport: t_rapport; p_ligne_max, p_colonne_max: integer);

    procedure affiche_parametres_rapport(p_rapport: t_rapport);

    procedure edite_rapport(p_pt_fichier_donnees: t_pt_fichier_donnees; p_rapport: t_rapport);

    procedure libere_rapport(var pv_rapport: t_rapport);
  implementation
    var s_graphique: array[horizontal..vertical, simple..double] of char;

    procedure ejecte_page(p_rapport: t_rapport);
      var l_ligne: integer;
      begin
        with p_rapport, g_sortie do
        begin
          for l_ligne:= ligne_sortie to lignes_par_page do
            va_a_la_ligne;
          ligne_sortie:= 1;
          if (nom_sortie= '') or (nom_sortie= 'CON')
            then begin
                gotoxy(79, 1); write('?'); stoppe;
                clrscr;
              end;
        end;
      end; 

    procedure imprime_les_titres_des_donnees(p_pt_page: t_pt_page_rapport);
      var l_pt_titre: t_pt_titre_rapport;
          l_pt_donnee: t_pt_donnee_rapport;
      begin
        with g_sortie, p_pt_page^ do
        begin
          imprime_chaine_db(s_graphique[vertical, double], 1);
          l_pt_titre:= pt_titre_debut;
          l_pt_donnee:= pt_donnee_debut;
          while l_pt_titre<> nil do
          begin
            with l_pt_titre^ do
            begin
              positionne_sortie(ligne_sortie, colonne_titre);
              imprime_chaine_db(titre[1], length(titre));
            end; 
            l_pt_titre:= l_pt_titre^.pt_titre_suivant;
            l_pt_donnee:= l_pt_donnee^.pt_donnee_suivante;
            if l_pt_donnee<> nil
              then
                with l_pt_donnee^ do
                begin
                  positionne_sortie(ligne_sortie, colonne_trait_gauche);
                  imprime_chaine_db(s_graphique[vertical, simple], 1);
                end;
          end; 
          positionne_sortie(ligne_sortie, taille_ligne);
          imprime_chaine_db(s_graphique[vertical, double], 1);
          va_a_la_ligne;
        end; 
      end; 

    procedure imprime_donnee(p_pt_donnee: t_pt_donnee_rapport);
      begin
        with p_pt_donnee^ do
        begin
          positionne_sortie(ligne_donnee, colonne_donnee);
          with pt_descripteur_de_zone^ do
             case type_zone of
               'C' : imprime_chaine_db(pt_valeur_zone^, taille_donnee);
               'N' : imprime_chaine_db(pt_valeur_zone^, taille_donnee);
               'L' : imprime_chaine_db(pt_valeur_zone^, 1);
               'D' : imprime_chaine_db(pt_valeur_zone^, 8);
               'M' : ;
             end; 
        end; 
      end; 

    procedure imprime_les_donnees(p_pt_page: t_pt_page_rapport);
      var l_pt_donnee: t_pt_donnee_rapport;
      begin
        with g_sortie, p_pt_page^ do
        begin
          imprime_chaine_db(s_graphique[vertical, double], 1);
          l_pt_donnee:= pt_donnee_debut;
          while l_pt_donnee<> nil do
          begin
            imprime_donnee(l_pt_donnee);
            l_pt_donnee:= l_pt_donnee^.pt_donnee_suivante;
            if l_pt_donnee<> nil
              then
                with l_pt_donnee^ do
                begin
                  positionne_sortie(ligne_sortie, colonne_trait_gauche);
                  imprime_chaine_db(s_graphique[vertical, simple], 1);
                end;
          end; 
          positionne_sortie(ligne_sortie, taille_ligne);
          imprime_chaine_db(s_graphique[vertical, double], 1);
          va_a_la_ligne;
        end; 
      end; 

    procedure imprime_une_fiche_par_page;
      begin
      end; 
    procedure edite_rapport(p_pt_fichier_donnees: t_pt_fichier_donnees; p_rapport: t_rapport);
      var l_pt_page: t_pt_page_rapport;
          l_numero_fiche_courante: integer;
          l_hauteur_donnees, l_ligne_donnees: integer;
      procedure construis_cadres;
        var l_pt_page: t_pt_page_rapport;
        procedure construis_cadres_de_la_page(p_pt_page: t_pt_page_rapport);
          var l_pt_donnee: t_pt_donnee_rapport;
              l_colonne_separateur: integer;
          procedure initialise_trait(var pv_pt_trait: t_pt_trait_cadre;
              p_debut, p_milieu, p_fin: char);
            begin
              with l_pt_page^ do
              begin
                getmem(pv_pt_trait, taille_ligne);
                pv_pt_trait^[0]:= p_debut;
                fillchar(pv_pt_trait^[1], taille_ligne- 2, p_milieu);
                pv_pt_trait^[taille_ligne- 1]:= p_fin;
              end; 
            end; 
          begin 
            with l_pt_page^ do
            begin
              initialise_trait(pt_trait_cadre_superieur, s_graphique[nord_ouest, double],
                               s_graphique[horizontal, double], s_graphique[nord_est, double]);
              initialise_trait(pt_trait_cadre_debut_donnees, s_graphique[ouest, double_vertical],
                               s_graphique[horizontal, double], s_graphique[est, double_vertical]);
              initialise_trait(pt_trait_cadre_inferieur, s_graphique[sud_ouest, double],
                               s_graphique[horizontal, double], s_graphique[sud_est, double]);
              l_pt_donnee:= pt_donnee_debut^.pt_donnee_suivante;
              while l_pt_donnee<> nil do
              begin
                l_colonne_separateur:= l_pt_donnee^.colonne_trait_gauche- 1;
                pt_trait_cadre_superieur^[l_colonne_separateur]:=
                    s_graphique[nord, double_horizontal];
                pt_trait_cadre_debut_donnees^[l_colonne_separateur]:=
                    s_graphique[nord, double_horizontal];
                pt_trait_cadre_inferieur^[l_colonne_separateur]:=
                    s_graphique[sud, double_horizontal];
                l_pt_donnee:= l_pt_donnee^.pt_donnee_suivante;
              end;
            end; 
          end; 
        begin 
          with p_rapport do
          begin
            l_pt_page:= pt_page_debut;
            while l_pt_page<> nil do
            begin
              construis_cadres_de_la_page(l_pt_page);
              l_pt_page:= l_pt_page^.pt_page_rapport_suivante;
            end; 
          end; 
        end; 
      procedure imprime_trait_cadre(p_pt_trait: t_pt_trait_cadre);
        begin
          with l_pt_page^ do
            if p_pt_trait<> nil
              then imprime_chaine_db_ligne(p_pt_trait^, taille_ligne);
        end; 
      procedure libere_traits;
        var l_pt_page: t_pt_page_rapport;
        begin
          with p_rapport do
          begin
            l_pt_page:= pt_page_debut;
            while l_pt_page<> nil do
            begin
              with l_pt_page^ do
              begin
                freemem(pt_trait_cadre_superieur, taille_ligne);
                freemem(pt_trait_cadre_debut_donnees, taille_ligne);
                freemem(pt_trait_cadre_inferieur, taille_ligne);
              end;
              l_pt_page:= l_pt_page^.pt_page_rapport_suivante;
            end; 
          end; 
        end; 
      begin 
        with p_rapport, g_sortie do
        begin
          l_hauteur_donnees:= lignes_par_page- marge_haute- hauteur_titre_debut_page_rapport
             - hauteur_titres_donnees- hauteur_cadre- marge_basse;
          construis_cadres;
          while not f_fin_fichier_donnees(p_pt_fichier_donnees) do
          begin
            l_pt_page:= pt_page_debut;
            while l_pt_page<> nil do
              with l_pt_page^ do
              begin
                l_numero_fiche_courante:= f_numero_fiche_courante(p_pt_fichier_donnees);
                imprime_trait_cadre(pt_trait_cadre_superieur);
                imprime_les_titres_des_donnees(l_pt_page);
                imprime_trait_cadre(pt_trait_cadre_debut_donnees);
                l_ligne_donnees:= 1;
                while not f_fin_fichier_donnees(p_pt_fichier_donnees)
                  and (l_ligne_donnees<= l_hauteur_donnees) do
                begin
                  lis_fiche_courante(p_pt_fichier_donnees);
                  imprime_les_donnees(l_pt_page);
                  l_ligne_donnees:= l_ligne_donnees+ 1;
                end; 
                imprime_trait_cadre(pt_trait_cadre_inferieur);
                ejecte_page(p_rapport);
                l_pt_page:= l_pt_page^.pt_page_rapport_suivante;
                if l_pt_page<> nil
                  then positionne_fiche_courante(p_pt_fichier_donnees, l_numero_fiche_courante);
              end; 
          end; 
          libere_traits;
        end; 
      end; 
    procedure affiche_parametres_une_donnee(p_pt_donnee: t_pt_donnee_rapport);
      begin
        with p_pt_donnee^ do
          write(pt_descripteur_de_zone^.nom_zone, pt_descripteur_de_zone^.type_zone: 3,
                ligne_donnee: 7, colonne_donnee: 6, taille_donnee: 8, decimales_donnee: 8,
                ' ', gabarit_donnee,
                ' ', f_pointeur_hexadecimal(pt_descripteur_de_zone^.pt_valeur_zone),
                colonne_trait_gauche: 3);
      end; 
    procedure affiche_parametres_un_titre(p_pt_titre: t_pt_titre_rapport);
      begin
        with p_pt_titre^ do
          write(ligne_titre: 7, colonne_titre: 6, ' ', titre, '<');
      end; 
    procedure affiche_parametres_rapport(p_rapport: t_rapport);
      var l_pt_page: t_pt_page_rapport;
          l_pt_donnee: t_pt_donnee_rapport;
          l_pt_titre: t_pt_titre_rapport;
      begin
        with p_rapport do
        begin
          writeln(' page nom-zone  type ligne colonne taille decimales gabarit');
          l_pt_page:= pt_page_debut;
          while l_pt_page<> nil do
          begin
            with l_pt_page^ do
            begin
              l_pt_donnee:= pt_donnee_debut;
              while l_pt_donnee<> nil do
              begin
                write(numero_page: 3, ' ');
                affiche_parametres_une_donnee(l_pt_donnee); writeln;
                l_pt_donnee:= l_pt_donnee^.pt_donnee_suivante;
              end; 
            end; 
            l_pt_page:= l_pt_page^.pt_page_rapport_suivante;
          end; 
          writeln(' page ligne colonne titre');
          l_pt_page:= pt_page_debut;
          while l_pt_page<> nil do
          begin
            with l_pt_page^ do
            begin
              l_pt_titre:= pt_titre_debut;
              while l_pt_titre<> nil do
              begin
                write(numero_page: 3, ' ', taille_ligne);
                affiche_parametres_un_titre(l_pt_titre); writeln;
                l_pt_titre:= l_pt_titre^.pt_titre_suivant;
              end; 
            end; 
            l_pt_page:= l_pt_page^.pt_page_rapport_suivante;
          end; 
        end; 
      end; 
    procedure stocke_titre(var pv_titre; p_texte_titre: t_texte_titre_rapport);
      begin
      end; 
    procedure initialise_parametres_rapport(var pv_rapport: t_rapport;
         p_titre_general: t_texte_titre_rapport;
         p_avec_cadre: boolean;
         p_marge_haute, p_marge_basse, p_lignes_par_page, p_colonne_max: integer);
      begin
        fillchar(pv_rapport, sizeof(pv_rapport), 0);
        with pv_rapport do
        begin
          if p_titre_general<> ''
            then stocke_titre(pt_titre_rapport, p_titre_general);
          if p_avec_cadre
            then hauteur_cadre:= 2;
          marge_haute:= p_marge_haute;
          marge_basse:= p_marge_basse;
          lignes_par_page:= p_lignes_par_page;
          pv_rapport.colonne_max:= p_colonne_max;
          pt_page_debut:= nil;
          pt_page_fin:= nil;
        end; 
      end; 
    procedure cree_page(var pv_rapport: t_rapport; p_numero_page: integer);
      var l_pt_page: t_pt_page_rapport;
      begin
        new(l_pt_page);
        with l_pt_page^ do
        begin
          pt_titre_debut:= nil; pt_titre_fin:= nil;
          pt_donnee_debut:= nil; pt_donnee_fin:= nil;
          pt_page_rapport_suivante:= nil;
          numero_page:= p_numero_page;
          taille_ligne:= 1;
        end; 
        with pv_rapport do
        begin
          if pt_page_debut= nil
            then pt_page_debut:= l_pt_page
            else pt_page_fin^.pt_page_rapport_suivante:= l_pt_page;
          pt_page_fin:= l_pt_page;
        end; 
      end; 
    procedure initialise_donnee(var pv_rapport: t_rapport;
        p_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
        p_numero_page, p_ligne, p_colonne, p_taille, p_decimales: integer;
        p_gabarit: t_gabarit_max;
        p_position_tampon: integer);
      var l_pt_donnee: t_pt_donnee_rapport;
      procedure ajoute_donnee(p_pt_page: t_pt_page_rapport; p_pt_donnee: t_pt_donnee_rapport);
        begin
          with p_pt_page^ do
          begin
            if pt_donnee_debut= nil
              then pt_donnee_debut:= p_pt_donnee
              else pt_donnee_fin^.pt_donnee_suivante:= p_pt_donnee;
            pt_donnee_fin:= p_pt_donnee;
          end; 
        end; 
      begin 
        getmem(l_pt_donnee, sizeof(t_donnee_rapport)- k_taille_gabarit_max
            + length(p_gabarit));
        with l_pt_donnee^ do
        begin
          pt_descripteur_de_zone:= p_pt_descripteur_de_zone;
          colonne_trait_gauche:= p_colonne- 1;
          ligne_donnee:= p_ligne; colonne_donnee:= p_colonne;
          taille_donnee:= p_taille;
          decimales_donnee:= p_decimales;
          gabarit_donnee:= p_gabarit;
          pt_donnee_suivante:= nil;
          with pv_rapport do
          begin
            if pt_page_debut= nil
              then cree_page(pv_rapport, p_numero_page)
              else
                if p_numero_page> pt_page_fin^.numero_page
                  then cree_page(pv_rapport, p_numero_page);
            ajoute_donnee(pv_rapport.pt_page_fin, l_pt_donnee);
            pv_rapport.pt_page_fin^.taille_ligne:=
              pv_rapport.pt_page_fin^.taille_ligne+ p_taille+ 1;
          end; 
        end; 
      end; 
    procedure initialise_titre(var pv_rapport: t_rapport;
        p_numero_page, p_ligne, p_colonne: integer;
        p_texte_titre: t_texte_titre_rapport);
      var l_pt_titre: t_pt_titre_rapport;
      procedure ajoute_titre(p_pt_page: t_pt_page_rapport; p_pt_titre: t_pt_titre_rapport);
        begin
          with p_pt_page^ do
          begin
            if pt_titre_debut= nil
              then pt_titre_debut:= p_pt_titre
              else pt_titre_fin^.pt_titre_suivant:= p_pt_titre;
            pt_titre_fin:= p_pt_titre;
          end; 
        end; 
      begin 
        getmem(l_pt_titre,
          sizeof(t_titre_rapport)- k_taille_titre_rapport_max+ length(p_texte_titre));
        with l_pt_titre^do
        begin
          ligne_titre:= p_ligne; colonne_titre:= p_colonne;
          titre:= p_texte_titre;
          pt_titre_suivant:= nil;
          with pv_rapport do
          begin
            if pt_page_debut= nil
              then cree_page(pv_rapport, p_numero_page)
              else
                if p_numero_page> pt_page_fin^.numero_page
                  then cree_page(pv_rapport, p_numero_page);
            ajoute_titre(pv_rapport.pt_page_fin, l_pt_titre);
          end; 
        end; 
      end; 
    procedure initialise_donnee_et_titre(var pv_rapport: t_rapport;
        p_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
        p_gabarit: t_gabarit_max; p_titre: t_texte_titre_rapport);
      const kt_page_rapport: integer= 0;
            kt_colonne_courante: integer= 2;
      begin 
        with pv_rapport, p_pt_descripteur_de_zone^ do
        begin
          if pt_page_debut= nil
            then begin
                kt_page_rapport:= 0;
                kt_colonne_courante:= 2;
              end;
          if kt_colonne_courante+ taille_zone> colonne_max
            then begin
                kt_page_rapport:= kt_page_rapport+ 1;
                kt_colonne_courante:= 2;
              end;
          case type_zone of
            'C' : initialise_donnee(pv_rapport,
                    p_pt_descripteur_de_zone,
                    kt_page_rapport, 2, kt_colonne_courante, taille_zone, 0,
                     '', 0);
            'N' : initialise_donnee(pv_rapport,
                    p_pt_descripteur_de_zone,
                    kt_page_rapport, 2, kt_colonne_courante, taille_zone, decimales_zone,
                    '', 0);
            'L' : initialise_donnee(pv_rapport,
                    p_pt_descripteur_de_zone,
                    kt_page_rapport, 2, kt_colonne_courante, 1, 0,
                    '', 0);
            'D' : initialise_donnee(pv_rapport,
                    p_pt_descripteur_de_zone,
                    kt_page_rapport, 2, kt_colonne_courante, 8, 0,
                    '', 0);
            'M' : initialise_donnee(pv_rapport,
                    p_pt_descripteur_de_zone,
                    kt_page_rapport, 2, kt_colonne_courante, 1, 0,
                    '', 0);
          end; 
          if length(p_titre)> taille_zone
            then p_titre[0]:= chr(taille_zone);
          initialise_titre(pv_rapport,
                      kt_page_rapport, 2, kt_colonne_courante,
                      p_titre);
          kt_colonne_courante:= kt_colonne_courante+ taille_zone+ 1;
        end; 
      end; 
    procedure initialise_rapport_standard(p_pt_fichier_donnees: t_pt_fichier_donnees;
        var pv_rapport: t_rapport; p_ligne_max, p_colonne_max: integer);
      var l_numero_zone: integer;
          l_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
          l_nom: t_texte_titre_rapport;
      begin
        initialise_parametres_rapport(pv_rapport, 'AHA', k_avec_cadre, 1, 1,
          p_ligne_max, p_colonne_max);
        for l_numero_zone:= 0 to f_nombre_zones(p_pt_fichier_donnees)- 1 do
        begin
          l_pt_descripteur_de_zone:=
              f_pt_descripteur_zone(p_pt_fichier_donnees, l_numero_zone);
          convertis_chaine_db_en_string(l_pt_descripteur_de_zone^.nom_zone, 10, l_nom);
          initialise_donnee_et_titre(pv_rapport, l_pt_descripteur_de_zone, '', l_nom);
        end; 
        pv_rapport.teste_rapport:= false;
      end; 
    procedure libere_rapport(var pv_rapport: t_rapport);
      var l_pt_page, l_pt_page_a_liberer: t_pt_page_rapport;
          l_pt_champ, l_pt_champ_a_liberer: t_pt_donnee_rapport;
          l_pt_titre, l_pt_titre_a_liberer: t_pt_titre_rapport;
      begin
        with pv_rapport do
        begin
          l_pt_page:= pt_page_debut;
          while l_pt_page<> nil do
          begin
            with l_pt_page^ do
            begin
              l_pt_champ:= pt_donnee_debut;
              while l_pt_champ<> nil do
              begin
                l_pt_champ_a_liberer:= l_pt_champ;
                l_pt_champ:= l_pt_champ^.pt_donnee_suivante;
                with l_pt_champ_a_liberer^ do
                  freemem(l_pt_champ_a_liberer,
                      sizeof(t_donnee_rapport)- k_taille_gabarit_max+ length(gabarit_donnee));
              end; 
            end; 
            l_pt_page:= l_pt_page^.pt_page_rapport_suivante;
          end; 
          l_pt_page:= pt_page_debut;
          while l_pt_page<> nil do
          begin
            with l_pt_page^ do
            begin
              l_pt_titre:= pt_titre_debut;
              while l_pt_titre<> nil do
              begin
                l_pt_titre_a_liberer:= l_pt_titre;
                l_pt_titre:= l_pt_titre^.pt_titre_suivant;
                with l_pt_titre_a_liberer^ do
                  freemem(l_pt_titre_a_liberer,
                      sizeof(t_titre_rapport)- k_taille_titre_rapport_max+ length(titre));
              end; 
            end; 
            l_pt_page_a_liberer:= l_pt_page;
            l_pt_page:= l_pt_page^.pt_page_rapport_suivante;
            dispose(l_pt_page_a_liberer);
          end; 
        end; 
      end; 
    procedure initialise_caracteres_semi_graphiques;
      procedure initialise_groupe(p_position: t_position_trait;
          p_simple, p_double_horizontal, p_double_vertical, p_double: integer);
        begin
          s_graphique[p_position, simple]:= chr(p_simple);
          s_graphique[p_position, double_horizontal]:= chr(p_double_horizontal);
          s_graphique[p_position, double_vertical]:= chr(p_double_vertical);
          s_graphique[p_position, double]:= chr(p_double);
        end; 
  
      begin 
        initialise_groupe(horizontal, 196, 205, 196, 205);
        initialise_groupe(nord_ouest, 218, 213, 214, 201);
        initialise_groupe(nord,       194, 209, 210, 203);
        initialise_groupe(nord_est,   191, 184, 183, 187);
        initialise_groupe(ouest,      195, 198, 199, 204);
        initialise_groupe(centre,     197, 216, 215, 206);
        initialise_groupe(est,        180, 181, 182, 185);
        initialise_groupe(sud_ouest,  192, 212, 211, 200);
        initialise_groupe(sud,        193, 207, 208, 202);
        initialise_groupe(sud_est,    217, 190, 189, 188);
        initialise_groupe(vertical,   179, 179, 186, 186);
      end; 
  begin 
    initialise_caracteres_semi_graphiques;
  end.  




