(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit usaisis;
  interface
    uses crt,
         uclavier, uerreur,
         utypcons, uecran, uaffiche;
    type t_parametres_saisie= record
                                remplace_insere: boolean;
                                caractere_sortie_de_champ: char;
                                position_dans_champ: integer;
                                a_modifie_le_champ: boolean;
                                a_modifie_un_champ_du_groupe: boolean;
                                caracteres_sortie_fiche_a_fiche: set of char;
                                caracteres_sortie_de_champ: set of char;
                                lettres: set of char;
                                chiffres: set of char;
                                booleens: set of char;
                                lettres_ou_chiffres: set of char;
                                saisissables: set of char;
                              end;
    var g_parametres_saisie: t_parametres_saisie;

    procedure saisis_chaine_db(p_ligne, p_colonne, p_position_dans_champ, p_taille: integer;
        var pv_chaine_db;
        var v_gabarit_de_controle: t_gabarit_max;
        p_type_champ: char);

    procedure saisis_chaine_db_numerique(p_ligne, p_colonne: integer;
        p_position_dans_champ: integer; p_taille_champ, p_decimales_champ: integer;
        p_taille_zone, p_decimales_zone: integer;
        var pv_chaine_db_numerique;
        var v_gabarit_de_controle: t_gabarit_max);

    procedure saisis_booleen(p_ligne, p_colonne: integer; p_position_dans_champ: integer;
        var pv_valeur_chaine);

    procedure saisis_chaine_db_date(p_ligne, p_colonne: integer;
                          p_position_dans_champ: integer; p_taille_champ: integer;
                          var pv_date;
                          var v_gabarit_de_controle: t_gabarit_max);
  implementation

    procedure saisis_chaine_db(p_ligne, p_colonne, p_position_dans_champ, p_taille: integer;
        var pv_chaine_db;
        var v_gabarit_de_controle: t_gabarit_max;
        p_type_champ: char);
      const k_remplace= true;
      var l_sauve_chaine: string;
          l_touche: char;
          l_colonne: integer;
          l_chaine_db_surtypee: t_chaine_db_max absolute pv_chaine_db;
          l_indice_fin: integer;
          l_indice_point_gabarit: integer;
          l_a_modifie_le_champ: boolean;

      procedure cherche_indice_point_gabarit;
        begin
          l_indice_point_gabarit:= 1;
          while (l_indice_point_gabarit<= length(v_gabarit_de_controle))
              and (v_gabarit_de_controle[l_indice_point_gabarit]<> '.') do
          l_indice_point_gabarit:= l_indice_point_gabarit+ 1;
        end; 

      procedure affiche_gabarit;
        var l_indice: integer;
        begin
          gotoxy(l_colonne, p_ligne);
          for l_indice:= 1 to length(v_gabarit_de_controle) do
            if not (v_gabarit_de_controle[l_indice] in (g_parametres_saisie.saisissables+ ['.', ',']))
              then g_ecran[p_ligne, p_colonne+ l_indice- 1].caractere:=
                      v_gabarit_de_controle[l_indice];
        end; 

      procedure aligne_partie_entiere_sur_point_gabarit;
        var l_decalage, l_indice: integer;
        begin
          l_decalage:= l_indice_point_gabarit- 1- p_position_dans_champ;
          if l_decalage> 0
            then begin
                move(l_chaine_db_surtypee, l_chaine_db_surtypee[l_decalage],
                     p_position_dans_champ);
                fillchar(l_chaine_db_surtypee[0], l_decalage, ' ');
                for l_indice:= 0 to l_indice_point_gabarit- 2 do
                  g_ecran[p_ligne, p_colonne+ l_indice].caractere:= l_chaine_db_surtypee[l_indice];
                p_position_dans_champ:= p_position_dans_champ+ l_decalage;
                l_colonne:= l_colonne+ l_decalage;
              end;
        end; 

      procedure remplace_ou_insere_caractere(p_remplace_ou_insere: boolean);

        procedure decale_fin_champ;
          var l_taille, l_indice_fin: integer;
          begin
            if v_gabarit_de_controle<> ''
              then begin
                  l_taille:= p_position_dans_champ+ 1;
                  while (l_taille<= length(v_gabarit_de_controle))
                      and (v_gabarit_de_controle[l_taille] in g_parametres_saisie.saisissables) do
                    l_taille:= l_taille+ 1;
                  l_taille:= l_taille- 1;
                end
              else l_taille:= p_taille;
            move(l_chaine_db_surtypee[p_position_dans_champ],
            l_chaine_db_surtypee[p_position_dans_champ+ 1], l_taille- p_position_dans_champ- 1);
            for l_indice_fin:= p_position_dans_champ+ 1 to l_taille- 1 do
              g_ecran[p_ligne, p_colonne+ l_indice_fin].caractere:=
                l_chaine_db_surtypee[l_indice_fin];
          end; 

        begin 
          if (l_touche= '.') and (p_type_champ= 'N') and (v_gabarit_de_controle<> '')
            then aligne_partie_entiere_sur_point_gabarit
            else begin
                if not p_remplace_ou_insere
                  then decale_fin_champ;
                l_chaine_db_surtypee[p_position_dans_champ]:= l_touche;
                g_ecran[p_ligne, p_colonne+ p_position_dans_champ].caractere:= l_touche;
                p_position_dans_champ:= p_position_dans_champ+ 1;
                l_colonne:= l_colonne+ 1;
              end;
        end; 

      procedure controle_la_saisie;

        procedure traite_chiffre;
          var l_valide: boolean;
          begin 
            repeat
              lis_touche(l_touche);
              l_valide:=  (l_touche in g_parametres_saisie.chiffres)
                          or ((v_gabarit_de_controle[p_position_dans_champ+ 1]= '#')
                              and (l_touche= ' '))
                          or ((l_touche= '.')
                              and (p_position_dans_champ< l_indice_point_gabarit));
              if not l_valide
                then sonne;
            until l_valide;
          end; 

        begin 
          case v_gabarit_de_controle[p_position_dans_champ+ 1] of
            'X' : lis_touche(l_touche);
            'A' : repeat
                    lis_touche(l_touche);
                    if not (l_touche in g_parametres_saisie.lettres)
                      then sonne;
                  until l_touche in g_parametres_saisie.lettres;
            '!' : begin
                    repeat
                      lis_touche(l_touche);
                      if not (l_touche in g_parametres_saisie.lettres)
                        then sonne;
                    until l_touche in g_parametres_saisie.lettres;
                    l_touche:= upcase(l_touche);
                  end;
            '#', '9' : traite_chiffre;
            'L' : repeat
                    lis_touche(l_touche);
                    if not (l_touche in g_parametres_saisie.booleens)
                      then sonne;
                  until l_touche in g_parametres_saisie.booleens;
            'N' : repeat
                    lis_touche(l_touche);
                    if not (l_touche in g_parametres_saisie.lettres_ou_chiffres)
                      then sonne;
                  until l_touche in g_parametres_saisie.lettres_ou_chiffres;
            else
              l_touche:= v_gabarit_de_controle[p_position_dans_champ+ 1];
              if (l_touche= ',') and (p_type_champ= 'N')
                then begin
                    if (l_chaine_db_surtypee[p_position_dans_champ]= ' ')
                        (*$r-*)
                        and (l_chaine_db_surtypee[p_position_dans_champ- 1] in ['0'..'9'])
                        (*$r+*)
                        and (l_chaine_db_surtypee[p_position_dans_champ+ 1] in ['0'..'9', ' '])
                      then begin
                          l_touche:= ',';
                          remplace_ou_insere_caractere(k_remplace);
                          l_touche:= k_rien_faire;
                        end
                      else
                        if (l_chaine_db_surtypee[p_position_dans_champ]= ',')
                              and (not (l_chaine_db_surtypee[p_position_dans_champ- 1]
                                        in ['0'..'9'])
                                   or not (l_chaine_db_surtypee[p_position_dans_champ+ 1]
                                        in ['0'..'9', ' ']))
                          then begin
                              l_touche:= ' ';
                              remplace_ou_insere_caractere(k_remplace);
                              l_touche:= k_rien_faire;
                            end
                          else l_touche:= k_curseur_est;
                  end 
                else l_touche:= k_curseur_est;
          end; 
          if (l_touche in [k_curseur_ouest, k_efface_avant_curseur]) and (p_position_dans_champ> 0)
            then begin
                while (p_position_dans_champ> 0)
                  and not (v_gabarit_de_controle[p_position_dans_champ]
                        in g_parametres_saisie.saisissables) do
                begin
                  p_position_dans_champ:= p_position_dans_champ- 1;
                  l_colonne:= l_colonne- 1;
                end;
              end;
        end; 

      procedure efface_sous_curseur;
        var l_taille, l_indice_fin: integer;
        begin
          if v_gabarit_de_controle<> ''
            then begin
                l_taille:= p_position_dans_champ+ 1;
                while (l_taille<= length(v_gabarit_de_controle))
                    and (v_gabarit_de_controle[l_taille] in  g_parametres_saisie.saisissables) do
                  l_taille:= l_taille+ 1;
                l_taille:= l_taille- 1;
              end
            else l_taille:= p_taille;
          if l_taille> p_position_dans_champ
            then move(l_chaine_db_surtypee[p_position_dans_champ+ 1],
                      l_chaine_db_surtypee[p_position_dans_champ], l_taille- p_position_dans_champ);
          l_chaine_db_surtypee[l_taille- 1]:= ' ';
          for l_indice_fin:= p_position_dans_champ to l_taille- 1 do
            g_ecran[p_ligne, p_colonne+ l_indice_fin].caractere:=
              l_chaine_db_surtypee[l_indice_fin];
        end; 

      procedure efface_avant_curseur;
        var l_taille, l_indice_fin: integer;
        begin
          if v_gabarit_de_controle<> ''
            then begin
                if p_position_dans_champ> 1
                  then
                    if (v_gabarit_de_controle[p_position_dans_champ] in [',', '.'])
                        and (p_type_champ= 'N')
                      then begin
                          p_position_dans_champ:= p_position_dans_champ- 1;
                          l_colonne:= l_colonne- 1;
                          l_touche:= ' ';
                          exit;
                        end; 
                l_taille:= p_position_dans_champ+ 1;
                while (l_taille<= length(v_gabarit_de_controle))
                    and (v_gabarit_de_controle[l_taille] in g_parametres_saisie.saisissables) do
                  l_taille:= l_taille+ 1;
                l_taille:= l_taille- 1;
              end
            else l_taille:= p_taille;
          if l_taille> p_position_dans_champ
            then move(l_chaine_db_surtypee[p_position_dans_champ],
                      l_chaine_db_surtypee[p_position_dans_champ- 1],
                      l_taille- p_position_dans_champ);
          l_chaine_db_surtypee[l_taille- 1]:= ' ';
          p_position_dans_champ:= p_position_dans_champ- 1;
          l_colonne:= l_colonne- 1;
          for l_indice_fin:= p_position_dans_champ to l_taille- 1 do
            g_ecran[p_ligne, p_colonne+ l_indice_fin].caractere:=
               l_chaine_db_surtypee[l_indice_fin];
          l_touche:= ' ';
        end; 

      procedure modifie_selon_gabarit;
        var l_indice: integer;
            l_remplacer: boolean;

        procedure remplace(p_indice: integer; p_caractere: char);
          begin
            l_chaine_db_surtypee[p_indice]:= p_caractere;
            g_ecran[p_ligne, p_colonne+ p_indice].caractere:= p_caractere;
          end; 

        begin 
          case p_type_champ of
            'C' : begin
                    for l_indice:= 0 to p_taille- 1 do
                      case v_gabarit_de_controle[l_indice+ 1] of
                        '!' : l_chaine_db_surtypee[l_indice]:= upcase(l_chaine_db_surtypee[l_indice]);
                        'A', 'X', '#', '9', 'N', 'L' : ; 
                        else
                          l_chaine_db_surtypee[l_indice]:= v_gabarit_de_controle[l_indice+ 1];
                      end;
                  end;
            'N' : begin
                    l_remplacer:= false;
                    for l_indice:= 0 to p_taille- 1 do
                      if not l_remplacer
                        then begin
                            if l_chaine_db_surtypee[l_indice] in ['-', '1'..'9']
                              then l_remplacer:= true
                              else
                                if l_chaine_db_surtypee[l_indice]= '.'
                                  then begin
                                      l_remplacer:= true;
                                      if l_indice- 1> 0
                                        then
                                          if l_chaine_db_surtypee[l_indice- 1]= ' '
                                            then remplace(l_indice- 1, '0');
                                    end
                                  else 
                                    if l_chaine_db_surtypee[l_indice]= '0'
                                      then remplace(l_indice, ' ');
                          end 
                        else 
                          if (l_chaine_db_surtypee[l_indice]= ' ')
                              and ((l_indice<= p_position_dans_champ)
                                   or (l_touche<> k_return))
                            then remplace(l_indice, '0')
                            else
                              if (l_touche= k_return) and (l_indice> p_position_dans_champ)
                                then
                                  if l_chaine_db_surtypee[l_indice] in [' ', '1'..'9']
                                    then remplace(l_indice, '0');
                    if l_chaine_db_surtypee[p_taille- 1]= ' '
                      then remplace(p_taille- 1, '0');
                  end; 
          end; 
        end; 

      begin 
        l_sauve_chaine:= l_chaine_db_surtypee;
        l_colonne:= p_colonne+ p_position_dans_champ;
        if v_gabarit_de_controle<> ''
          then
            if p_type_champ= 'N'
              then cherche_indice_point_gabarit
              else affiche_gabarit;
        l_a_modifie_le_champ:= false;
        repeat
          gotoxy(l_colonne, p_ligne);
          if v_gabarit_de_controle<> ''
            then controle_la_saisie
            else lis_touche(l_touche);
          if not l_a_modifie_le_champ
            then
              if not ((l_touche= k_return) and (p_position_dans_champ= 0))
                then l_a_modifie_le_champ:=
                           not (l_touche in [k_curseur_ouest, k_curseur_est,
                                             k_curseur_nord, k_curseur_sud,
                                             k_page_precedente, k_page_suivante,
                                             k_page_ouest, k_page_est,
                                             k_controle_end]);
          case l_touche of
            k_efface_avant_curseur :
              if p_position_dans_champ> 0
                then efface_avant_curseur;
            k_efface_sous_curseur : efface_sous_curseur;
            k_curseur_ouest :
              if p_position_dans_champ> 0
                then begin
                    p_position_dans_champ:= p_position_dans_champ- 1;
                    l_colonne:= l_colonne- 1;
                    l_touche:= ' ';
                  end;
            k_curseur_est :
              if p_position_dans_champ< p_taille
                then begin
                    p_position_dans_champ:= p_position_dans_champ+ 1;
                    l_colonne:= l_colonne+ 1;
                    l_touche:= ' ';
                  end;
            k_mot_suivant :
              begin
                while (p_position_dans_champ< p_taille)
                    and (l_chaine_db_surtypee[p_position_dans_champ]<> ' ') do
                begin
                  p_position_dans_champ:= p_position_dans_champ+ 1;
                  l_colonne:= l_colonne+ 1;
                end;
                if p_position_dans_champ< p_taille
                  then begin
                      p_position_dans_champ:= p_position_dans_champ+ 1;
                      l_colonne:= l_colonne+ 1;
                    end;
              end; 
            k_mot_precedent :
              begin
                while (p_position_dans_champ> 0)
                    and (l_chaine_db_surtypee[p_position_dans_champ]<> ' ') do
                begin
                  p_position_dans_champ:= p_position_dans_champ- 1;
                  l_colonne:= l_colonne- 1;
                end;
                if p_position_dans_champ> 0
                  then begin
                      p_position_dans_champ:= p_position_dans_champ- 1;
                      l_colonne:= l_colonne- 1;
                      l_touche:= ' ';
                    end;
              end; 
            k_return : if l_a_modifie_le_champ
                           and (p_type_champ= 'N') and (v_gabarit_de_controle<> '')
                         then aligne_partie_entiere_sur_point_gabarit;
            k_curseur_nord, k_curseur_sud,
              k_page_precedente, k_page_suivante,
              k_page_ouest, k_page_est,
              k_escape, k_controle_end : ;
            k_rien_faire: ;
            k_remplace_insere : g_parametres_saisie.remplace_insere:=
                not g_parametres_saisie.remplace_insere;
            else remplace_ou_insere_caractere(g_parametres_saisie.remplace_insere);
          end; 
        until (p_position_dans_champ>= p_taille)
          or (l_touche in g_parametres_saisie.caracteres_sortie_de_champ);
        if l_a_modifie_le_champ and (v_gabarit_de_controle<> '')
          then modifie_selon_gabarit;
        with g_parametres_saisie do
        begin
          if p_position_dans_champ>= p_taille
            then caractere_sortie_de_champ:= k_curseur_est
            else caractere_sortie_de_champ:= l_touche;
          position_dans_champ:= p_position_dans_champ;
          a_modifie_le_champ:= l_a_modifie_le_champ;
        end; 
      end; 

    procedure saisis_chaine_db_numerique(p_ligne, p_colonne: integer;
        p_position_dans_champ: integer; p_taille_champ, p_decimales_champ: integer;
        p_taille_zone, p_decimales_zone: integer;
        var pv_chaine_db_numerique;
        var v_gabarit_de_controle: t_gabarit_max);
      var l_chaine_db_numerique_surtypee: t_chaine_db_numerique_max
               absolute pv_chaine_db_numerique;

      procedure cree_gabarit_numerique(p_taille, p_decimales: integer;
          var pv_gabarit: t_gabarit_max);
        begin
          fillchar(pv_gabarit[1], p_taille, '9');
          pv_gabarit[0]:= chr(p_taille);
          if p_decimales<> 0
            then pv_gabarit[p_taille- p_decimales]:= '.';
        end; 

      procedure saisis_avec_gabarit_special(var v_gabarit: t_gabarit_max);
        var l_chaine_db_numerique: t_chaine_db_numerique_max;

        procedure met_dans_la_zone;
          var l_indice: integer;
              l_gabarit: t_gabarit_max;
          begin
            l_indice:= 0;
            while l_indice< p_taille_champ do
              if not (l_chaine_db_numerique[l_indice] in ['-', '.', ' ', '0'..'9'])
                then begin
                    move(l_chaine_db_numerique[l_indice+ 1], l_chaine_db_numerique[l_indice],
                         p_taille_champ- l_indice);
                    p_taille_champ:= p_taille_champ- 1;
                  end
                else l_indice:= l_indice+ 1;
            cree_gabarit_numerique(p_taille_zone, p_decimales_zone, l_gabarit);
            formate_chaine_db_numerique(l_chaine_db_numerique,
                                       p_taille_zone, p_decimales_zone,  v_gabarit);
            move(l_chaine_db_numerique, l_chaine_db_numerique_surtypee, p_taille_zone);
          end; 

        begin 
          move(l_chaine_db_numerique_surtypee, l_chaine_db_numerique, p_taille_zone);
          formate_chaine_db_numerique(l_chaine_db_numerique, p_taille_zone,
              p_decimales_zone, v_gabarit);
          saisis_chaine_db(p_ligne, p_colonne, p_position_dans_champ,
                          p_taille_champ, l_chaine_db_numerique, v_gabarit, 'N');
          if g_parametres_saisie.a_modifie_le_champ
            then met_dans_la_zone;
        end; 

      procedure saisis_au_format_standard;
        var l_gabarit: t_gabarit_max;
            l_position: integer;
        begin 
          if (p_decimales_champ= p_decimales_zone) and (p_taille_champ= p_taille_zone)
            then begin
                cree_gabarit_numerique(p_taille_zone, p_decimales_zone, l_gabarit);
                if p_decimales_zone<> 0
                  then begin
                      l_chaine_db_numerique_surtypee[p_taille_champ- p_decimales_zone- 1]:= '.';
                      g_ecran[p_ligne,
                          p_colonne+ p_taille_champ- p_decimales_zone- 1].caractere:= '.';
                    end;
                saisis_chaine_db(p_ligne, p_colonne, p_position_dans_champ,
                                p_taille_champ, l_chaine_db_numerique_surtypee, l_gabarit, 'N');
              end
            else begin
                cree_gabarit_numerique(p_taille_champ, p_decimales_champ, l_gabarit);
                saisis_avec_gabarit_special(l_gabarit);
              end;
        end; 

      begin 
        if v_gabarit_de_controle= ''
          then saisis_au_format_standard
          else saisis_avec_gabarit_special(v_gabarit_de_controle);
      end; 

    procedure saisis_booleen(p_ligne, p_colonne: integer; p_position_dans_champ: integer;
        var pv_valeur_chaine);
      var l_booleen_retype: char absolute pv_valeur_chaine;
          l_gabarit_de_controle: t_gabarit_max;
      begin
        l_gabarit_de_controle:= 'A';
        if not (l_booleen_retype in ['Y', 'N'])
          then begin
              l_booleen_retype:= 'Y';
              g_ecran[p_ligne, p_colonne+ p_position_dans_champ].caractere:= 'Y';
            end;
        repeat
          p_position_dans_champ:= 0;
          saisis_chaine_db(p_ligne, p_colonne, p_position_dans_champ,
                        1, l_booleen_retype, l_gabarit_de_controle, 'C');
          if not (l_booleen_retype in ['Y', 'N'])
            then sonne;
        until l_booleen_retype in ['Y', 'N'];
      end; 

    procedure saisis_chaine_db_date(p_ligne, p_colonne: integer;
                          p_position_dans_champ: integer; p_taille_champ: integer;
                          var pv_date;
                          var v_gabarit_de_controle: t_gabarit_max);
      var l_date_surtypee: t_date absolute pv_date;
          l_date: t_date;
          l_gabarit: t_gabarit_max;
      begin
        formate_chaine_db_date(l_date_surtypee, l_date);
        l_gabarit:= '99/99/99';
        saisis_chaine_db(p_ligne, p_colonne, p_position_dans_champ,
               8, l_date, l_gabarit, 'C');
        l_date_surtypee:= l_date;
        move(l_date_surtypee[3], l_date_surtypee[4], 2);
        move(l_date_surtypee[0], l_date_surtypee[2], 2);
        l_date_surtypee[0]:= '1';
        l_date_surtypee[1]:= '9';
      end; 

    procedure initialise_parametres_de_saisie;
      begin 
        fillchar(g_parametres_saisie, sizeof(g_parametres_saisie), 0);
        with g_parametres_saisie do
        begin
          caracteres_sortie_fiche_a_fiche:= [k_controle_end, k_escape];
          caracteres_sortie_de_champ:= caracteres_sortie_fiche_a_fiche
            + [ 
                k_return, k_curseur_sud, k_curseur_est, k_page_suivante,
                k_curseur_nord, k_efface_avant_curseur, k_curseur_ouest,
                k_page_precedente, k_mot_precedent];
          lettres:= ['a'..'z', 'A'..'Z']
            + caracteres_sortie_de_champ
            + [k_efface_sous_curseur, k_remplace_insere, k_mot_suivant];
          chiffres:= ['0'..'9', '+', '-']
            + caracteres_sortie_de_champ
            + [k_efface_sous_curseur, k_remplace_insere];
          lettres_ou_chiffres:= lettres+ chiffres;
          booleens:= ['T', 't', 'O', 'o', 'N', 'n'];
          saisissables:= ['A', '!', '#', '9', 'N', 'L', 'X'];
          remplace_insere:= true;
        end; 
      end; 

  begin 
    initialise_parametres_de_saisie;
  end. 



