(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+,b+*)

program compilateur_pascal_assy_binaire;
  uses crt,
       uclavier, uerreur,
       uhex, uchained,
       utypcons,
       uecran, uaffiche,
       udonnees, usortie,
       uediteur, ulexical;
  const k_chemin_programme= 'A:';
        k_suffixe_programme: string[4]= '.PAS';
        k_taille_label_max= 39;
  type t_label= string[k_taille_label_max];
  const 
        k_code_CALL= $E8;
        k_code_MOV_DX_IMMEDIAT= $BA;
        k_code_RET= $C3;
        k_code_SEG_CS= $2E;
        k_code_MOV_W_MEMOIRE_IMMEDIAT= $06C7;
        k_code_MOV_B_MEMOIRE_IMMEDIAT= $06C6;
        k_code_MOV_AX_MEMOIRE= $A1;
        k_code_MOV_MEMOIRE_AX= $A3;
        k_code_MOV_DX_MEMOIRE= $168B;
        k_code_MOV_MEMOIRE_BX= $1E89;
        k_code_JMP= $E9;
        k_code_JE= $74;
        k_code_CMP_W_MEMOIRE_IMMEDIAT= $3E81;
        k_adresse_curseur_x= $0103;
        k_adresse_curseur_y= $0105;
        k_adresse_affiche_hex_dx= $0108;
        k_adresse_a_la_ligne= $016F;
        k_adresse_initialise_curseur= $01B8;
        k_adresse_clrscr= $01C5;
        k_adresse_affiche_chaine= $01EA;
        k_adresse_stoppe= $021D;
        k_adresse_lis_entier= $0229;
        k_objet_max= 1000;
  var g_choix: char;
      g_pt_programme: t_pt_texte;
      g_nom_texte: t_string_80;
      g_objet: record
                 indice_objet: integer;
                 tampon_objet: array[0..k_objet_max] of byte;
                 hexa_symbolique: boolean;
               end;

  procedure compile_programme(p_pt_programme: t_pt_texte;
      p_ensemble_symboles_finaux: t_ensemble_de_symboles);
    (*$i a:icpogen *)

    procedure traite_instructions(p_pt_programme: t_pt_texte;
               p_ensemble_symboles_finaux_2: t_ensemble_de_symboles;
               p_nom_proprietaire: t_nom_proprietaire);
      var 
          l_texte_expression: string;
      (*$i a:iintvar *)
      (*$i a:icpoexpr *)
      (*$i a:icpocde *)
      begin 
        with g_interprete, g_objet, g_sortie do
        while not (type_symbole in p_ensemble_symboles_finaux_2) do
        begin
          genere_ligne(k_ligne);
          case type_symbole of
            symbole_variable : traite_affectation;
            symbole_point_interrogation : traite_point_interrogation;
            symbole_WRITE : traite_write;
            symbole_arobas : traite_arobas;
            symbole_INPUT : traite_INPUT;
            symbole_IF : traite_IF;
            symbole_DO : traite_DO;
            symbole_CLEAR : traite_CLEAR;
            symbole_STOPPE : traite_STOPPE;
            symbole_QUIT : ;
            else
              affiche_erreur_programme(p_pt_programme, 'attend pas le symbole '+ texte_symbole
                + ' en dbut instruction');
              lis_symbole(p_pt_programme);
          end; 
          while type_symbole= symbole_retour_chariot do
            lis_symbole(p_pt_programme);
        end; 
      end; 

    procedure charge_librairie;
      var l_librairie: file;
      begin
        assign(l_librairie, 'a:lib.com');
        reset(l_librairie, 1);
        with g_objet do
        begin
          indice_objet:= filesize(l_librairie);
          writeln('charge a:lib.com ', f_entier_hexadecimal(indice_objet), ' octets');
          blockread(l_librairie, tampon_objet, indice_objet);
          close(l_librairie);
        end; 
      end; 

    procedure sauve_objet;
      var l_objet: file;
      begin
        with g_objet do
        begin
          if g_objet.hexa_symbolique
            then begin
                writeln(g_sortie.sortie);
                stoppe;
              end;
          writeln('sauve ', 'a:'+ g_pt_programme^.nom_texte+ '.com , ',
              f_entier_hexadecimal(indice_objet));
          assign(l_objet, 'a:'+ g_pt_programme^.nom_texte+ '.com');
          rewrite(l_objet, 1);
          blockwrite(l_objet, tampon_objet, indice_objet);
          close(l_objet);
        end;
      end; 

    begin 
      p_pt_programme^.indice_courant:= 0;
      fillchar(g_objet, sizeof(g_objet)- 1, 0);
      charge_librairie;
      with g_interprete do
      begin
        indice_variable_max:= 0;
        indice_valeur_variable_suivante:= 0;
        fillchar(table_fichiers, sizeof(table_fichiers), 0);
      end; 
      lis_symbole(p_pt_programme);
      traite_instructions(p_pt_programme,
         p_ensemble_symboles_finaux, p_pt_programme^.nom_texte);
      genere_call(k_adresse_stoppe);
      genere_octet(k_code_RET, k_ligne);
      sauve_objet;
    end; 

  procedure go;
    var l_table_noms: array[0..100] of t_string_80;
        l_indice_nom, l_nom_max: integer;
        l_choix: char;

    procedure ajoute_un_programme(p_nom: t_string_80);
      begin
        l_table_noms[l_nom_max]:= p_nom;
        l_nom_max:= l_nom_max+ 1;
      end; 

    begin 
      l_nom_max:= 0;
      ajoute_un_programme('AOAFFENT');
      ajoute_un_programme('AOAFFICHE');
      ajoute_un_programme('AOSAY');
      ajoute_un_programme('AOAFFECTE1');
      ajoute_un_programme('AOINPUT');
      ajoute_un_programme('AOWHILE');
      ajoute_un_programme('AOWHILE1');
      ajoute_un_programme('AOIF');
      l_indice_nom:= 0;
      clrscr;
      repeat
        writeln;
        write(l_indice_nom: 2, ' ', l_table_noms[l_indice_nom]);
        write(' continue, Ok, Fichier, Quitte ? '); lis_touche(l_choix);
        if l_choix in ['o', 'f']
          then begin
              g_nom_texte:= l_table_noms[l_indice_nom];
              charge_texte(g_pt_programme,
                  k_chemin_programme+ g_nom_texte+  k_suffixe_programme, k_texte_max);
              with g_pt_programme^ do
                affiche_programme(g_pt_programme);
              stoppe; writeln;
              writeln('INTERPRETE: ');
              writeln;
              if l_choix= 'f'
                then
                  with g_sortie do
                  begin
                    writeln;
                    writeln('met dans: a:r'+ g_nom_texte+ '.pas');
                    writeln;
                    close(sortie);
                    assign(sortie, k_chemin_programme+ 'r'+ g_nom_texte+ '.pas');
                    rewrite(sortie);
                  end;
              compile_programme(g_pt_programme, [symbole_fin, symbole_QUIT]);
              writeln;
              libere_texte(g_pt_programme);
              if l_choix= 'f'
                then
                  with g_sortie do
                  begin
                    writeln(sortie);
                    close(sortie);
                    assign(sortie, 'CON');
                    rewrite(sortie);
                  end;
            end;
        l_indice_nom:= l_indice_nom+ 1;
      until (l_choix= 'q') or (l_indice_nom= l_nom_max);
    end; 

  procedure initialise;
    begin 
      g_pt_programme:= nil;
      g_nom_texte:= '';
      g_objet.hexa_symbolique:= false;
      g_objet.hexa_symbolique:= true;
      g_interprete.teste_interprete:= false;
    end; 

  begin 
    initialise;
    repeat
      writeln;
      write(g_nom_texte, ' $', f_pointeur_hexadecimal(heapptr),
        ' long ', f_pointeur_longint(heapptr));
      if g_objet.hexa_symbolique
        then write(' hexa symbolique')
        else write(' hexa binaire');
      writeln;
      write('Nom, Charge, Affiche, Interprete, Test, Go, Sortie, Quitte ? ');
      lis_touche(g_choix); writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'a' : with g_pt_programme^ do
                affiche_programme(g_pt_programme);
        'c' : charge_texte(g_pt_programme,
                  k_chemin_programme+ g_nom_texte+ k_suffixe_programme, k_texte_max);
        'i' : begin
                if g_pt_programme= nil
                  then charge_texte(g_pt_programme,
                      k_chemin_programme+ g_nom_texte+ k_suffixe_programme,
                      k_texte_max);
                compile_programme(g_pt_programme, [symbole_fin, symbole_QUIT]);
              end;
        'g' : go;
        'n' : begin
                write('nom <ESSAI> ? '); readln(g_nom_texte);
               end;
        'r' : affiche_reserves;
        's' : choisis_sortie;
        't' : g_objet.hexa_symbolique:= not g_objet.hexa_symbolique;
      end; 
    until g_choix= 'q';
  end. 
