(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
(*$b+*)

program compilateur_pascal_generant_du_pascal;
  uses crt,
       uclavier, uerreur,
       utypcons,
       uecran, usortie, uaffiche,
       uhex, uchained, uchaine,
       udonnees,
       uediteur, ulexical;
  const k_chemin_programme= 'A:';
        k_suffixe_programme: string[4]= '.PAS';
  var g_choix: char;
      g_pt_programme: t_pt_texte;
      g_nom_programme: t_string_80;

  procedure compile_programme(p_pt_programme: t_pt_texte;
      p_ensemble_symboles_finaux: t_ensemble_de_symboles);
    (*$i a:icgenere *)

    procedure traite_instructions(p_pt_programme: t_pt_texte;
               p_ensemble_symboles_finaux_2: t_ensemble_de_symboles;
               p_nom_proprietaire: t_nom_proprietaire);
      var 
          l_texte_expression: string;
      (*$i a:iintvar *)
      (*$i a:icexpr *)
      (*$i a:iccde *)
      begin 
        with g_interprete do
          while not (type_symbole in p_ensemble_symboles_finaux_2) do
          begin
            case type_symbole of
              symbole_variable : traite_affectation;
              symbole_DISPLAY : traite_DISPLAY;
              symbole_point_interrogation : traite_point_interrogation;
              symbole_WRITE : traite_WRITE;
              symbole_arobas : traite_arobas;
              symbole_INPUT : traite_INPUT;
              symbole_RELEASE : traite_RELEASE;
              symbole_IF : traite_IF;
              symbole_DO : traite_DO;
              symbole_CLEAR : traite_CLEAR;
              symbole_STOPPE : traite_STOPPE;
              symbole_QUIT : ;
              else
                affiche_erreur_programme(p_pt_programme,
                    'attend pas le type_symbole '+ texte_symbole+ ' ici');
                lis_symbole(p_pt_programme);
            end; 
            while type_symbole= symbole_retour_chariot do
              lis_symbole(p_pt_programme);
          end; 
      end; 

    begin 
      p_pt_programme^.indice_courant:= 0;
      genere_ligne(0, 'PROGRAM resultat_compilation;');
      genere_ligne(2, 'USES CRT, uclavier, uerreur, uecran, uaffiche, usortie,');
      genere_ligne(0, '     utypcons, udonnees, usaisis, uchamps, ubalaye;');
      genere_ligne(0, '');
      genere_ligne(0, '(*$i a:initvar *)');
      genere_ligne(0, '');
      genere_ligne(0, 'BEGIN'); g_sortie.colonne_sortie:= g_sortie.colonne_sortie+ 2;
      genere_ligne(0, 'alloue_variables;');
      with g_interprete do
      begin
        indice_variable_max:= 0;
        indice_valeur_variable_suivante:= 0;
        fillchar(table_fichiers, sizeof(table_fichiers), 0);
      end; 
      lis_symbole(p_pt_programme);
      traite_instructions(p_pt_programme,
         p_ensemble_symboles_finaux, p_pt_programme^.nom_texte);
      genere_ligne(-2, 'END.');
    end; 

  procedure go;
    var l_table_noms: array[0..100] of t_string_80;
        l_indice_nom, l_nom_max: integer;
        l_choix: char;

    procedure ajoute_un_programme(p_nom: t_string_80);
      begin
        l_table_noms[l_nom_max]:= p_nom;
        l_nom_max:= l_nom_max+ 1;
      end; 

    begin 
      l_nom_max:= 0;
      ajoute_un_programme('EXCOMP');
      ajoute_un_programme('AFFICHE');
      ajoute_un_programme('EXPRESSI');
      ajoute_un_programme('SAY');
      ajoute_un_programme('AFFECTE');
      ajoute_un_programme('AFFECHAI');
      ajoute_un_programme('AFFENUM');
      ajoute_un_programme('RELEASE');
      ajoute_un_programme('INPUT');
      ajoute_un_programme('WHILE');
      ajoute_un_programme('WHILEEMB');
      ajoute_un_programme('IF');
      ajoute_un_programme('IFTHENEL');
      ajoute_un_programme('IFEMB');
      l_indice_nom:= 0;
      clrscr;
      repeat
        writeln;
        write(l_indice_nom: 2, ' ', l_table_noms[l_indice_nom]);
        write(' continue, Ok, Fichier, Quitte ? '); lis_touche(l_choix);
        if l_choix in ['o', 'f']
          then begin
              g_nom_programme:= l_table_noms[l_indice_nom];
              charge_texte(g_pt_programme,
                  k_chemin_programme+ g_nom_programme+ k_suffixe_programme, k_texte_max);
              with g_pt_programme^ do
                affiche_programme(g_pt_programme);
              stoppe; writeln;
              write('INTERPRETE: ');
              if l_choix= 'f'
                then
                  with g_sortie do
                  begin
                    writeln;
                    writeln('met dans: a:r'+ g_nom_programme+ '.pas');
                    writeln;
                    close(sortie);
                    assign(sortie, 'a:r'+ g_nom_programme+ '.pas');
                    rewrite(sortie);
                  end;
              compile_programme(g_pt_programme, [symbole_fin, symbole_QUIT]);
              writeln;
              libere_texte(g_pt_programme);
              if l_choix= 'f'
                then
                  with g_sortie do
                  begin
                    writeln(sortie);
                    close(sortie);
                    assign(sortie, 'CON');
                    rewrite(sortie);
                  end;
            end;
        l_indice_nom:= l_indice_nom+ 1;
      until (l_choix= 'q') or (l_indice_nom= l_nom_max);
    end; 

  procedure initialise;
    begin 
      g_pt_programme:= nil;
      g_nom_programme:= '';
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_programme, ' $', f_pointeur_hexadecimal(heapptr),
        ' long ', f_pointeur_longint(heapptr));
      writeln('manuel:      Nom, Charge, Affiche, Interprete, Test, Sortie');
      write(  'automatique: Go, Quitte ? ');
      lis_touche(g_choix); writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'a' : with g_pt_programme^ do
                affiche_programme(g_pt_programme);
        'c' : charge_texte(g_pt_programme, g_nom_programme+ k_suffixe_programme, k_texte_max);
        'i' : begin
                if g_pt_programme= nil
                  then charge_texte(g_pt_programme, g_nom_programme+ k_suffixe_programme,
                      k_texte_max);
                compile_programme(g_pt_programme, [symbole_fin, symbole_QUIT]);
              end;
        'g' : go;
        'n' : begin
                write('nom <ESSAI> ? '); readln(g_nom_programme);
               end;
        'r' : affiche_reserves;
        's' : choisis_sortie;
        't' : g_interprete.teste_interprete:= not g_interprete.teste_interprete;
      end; 
    until g_choix= 'q';
  end. 
