; 001 ialexical
; 30 jul 91

;--------------------------------------
; l'analyseur lexical
;--------------------------------------

                data

; le mot courant du source
v_debut_mot                  equ    $0102 ; 2
v_fin_mot                    equ    $0104 ; 2
v_taille_mot                 equ    $0106 ; 2 parceque compare  bx



k_symbole_inconnu            equ    $00
k_symbole_chaine_litterale   equ    $01
k_symbole_nombre_litteral    equ    $02
k_symbole_booleen_litteral   equ    $03

k_premier_mot_reserve        equ    $04

k_symbole_clear              equ    $04
k_symbole_say                equ    $05
k_symbole_get                equ    $06
k_symbole_read               equ    $07
k_symbole_input              equ    $08
k_symbole_to                 equ    $09

k_symbole_if                 equ    $0A
k_symbole_end_if             equ    $0B
k_symbole_else               equ    $0C
k_symbole_do                 equ    $0D
k_symbole_while              equ    $0E
k_symbole_end_do             equ    $0F

k_symbole_and                equ    $10

k_symbole_display            equ    $11
k_symbole_memory             equ    $12
k_symbole_space              equ    $13
k_symbole_create             equ    $14

; le dernier symbole qui peut commencer une instruction
k_dernier_mot_instruction    equ    $14

k_premiere_ponctuation       equ    $81

k_symbole_interrogation      equ    $81
k_symbole_arobas             equ    $82

k_derniere_ponctuation_instruction
                             equ    $83

k_symbole_egal               equ    $83
k_symbole_virgule            equ    $84
k_symbole_parenthese_ouvrante equ   $85
k_symbole_parenthese_fermante equ   $86

k_symbole_variable           equ    $F0

k_symbole_fin                equ    $FF


k_nombre_mots_reserves       equ    $11 ; [$04- $14]

; la taille d'une entre dans la table des mots rservs
k_taille_entree              equ    $0D
; la position de l'adresse de traitement dans l'entre
k_decalage_adresse           equ    $0B



v_type_symbole               equ    $0108 ; 2 octet, car fait un mov [], CX !!!
; la valeur numrique si le symbole est un chiffre
v_valeur_chiffre             equ    $0110 ; 2 octets
; l'emplacement o se trouve l'adresse de traitement
v_adresse_traitement_reserve equ    $010A ; 2 octets



                code

lis_symbole
                mov    al, '>'
                call   affiche_car_test

                ; par dfaut, symbole inconnu
                mov    b [v_type_symbole], k_symbole_inconnu

                ; saute ' ', RETURN, INTERLIGNE et CONTROLE-Z
                call   saute_separateurs

                cmp    si, [v_fin_texte]
                jb     .analyse_symbole

                ; a fini le texte
                mov    b [v_type_symbole], k_symbole_fin
                jmp    .ret

.analyse_symbole
                call   teste_lettre
                jb     .chaine_litterale
                call   analyse_identificateur
                jmp_s  .ret

.chaine_litterale
                cmp    al, k_apostrophe
                jne    .nombre_litteral
                call   analyse_chaine_litterale
                jmp_s  .ret

.nombre_litteral
                call   teste_chiffre
                jb     .teste_ponctuation
                call   analyse_nombre_litteral
                jmp_s  .ret

.teste_ponctuation
                cmp    al, '='
                jne    .teste_interrogation
                mov    b [v_type_symbole], k_symbole_egal
                jmp_s  .saute_symbole

.teste_interrogation
                cmp    al, '?'
                jne    .teste_arobas
                mov    b [v_type_symbole], k_symbole_interrogation
                mov    bx, interprete_interrogation
                jmp_s  .saute_symbole
.teste_arobas
                cmp    al, '@'
                jne    .teste_virgule
                mov    b [v_type_symbole], k_symbole_arobas
                mov    bx, interprete_arobas
                jmp_s  .saute_symbole

.teste_virgule  cmp    al, ','
                jne    .saute_symbole
                mov    b [v_type_symbole], k_symbole_virgule
                jmp_s  .saute_symbole

.saute_symbole  inc    si

.ret            cmp    b [v_teste], $00
                je     .fin2
                call   affiche_symbole
.fin2           ret



saute_separateurs
                mov    al, [si]

                cmp    al, k_return
                jne    .teste_controle_z
                ; saute RETURN et INTERLIGNE
                inc    si
                jmp_s  .saute_separateur

.teste_controle_z
                cmp    al, k_controle_z
                je     .saute_separateur

                cmp    al, ' '
                jne    .fin_saute
.saute_separateur
                inc    si
                jmp_s  saute_separateurs

.fin_saute      ret    ; saute_sparateurs



teste_lettre    ; teste le caractre dans AL.
                ; SI A..Z, _, a..z, purge la retenue
                cmp    al, 'A'
                jb     .ret
                cmp    al, '[' ; Z+ 1
                cmc
                jnc    .ret

                cmp    al, '_'
                je     .ret

                cmp    al, 'a'
                jb     .ret
                cmp    al, '{' ; z+ 1
                cmc

.ret            ret    ; teste_lettre




analyse_identificateur
                mov    b [v_type_symbole], k_symbole_variable

                ; mmorise l'indice du dbut du mot
                mov    [v_debut_mot], si

.repete_lettre  ; affiche
                call   affiche_car_test

                inc    si
                mov    al, [si]
                call   teste_lettre
                jae    .repete_lettre

                ; calcule la taille pour comparer aux rservs
                mov    ax, si
                sub    ax, [v_debut_mot]
                mov    [v_taille_mot], ax

                ; un mot rserv ou une variable ?
                call   analyse_reserve

                ret



analyse_chaine_litterale
                mov    b [v_type_symbole], k_symbole_chaine_litterale

                ; saute '
                inc    si

                ; mmorise pour pouvoir traiter la chane
                mov    [v_debut_mot], si

                ; avance SI juqu'au prochain '
.repete         mov    al, [si]
                cmp    al, k_apostrophe
                je     .fin_chaine
                inc    si
                jmp_s  .repete

.fin_chaine     ; calcule la taille pour faciliter l'affichage
                mov    ax, si
                sub    ax, [v_debut_mot]
                mov    [v_taille_mot], ax

                mov    [v_fin_mot], si

                ; dpasse ' final
                inc    si

                ret



analyse_nombre_litteral
                mov    b [v_type_symbole], k_symbole_nombre_litteral

                ; rcupre uniquement le premier chiffre
                sub    al, $30
                mov    [v_valeur_chiffre], al

                inc    si

                ret




analyse_reserve ; cherche le mot rserv dans la table

                ; sauve l'indice de l'objet
                push   di

                ; DI utilis comme dbut de chaque entre de la table
                mov    di, table_mots_reserves

                ; sauve indice de la fin du mot
                push   si

                ; SI utilis comme dpart du mot
                mov    si, [v_debut_mot]

                ; nombre de mots tests
                mov    cx, $0000

.compare_un_mot ; bx: indice dans le mot
                xor    bx, bx

.compare_une_lettre
                ; la lettre du mot
                mov    al, [bx+ si]
                ; comparee  la lettre de la table
                seg    cs
                cmp    al, [bx+ di]
                je     .lettre_suivante

.entree_suivante
                ; les lettres sont diffrentes: passe  l'entre suivante
                inc    cx

                ; ? fin de la table
                cmp    cx, k_nombre_mots_reserves
                jb     .teste_mot_reserve_suivant

                ; rcupre l'indice du prochain caractre du source
                pop    si

                ; rcupere l'indice dans l'objet
                pop    di

                mov    b [v_type_symbole], k_symbole_variable
                jmp_s  .ret

.teste_mot_reserve_suivant
                ; positionne DI au dbut de l'entre suivante
                add    di, k_taille_entree
                jmp_s  .compare_un_mot

.lettre_suivante
                inc    bx
                ; ? a atteint la fin du mot rserv de la table
                seg    cs
                cmp    b [bx+ di], $00
                jne    .compare_une_lettre

                ; verifie que le mot courant n'est pas plus long que
                ; le mot rserv
                cmp    bl, [v_taille_mot]
                jne    .entree_suivante

                ; mise au point: renvoie le rang du symbole
                add    cx, k_premier_mot_reserve
                mov    [v_type_symbole], cx

                ; calcule l'adresse de traitement du mot rserv
                mov    [v_adresse_traitement_reserve], di
                add    w [v_adresse_traitement_reserve], k_decalage_adresse

                ; rcupre les indice source et objet
                pop    si
                pop    di

.ret            ret



table_mots_reserves
                ; 11 octets pour le nom, 2 pour l'adresse= 13 octets

                ; $00, $04
                asc    'CLEAR'
                hex    000000000000
adr_clear       adr    interprete_clear

                ; $01, $05
                asc    'SAY'
                hex    0000000000000000
                adr    interprete_say

                ; $02, $06
                asc    'GET'
                hex    0000000000000000
                adr    interprete_get

                ; $03, $07
                asc    'READ'
                hex    00000000000000
                adr    interprete_read

                ; $04, $08
                asc    'INPUT'
                hex    000000000000
                adr    interprete_input

                ; $05, $09
                asc    'TO'
                hex    000000000000000000
                hex    FFFF

                ; $06, $0A
                asc    'IF'
                hex    000000000000000000
                adr    interprete_if

                ; $07, $0B
                asc    'ENDIF'
                hex    000000000000
                hex    FFFF

                ; $08, $0C
                asc    'ELSE'
                hex    00000000000000
                hex    FFFF

                ; $09, $0D
                asc    'DO'
                hex    000000000000000000
                adr    interprete_do

                ; $0A, $0E
                asc    'WHILE'
                hex    000000000000
                adr    interprete_while

                ; $0B, $0F
                asc    'ENDDO'
                hex    000000000000
                hex    FFFF

                ; $0C, $10
                asc    'AND'
                hex    0000000000000000
                adr    interprete_and

                ; $0D, $11
                asc    'DISPLAY'
                hex    00000000
                adr    interprete_display

                ; $0E, $12
                asc    'MEMORY'
                hex    0000000000
                hex    FFFF

                ; $0F, $13
                asc    'SPACE'
                hex    000000000000
                hex    FFFF

                ; $10, $14
                asc    'CREATE'
                hex    0000000000
                adr    interprete_create



affiche_symbole ; mise au point
                mov    al, [v_type_symbole]
                call   affiche_hex_al

                cmp    al, k_symbole_inconnu
                jne    .chaine_litterale
                call   affiche_chaine
                asc    'symbole inconnu'
                hex    00
                jmp    .fin
.chaine_litterale
                cmp    al, k_symbole_chaine_litterale
                jne    .nombre_litteral
                call   affiche_chaine
                asc    'chaine:'
                hex    00
                jmp    .fin
.nombre_litteral
                cmp    al, k_symbole_nombre_litteral
                jne    .clear
                call   affiche_chaine
                asc    'nombre:'
                hex    00
                jmp    .fin
.clear          cmp    al, k_premiere_ponctuation
                jae    .ponctuation
                ; les mots rservs
                push   si
                push   ds

                push   cs
                pop    ds

                xor    ah, ah
                sub    al, k_premier_mot_reserve
                mov    cx, k_taille_entree
                mul    cx
                add    ax, table_mots_reserves
                mov    si, ax
                mov    dx, ax
                call   affiche_chaine_0

                pop    ds
                pop    si
                jmp    .fin

.ponctuation    cmp    al, k_symbole_egal
                jne    .interrogation
                mov    al, '='
                call   affiche_car
                jmp    .fin
.interrogation  cmp    al, k_symbole_interrogation
                jne    .arobas
                mov    al, '?'
                call   affiche_car
                jmp    .fin
.arobas         cmp    al, k_symbole_arobas
                jne    .virgule
                mov    al, '@'
                call   affiche_car
                jmp    .fin
.virgule        cmp    al, k_symbole_virgule
                jne    .variable
                mov    al, ','
                call   affiche_car
                jmp    .fin

.variable       cmp    al, k_symbole_variable
                jne    .fin
                call   affiche_chaine
                asc    'var'
                hex    00

.fin            call   a_la_ligne
                ret    ; affiche_symbole

; fin ialexical
