(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)


      procedure affiche_un_facteur;
        begin
          with g_interprete do
          begin
            case type_symbole of
              symbole_variable :
                if f_variable_existe
                  then begin
                      genere('mov    dx, [$'+ f_entier_hexadecimal(indice_variable_courante* 2)+ ']');
                      genere('call   affiche_hex_dx');
                    end
                  else affiche_erreur_programme(p_pt_programme,
                                    'variable '+ texte_symbole+ ' inconnue');
              symbole_chaine_constante : begin
                                           genere('call   affiche_chaine');
                                           genere('asc    '''+ texte_symbole+ '''');
                                           genere('hex    00');
                                         end;
              symbole_nombre_constant:
                begin
                  genere('mov    dx, $'+ f_entier_hexadecimal(round(valeur_numerique_symbole)));
                  genere('call   affiche_hex_dx');
                end;
              else
                affiche_erreur_programme(p_pt_programme,
                  'attend nom variable ou constante, pas '+ texte_symbole);
            end; 
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_point_interrogation;
        var l_premier: boolean;
        begin
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            repeat
              if l_premier
                then l_premier:= false;
              affiche_un_facteur;
            until type_symbole= symbole_retour_chariot;
            genere('call   a_la_ligne');
          end; 
        end; 

      procedure traite_WRITE;
        var l_premier: boolean;
        begin
          with g_interprete, g_sortie do
          begin
            l_premier:= true;
            lis_symbole(p_pt_programme);
            repeat
              if l_premier
                then l_premier:= false;
              affiche_un_facteur;
            until type_symbole= symbole_retour_chariot;
          end; 
        end; 

      procedure traite_affectation;
        var l_nom_variable: string;
        var l_membre_gauche: integer;
        begin 
          with g_interprete do
          begin
            l_nom_variable:= texte_symbole;
            if not f_variable_existe
              then alloue_variable;
            l_membre_gauche:= indice_variable_courante;
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_egal
              then begin
                  lis_symbole(p_pt_programme);
                  case type_symbole of
                    symbole_nombre_constant :
                      begin
                        genere('mov    w [$'
                              + f_entier_hexadecimal(indice_variable_courante* 2)
                              + '], $'+ f_entier_hexadecimal(round(valeur_numerique_symbole)));
                        lis_symbole(p_pt_programme);
                      end;
                    symbole_variable :
                      begin
                        if not f_variable_existe
                          then affiche_erreur_programme(p_pt_programme, 'variable '
                                           + texte_symbole+ ' existe pas');
                        genere('mov    ax, [$'
                               + f_entier_hexadecimal(indice_variable_courante* 2)
                               + ']');
                        genere('mov    [$'
                                + f_entier_hexadecimal(l_membre_gauche* 2)
                                + '], ax');
                        lis_symbole(p_pt_programme);
                      end;
                    else affiche_erreur_programme(p_pt_programme,
                        'erreur d''affectation');
                  end; 
                end
              else affiche_erreur_programme(p_pt_programme, 'aprs '+ l_nom_variable+ ' attend =');
          end; 
        end; 

      procedure traite_INPUT;
        var l_chaine: string;
            l_taille_chaine: integer;
            l_erreur: integer;

        procedure lis_variable_de_type_inconnu;
          var l_reel: real;
          begin
            with g_interprete do
            begin
              val(l_chaine, l_reel, l_erreur);
              with g_interprete, table_variables[indice_variable_courante].pt_descripteur^ do
              begin
                if (l_erreur= 0) and (l_taille_chaine<> 0)
                  then begin
                      type_zone:= 'N';
                      valeur_numerique:= l_reel;
                    end
                  else type_zone:= 'C';
              end;
            end; 
          end; 

        begin 
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_chaine_constante
              then affiche_un_facteur;
            if type_symbole= symbole_TO
              then begin
                  lis_symbole(p_pt_programme);
                  if type_symbole= symbole_variable
                    then begin
                        if not f_variable_existe
                          then alloue_variable;
                        genere('call   lis_entier');
                        genere('mov    [$'+ f_entier_hexadecimal(indice_variable_courante* 2)
                             + '], bx');
                      end
                    else affiche_erreur_programme(p_pt_programme,
                        'attend un nom de variable');
                end
              else affiche_erreur_programme(p_pt_programme, 'attend TO');
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_arobas;
        var l_ligne, l_colonne: integer;

        procedure traite_SAY;
          begin
            with g_interprete do
            begin
              genere('seg    cs');
              genere('mov    w [curseur_x], $'+ f_entier_hexadecimal(l_colonne));
              genere('seg    cs');
              genere('mov    b [curseur_y], $'+ f_entier_hexadecimal(l_ligne));
              lis_symbole(p_pt_programme);
              affiche_un_facteur;
            end; 
          end; 

        begin 
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            traite_expression;
            l_ligne:= round(valeur_numerique_symbole);
            if type_symbole<> symbole_virgule
              then affiche_erreur_programme(p_pt_programme, 'attend ,');
            lis_symbole(p_pt_programme);
            traite_expression;
            l_colonne:= round(valeur_numerique_symbole);
            case type_symbole of
              symbole_SAY : traite_SAY;
            end; 
          end; 
        end; 

      procedure traite_IF;
        var l_label_execute_if, l_label_else_ou_end_if, l_label_end_if: t_label;
            l_numero_label: integer;
        begin
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            genere_condition;
            l_numero_label:= l_numero_if;
            l_label_execute_if:= f_cree_label(symbole_if, l_numero_label);
            l_label_else_ou_end_if:= f_cree_label(symbole_else, l_numero_label);
            with g_interprete do
              l_numero_if:= l_numero_if+ 1;
            genere('je     '+ l_label_execute_if);
            genere('jmp    '+ l_label_else_ou_end_if);
            genere_label(l_label_execute_if);
            traite_instructions(p_pt_programme,
                  [symbole_fin, symbole_else, symbole_endif], p_nom_proprietaire);
            if type_symbole= symbole_ELSE
              then begin
                  l_label_end_if:= f_cree_label(symbole_endif, l_numero_label);
                  genere('jmp    '+ l_label_end_if);
                  genere_label(l_label_else_ou_end_if);
                  lis_symbole(p_pt_programme);
                  traite_instructions(p_pt_programme,
                        [symbole_fin, symbole_endif], p_nom_proprietaire);
                  genere_label(l_label_end_if);
                end
              else genere_label(l_label_else_ou_end_if);
            lis_symbole(p_pt_programme);
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_WHILE;
        var l_label_debut_while, l_label_execute_while, l_label_fin_while: t_label;
        begin
          with g_interprete do
          begin
            l_label_debut_while:= 'debut'+ f_cree_label(symbole_while, l_numero_while);
            l_label_execute_while:= 'execute'+ f_cree_label(symbole_while, l_numero_while);
            l_label_fin_while:= 'fin'+ f_cree_label(symbole_while, l_numero_while);
            l_numero_while:= l_numero_while+ 1;
            genere_label(l_label_debut_while);
            lis_symbole(p_pt_programme);
            genere_condition;
            genere('je     '+ l_label_execute_while);
            genere('jmp    '+ l_label_fin_while);
            genere_label(l_label_execute_while);
            traite_instructions(p_pt_programme, [symbole_fin, symbole_enddo], p_nom_proprietaire);
            genere('jmp    '+ l_label_debut_while);
            genere_label(l_label_fin_while);
            lis_symbole(p_pt_programme);
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_DO;
        begin 
          lis_symbole(p_pt_programme);
          case g_interprete.type_symbole of
            symbole_while : traite_WHILE;
          end; 
        end; 

      procedure traite_CLEAR;
        begin 
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole in [symbole_retour_chariot, symbole_SCREEN]
              then begin
                   genere('call   clrscr');
                   genere('call   initialise_curseur');
                 end;
            if type_symbole in [symbole_retour_chariot, symbole_MEMORY]
              then 
                    g_interprete.indice_variable_libre:= 0;
            if type_symbole<> symbole_retour_chariot
              then lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_STOPPE;
        begin
          genere('call   stoppe');
          lis_symbole(p_pt_programme);
        end; 
