(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)


      procedure traite_expression;
        var l_valeur_constante, l_valeur_terme, l_valeur_expression: real;

        procedure compile_expression;
          var l_plus_moins: t_symbole;
              l_expression: real;
              l_signe: real;

          procedure compile_terme;
            var l_fois_divise: t_symbole;
                l_terme: real;

            procedure compile_facteur;
              var l_sauve_expression: real;

              procedure verifie_type_expression(p_type: char);
                begin
                  with g_interprete do
                  begin
                    if type_expression= '?'
                      then type_expression:= p_type
                      else
                        if type_expression<> p_type
                          then affiche_erreur_programme(p_pt_programme,
                              'expression '+ type_expression+ ' et '+ p_type);
                  end; 
                end; 

              procedure extrais_variable;
                var l_indice_variable_precedente: integer;
                begin
                  with g_interprete do
                  begin
                    l_indice_variable_precedente:= indice_variable_courante;
                    if f_variable_existe
                      then begin
                          with table_variables[indice_variable_courante].pt_descripteur^ do
                          begin
                            case type_zone of
                              'C' : begin
                                      type_symbole:= symbole_chaine_constante;
                                      l_texte_expression:= l_texte_expression
                                         + 'f_extrais_chaine('
                                         + f_entier_chaine(indice_variable_courante)+ ')';
                                      verifie_type_expression('C');
                                    end;
                              'N' : begin
                                      type_symbole:= symbole_nombre_constant;
                                      l_texte_expression:= l_texte_expression+ f_variable;
                                      verifie_type_expression('N');
                                    end;
                              else affiche_erreur_programme(p_pt_programme,
                                  'sait pas traiter ce type (dynamique ? )');
                            end; 
                          end 
                        end 
                      else affiche_erreur_programme(p_pt_programme, 'pas cette variable');
                    indice_variable_courante:= l_indice_variable_precedente;
                    lis_symbole(p_pt_programme)
                  end; 
                end; 

              begin 
                with g_interprete do
                begin
                  case type_symbole of
                    symbole_variable : extrais_variable;
                    symbole_nombre_constant :
                      begin
                        verifie_type_expression('N');
                        l_texte_expression:= l_texte_expression+ texte_symbole;
                        lis_symbole(p_pt_programme);
                      end;
                    symbole_parenthese_ouvrante :
                      begin
                        l_texte_expression:= l_texte_expression+ '(';
                        lis_symbole(p_pt_programme);
                        compile_expression;
                        if type_symbole= symbole_parenthese_fermante
                          then begin
                              l_texte_expression:= l_texte_expression+ ')';
                              lis_symbole(p_pt_programme);
                            end
                          else affiche_erreur_programme(p_pt_programme, 'manque )');
                      end;
                    symbole_chaine_constante :
                      begin
                        verifie_type_expression('C');
                        l_texte_expression:= l_texte_expression+ ''''+ texte_symbole+ '''';
                        lis_symbole(p_pt_programme)
                      end;
                    else begin
                        affiche_erreur_programme(p_pt_programme,
                            'attend fact: k, var, (: '+ texte_symbole);
                        lis_symbole(p_pt_programme);
                      end;
                  end; 
                end; 
              end; 

            begin 
              with g_interprete do
              begin
                compile_facteur;
                while type_symbole in [symbole_fois, symbole_divise] do
                begin
                  l_texte_expression:= l_texte_expression+ texte_symbole;
                  lis_symbole(p_pt_programme);
                  compile_facteur;
                end; 
              end; 
            end; 

          begin 
            with g_interprete do
            begin
              if type_symbole in [symbole_plus, symbole_moins]
                then begin
                    l_texte_expression:= l_texte_expression+ texte_symbole;
                    lis_symbole(p_pt_programme);
                    compile_terme;
                  end
                else begin
                    compile_terme;
                  end;
              while type_symbole in [symbole_plus, symbole_moins] do
              begin
                l_texte_expression:= l_texte_expression+ texte_symbole;
                lis_symbole(p_pt_programme);
                compile_terme;
              end; 
            end; 
          end; 

        begin 
          g_interprete.type_expression:= '?';
          l_texte_expression:= '';
          compile_expression;
          g_interprete.valeur_numerique_symbole:= l_valeur_expression;
        end; 

      procedure traite_condition;
        const k_precision= 1e-20;
        var l_reel_gauche, l_reel_droite: real;
            l_chaine_gauche: string;
            l_type_membre_gauche: char;
            l_type_signe: t_symbole;
        begin
          with g_interprete do
          begin
            traite_expression;  genere(l_texte_expression);
            case type_expression of
              'C' : ;
              'N' : ;
              else affiche_erreur_programme(p_pt_programme, 'membre gauche que C ou N');
            end; 
            l_type_membre_gauche:= type_expression;
            if type_symbole in [symbole_egal, symbole_inferieur, symbole_superieur]
              then begin
                  genere(texte_symbole);
                  l_type_signe:= type_symbole;
                  lis_symbole(p_pt_programme);
                  traite_expression;
                  if type_expression<> l_type_membre_gauche
                    then affiche_erreur_programme(p_pt_programme,
                        l_type_membre_gauche+ ' comp '+ type_expression);
                  case l_type_signe of
                    symbole_egal : ;
                    symbole_inferieur : ;
                    symbole_superieur : ;
                    else affiche_erreur_programme(p_pt_programme, 'bug: pas ce signe');
                  end; 
                  case type_expression of
                    'C' : ;
                    'N' : ;
                    else affiche_erreur_programme(p_pt_programme, 'membre droite que C ou N');
                  end; 
                  genere(l_texte_expression);
                end 
              else affiche_erreur_programme(p_pt_programme, 'attend =, <, > ');
            while type_symbole= symbole_retour_chariot do
              lis_symbole(p_pt_programme);
          end; 
        end; 
