(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)


      procedure affiche_un_facteur;
        var l_indice: integer;
        begin
          with g_interprete do
          begin
            case type_symbole of
              symbole_variable :
                if f_variable_existe
                  then begin
                      genere_mot(k_code_MOV_DX_MEMOIRE, k_normal);
                      genere_mot(indice_variable_courante* 2, k_ligne);
                      genere_call(k_adresse_affiche_hex_dx);
                    end
                  else affiche_erreur_programme(p_pt_programme,
                            'variable '+ texte_symbole+ ' inconnue');
              symbole_chaine_constante :
                begin
                  genere_call(k_adresse_affiche_chaine);
                  for l_indice:= 1 to length(texte_symbole) do
                    genere_octet(ord(texte_symbole[l_indice]), k_normal);
                  genere_octet(0, k_ligne);
                end;
              symbole_nombre_constant:
                begin
                  genere_octet(k_code_MOV_DX_IMMEDIAT, k_normal);
                  genere_entier(round(valeur_numerique_symbole), k_ligne);
                  genere_call(k_adresse_affiche_hex_dx);
                end;
              else
                affiche_erreur_programme(p_pt_programme,
                    'attend nom variable ou constante, pas >'+ texte_symbole+ '<');
            end; 
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_point_interrogation;
        var l_premier: boolean;
        begin
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            repeat
              if l_premier
                then l_premier:= false;
              affiche_un_facteur;
            until type_symbole= symbole_retour_chariot;
            genere_call(k_adresse_a_la_ligne);
          end; 
        end; 

      procedure traite_WRITE;
        var l_premier: boolean;
        begin
          with g_interprete, g_sortie do
          begin
            l_premier:= true;
            lis_symbole(p_pt_programme);
            repeat
              if l_premier
                then l_premier:= false;
              affiche_un_facteur;
            until type_symbole= symbole_retour_chariot;
          end; 
        end; 

      procedure traite_affectation;
        var l_nom_variable: string;
            l_membre_gauche: integer;
        begin 
          with g_interprete do
          begin
            l_nom_variable:= texte_symbole;
            if not f_variable_existe
              then alloue_variable;
            l_membre_gauche:= indice_variable_courante;
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_egal
              then begin
                  lis_symbole(p_pt_programme);
                  case type_symbole of
                    symbole_nombre_constant :
                      begin
                        genere_mot(k_code_MOV_W_MEMOIRE_IMMEDIAT, k_normal);
                        genere_mot(indice_variable_courante* 2, k_normal);
                        genere_mot(round(valeur_numerique_symbole), k_ligne);
                        lis_symbole(p_pt_programme);
                      end;
                    symbole_variable :
                      begin
                        if not f_variable_existe
                          then affiche_erreur_programme(p_pt_programme, 'variable '
                                            + texte_symbole+ ' existe pas');
                        genere_octet(k_code_MOV_AX_MEMOIRE, k_normal);
                        genere_mot(indice_variable_courante* 2, k_ligne);
                        genere_octet(k_code_MOV_MEMOIRE_AX, k_normal);
                        genere_mot(l_membre_gauche* 2, k_ligne);
                        lis_symbole(p_pt_programme);
                      end;
                    else
                      affiche_erreur_programme(p_pt_programme, 'erreur d''affectation');
                  end; 
                end
              else affiche_erreur_programme(p_pt_programme, 'aprs '+ l_nom_variable+ ' attend =');
          end; 
        end; 

      procedure traite_INPUT;
        var l_chaine: string;
            l_taille_chaine: integer;
            l_erreur: integer;

        procedure lis_variable_de_type_inconnu;
          var l_reel: real;
          begin
            with g_interprete do
            begin
              val(l_chaine, l_reel, l_erreur);
              with table_variables[indice_variable_courante].pt_descripteur^ do
              begin
                if (l_erreur= 0) and (l_taille_chaine<> 0)
                  then begin
                      type_zone:= 'N';
                      valeur_numerique:= l_reel;
                    end
                  else type_zone:= 'C';
              end;
            end; 
          end; 

        begin 
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_chaine_constante
              then begin
                  affiche_un_facteur;
                end;
            if type_symbole= symbole_TO
              then begin
                  lis_symbole(p_pt_programme);
                  if type_symbole= symbole_variable
                    then begin
                        if not f_variable_existe
                          then alloue_variable;
                        genere_call(k_adresse_lis_entier);
                        genere_mot(k_code_MOV_MEMOIRE_BX, k_normal);
                        genere_mot(indice_variable_courante* 2, k_ligne);
                      end
                    else affiche_erreur_programme(p_pt_programme,
                        'attend un nom de variable');
                end
              else affiche_erreur_programme(p_pt_programme, 'attend TO');
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_arobas;
        var l_ligne, l_colonne: integer;

        procedure traite_SAY;
          begin
            with g_interprete do
            begin
              genere_octet(k_code_SEG_CS, k_ligne);
              genere_mot(k_code_MOV_W_MEMOIRE_IMMEDIAT, k_normal);
              genere_entier(k_adresse_curseur_x, k_normal);
              genere_entier(l_colonne, k_ligne); readln;
              genere_octet(k_code_SEG_CS, k_ligne);
              genere_mot(k_code_MOV_B_MEMOIRE_IMMEDIAT, k_normal);
              genere_entier(k_adresse_curseur_y, k_normal);
              genere_octet(l_ligne, k_ligne);
              lis_symbole(p_pt_programme);
              affiche_un_facteur;
            end; 
          end; 

        begin 
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            traite_expression;
            l_ligne:= round(valeur_numerique_symbole);
            if type_symbole<> symbole_virgule
              then affiche_erreur_programme(p_pt_programme, 'attend ,');
            lis_symbole(p_pt_programme);
            traite_expression;
            l_colonne:= round(valeur_numerique_symbole);
            case type_symbole of
              symbole_SAY : traite_SAY;
            end; 
          end; 
        end; 

      procedure traite_IF;
        var l_label_execute_if, l_label_else_ou_end_if, l_label_end_if: t_label;
            l_numero_label: integer;
        begin
          with g_interprete do
          begin
          end; 
        end; 
      procedure traite_WHILE;
        var l_label_debut_while, l_adresse_jmp_fin: integer;
        begin
          with g_interprete, g_objet do
          begin
            l_label_debut_while:= indice_objet;
            lis_symbole(p_pt_programme);
            genere_condition;
            genere_octet(k_code_JE, k_normal);
            genere_octet($03, k_ligne);
            l_adresse_jmp_fin:= indice_objet;
            indice_objet:= indice_objet+ 3;
            traite_instructions(p_pt_programme, [symbole_fin, symbole_enddo], p_nom_proprietaire);
            genere_jmp(indice_objet, l_label_debut_while);
            indice_objet:= indice_objet+ 3;
            genere_JMP(l_adresse_jmp_fin, indice_objet);
            lis_symbole(p_pt_programme);
            lis_symbole(p_pt_programme);
          end; 
        end; 
      procedure traite_DO;
        begin 
          lis_symbole(p_pt_programme);
          case g_interprete.type_symbole of
            symbole_while : traite_WHILE;
          end; 
        end; 
      procedure traite_CLEAR;
        begin 
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole in [symbole_retour_chariot, symbole_SCREEN]
              then begin
                   genere_call(k_adresse_clrscr);
                   genere_call(k_adresse_initialise_curseur);
                 end;
            if type_symbole in [symbole_retour_chariot, symbole_MEMORY]
              then 
                    g_interprete.indice_variable_libre:= 0;
            if type_symbole<> symbole_retour_chariot
              then lis_symbole(p_pt_programme);
          end; 
        end; 
      procedure traite_STOPPE;
        begin
          genere_call(k_adresse_stoppe);
          lis_symbole(p_pt_programme);
        end; 
