(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)


      procedure traite_DISPLAY;
        begin
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_MEMORY
              then affiche_variables
              else affiche_erreur_programme(p_pt_programme, 'attend MEMORY');
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_point_interrogation;
        begin
          with g_interprete, g_sortie do
          begin
            lis_symbole(p_pt_programme);
            repeat
              traite_expression;
              case type_expression of
                'C' : write(sortie, valeur_expression_chaine);
                'N' : write(sortie, valeur_numerique_symbole);
                else
                  affiche_erreur_programme(p_pt_programme,
                      'attend chaine ou expression, pas '+ texte_symbole);
              end; 
            until type_symbole= symbole_retour_chariot;
            writeln(sortie);
          end; 
        end; 

      procedure traite_WRITE;
        begin
          with g_interprete, g_sortie do
          begin
            lis_symbole(p_pt_programme);
            repeat
              traite_expression;
              case type_expression of
                'C' : write(sortie, valeur_expression_chaine);
                'N' : write(sortie, valeur_numerique_symbole);
                else
                  affiche_erreur_programme(p_pt_programme,
                      'attend chaine ou expression, pas '+ texte_symbole);
              end; 
            until type_symbole= symbole_retour_chariot;
          end; 
        end; 

      procedure traite_affectation;
        var l_nom_variable: string;

        procedure affecte_expression;
          begin
            with g_interprete, table_variables[indice_variable_courante].pt_descripteur^ do
            begin
              case type_expression of
                'C' : begin
                        if type_zone= '?'
                          then type_zone:= 'C'
                          else
                            if type_zone<> 'C'
                              then affiche_erreur_programme(p_pt_programme,
                                 'affecte '+ type_zone+ '= C');
                        stocke_valeur_chaine(valeur_expression_chaine[1],
                            length(valeur_expression_chaine));
                      end;
                'N' : begin
                        if type_zone= '?'
                          then type_zone:= 'N'
                          else
                            if type_zone<> 'N'
                              then affiche_erreur_programme(p_pt_programme,
                                 'affecte '+ type_zone+ '= N');
                        valeur_numerique:= valeur_numerique_symbole;
                      end;
                else affiche_erreur_programme(p_pt_programme,
                    'expression de type inconnu '+ type_expression);
              end; 
            end; 
          end; 

        procedure traite_SPACE;
          begin
            with g_interprete do
            begin
              lis_symbole(p_pt_programme);
              if type_symbole= symbole_parenthese_ouvrante
                then begin
                    lis_symbole(p_pt_programme);
                    traite_expression;
                    if type_expression= 'N'
                      then begin
                          fillchar(valeur_expression_chaine[1],
                              round(valeur_numerique_symbole), ' ');
                          valeur_expression_chaine[0]:=
                              chr(round(valeur_numerique_symbole));
                          type_expression:= 'C';
                          affecte_expression;
                        end
                      else affiche_erreur_programme(p_pt_programme,
                          'attend valeur numrique '+ type_expression);
                    lis_symbole(p_pt_programme);
                  end
                else affiche_erreur_programme(p_pt_programme, 'attend (');
            end; 
          end; 

        begin 
          with g_interprete do
          begin
            l_nom_variable:= texte_symbole;
            if not f_variable_existe
              then alloue_variable;
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_egal
              then begin
                  lis_symbole(p_pt_programme);
                  case type_symbole of
                    symbole_SPACE : traite_SPACE;
                    symbole_chaine_constante, symbole_nombre_constant,
                      symbole_parenthese_ouvrante,
                      symbole_variable : begin
                                           traite_expression;
                                           affecte_expression;
                                         end;
                    else
                      affiche_erreur_programme(p_pt_programme, 'erreur d''affectation');
                  end; 
                end
              else affiche_erreur_programme(p_pt_programme, 'aprs '+ l_nom_variable+ ' attend =');
          end; 
        end; 

      procedure traite_INPUT;
        var l_chaine: string;
            l_taille_chaine: integer;
            l_erreur: integer;

        procedure lis_variable_de_type_inconnu;
          var l_reel: real;
          begin
            with g_interprete do
            begin
              val(l_chaine, l_reel, l_erreur);
              with g_interprete, table_variables[indice_variable_courante].pt_descripteur^ do
              begin
                if (l_erreur= 0) and (l_taille_chaine<> 0)
                  then begin
                      type_zone:= 'N';
                      valeur_numerique:= l_reel;
                    end
                  else type_zone:= 'C';
              end;
            end; 
          end; 

        begin 
          with g_interprete, g_sortie do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole= symbole_chaine_constante
              then begin
                  write(sortie, texte_symbole);
                  lis_symbole(p_pt_programme);
                end;
            if type_symbole= symbole_TO
              then begin
                  lis_symbole(p_pt_programme);
                  if type_symbole= symbole_variable
                    then begin
                        if not f_variable_existe
                          then alloue_variable;
                        readln(l_chaine);
                        l_taille_chaine:= length(l_chaine);
                        stocke_valeur_chaine(l_chaine[1], l_taille_chaine);
                        with table_variables[indice_variable_courante].pt_descripteur^ do
                          case type_zone of
                            'C' :  ;
                            'N' : begin
                                    val(l_chaine, valeur_numerique, l_erreur);
                                    if (l_erreur<> 0) and (l_chaine<> '')
                                      then affiche_erreur_programme(p_pt_programme,
                                          'saisie numrique incorrecte');
                                  end;
                            else lis_variable_de_type_inconnu;
                          end; 
                      end
                    else affiche_erreur_programme(p_pt_programme,
                        'attend un nom de variable');
                end
              else affiche_erreur_programme(p_pt_programme, 'attend TO');
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_RELEASE;
        begin
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if f_variable_existe
              then begin
                  with g_interprete do
                    table_variables[indice_variable_courante].proprietaire[1]:= '*';
                end
              else affiche_erreur_programme(p_pt_programme,
                  'variable '+ texte_symbole+ 'n''existe pas');
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_PUBLIC;
        begin
          lis_symbole(p_pt_programme);
          if not f_variable_existe
            then alloue_variable;
          with g_interprete do
            table_variables[indice_variable_courante].proprietaire:= p_nom_proprietaire;
          lis_symbole(p_pt_programme);
        end; 

      procedure traite_PRIVATE;
        begin
          lis_symbole(p_pt_programme);
          if not f_variable_existe
            then alloue_variable;
          with g_interprete do
            table_variables[indice_variable_courante].privee:= true;
          lis_symbole(p_pt_programme);
        end; 

      procedure traite_arobas;
        var l_ligne, l_colonne: integer;

        procedure traite_GET;
          var l_pt_descripteur_de_zone: t_pt_descripteur_de_zone;
              l_numero_champ: integer;
          begin
            with g_interprete do
            begin
              lis_symbole(p_pt_programme);
              if type_symbole= symbole_variable
                then begin
                    if not f_variable_existe
                      then affiche_erreur_programme(p_pt_programme,
                          'variable doit tre initialise');
                    with g_interprete do
                      l_pt_descripteur_de_zone:=
                          table_variables[indice_variable_courante].pt_descripteur;
                    with l_pt_descripteur_de_zone^ do
                      case type_zone of
                        'C' : initialise_champ(l_groupe_champs,
                                  l_pt_descripteur_de_zone,
                                  0, l_ligne, l_colonne, taille_zone, 0,
                                  '', 0);
                        else affiche_erreur('pas implment ce type de zone '+ type_zone+ '<');
                      end; 
                  end 
                else affiche_erreur_programme(p_pt_programme, 'attend nom de variable');
            end; 
          end; 

        procedure traite_SAY;
          begin
            with g_interprete, g_sortie do
            begin
              gotoxy(l_colonne, l_ligne);
              lis_symbole(p_pt_programme);
              traite_expression;
              case type_expression of
                'C' : write(sortie, valeur_expression_chaine);
                'N' : write(sortie, valeur_numerique_symbole);
                else affiche_erreur_programme(p_pt_programme,
                    'attend chaine ou expression numrique');
              end; 
            end; 
          end; 

        begin 
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            traite_expression;
            l_ligne:= round(valeur_numerique_symbole);
            if type_symbole<> symbole_virgule
              then affiche_erreur_programme(p_pt_programme, 'attend ,');
            lis_symbole(p_pt_programme);
            traite_expression;
            l_colonne:= round(valeur_numerique_symbole);
            case type_symbole of
              symbole_SAY : traite_SAY;
              symbole_GET : traite_GET;
            end; 
            lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_READ;
        var l_pt_page: t_pt_page;
            l_pt_champ: t_pt_champ;

        procedure affiche_champs_de_la_page(p_pt_page: t_pt_page);
          var l_pt_champ: t_pt_champ;
              l_pt_titre: t_pt_titre;
          begin
            with p_pt_page^ do
            begin
              l_pt_champ:= pt_champ_debut;
              while l_pt_champ<> nil do
              begin
                affiche_champ(l_pt_champ, k_video_inverse);
                l_pt_champ:= l_pt_champ^.pt_champ_suivant;
              end; 
            end; 
          end; 

        begin 
          clrscr;
          l_pt_page:= l_groupe_champs.pt_page_debut;
          l_pt_champ:= l_pt_page^.pt_champ_debut;
          affiche_champs_de_la_page(l_groupe_champs.pt_page_debut);
          with g_parametres_saisie do
            saisis_groupe_de_champs(l_groupe_champs,
                  l_pt_page, l_pt_champ, position_dans_champ,
                  true, l_pt_fichier_memo);
          libere_groupe_de_champs(l_groupe_champs);
          initialise_groupe_de_champs(l_groupe_champs);
          lis_symbole(p_pt_programme);
        end; 

      procedure purge_fin_ligne_return;
        begin
          with g_interprete do
          begin
            while type_symbole<> symbole_retour_chariot do
              lis_symbole(p_pt_programme);
            while type_symbole= symbole_retour_chariot do
              lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure saute_jusqu_a(p_symbole_arret: t_ensemble_de_symboles);
        begin
          with g_interprete do
            repeat
              lis_symbole(p_pt_programme);
              case type_symbole of
                symbole_WHILE : if p_symbole_arret= [symbole_ENDDO]
                                  then begin
                                      saute_jusqu_a([symbole_ENDDO]);
                                      purge_fin_ligne_return;
                                    end;
                symbole_IF : if p_symbole_arret<= [symbole_ENDIF, symbole_ELSE]
                  then begin
                      saute_jusqu_a([symbole_ENDIF]);
                      purge_fin_ligne_return;
                    end;
              end;
            until type_symbole in p_symbole_arret;
        end; 

      procedure traite_IF;
        begin
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if f_condition_vraie
              then begin
                  traite_instructions(p_pt_programme,
                      [symbole_fin, symbole_ELSE, symbole_ENDIF],
                      p_nom_proprietaire);
                  if type_symbole= symbole_ELSE
                    then saute_jusqu_a([symbole_ENDIF]);
                  purge_fin_ligne_return;
                end
              else begin
                  saute_jusqu_a([symbole_ELSE, symbole_ENDIF]);
                  if type_symbole= symbole_ELSE
                    then begin
                        purge_fin_ligne_return;
                        traite_instructions(p_pt_programme,
                            [symbole_fin, symbole_ELSE, symbole_ENDIF],
                            p_nom_proprietaire);
                      end;
                  purge_fin_ligne_return;
                end;
          end; 
        end; 

      procedure traite_WHILE;
        var l_indice_condition: integer;
        begin
          with g_interprete do
          begin
            l_indice_condition:= p_pt_programme^.indice_courant;
            lis_symbole(p_pt_programme);
            while f_condition_vraie do
            begin
              traite_instructions(p_pt_programme, [symbole_fin, symbole_ENDDO],
                  p_nom_proprietaire);
              p_pt_programme^.indice_courant:= l_indice_condition;
              lis_symbole(p_pt_programme);
            end; 
            saute_jusqu_a([symbole_ENDDO]);
            purge_fin_ligne_return;
          end; 
        end; 

      procedure traite_DO;

        procedure traite_DO_programme;
          var l_pt_programme: t_pt_texte;
              l_indice_variable: integer;
          begin
            with g_interprete do
            begin
              charge_texte(l_pt_programme, 'a:'+ texte_symbole+ k_suffixe_programme, k_texte_max);
              l_pt_programme^.indice_courant:= 0;
              lis_symbole(l_pt_programme);
              traite_instructions(l_pt_programme, [symbole_fin], p_pt_programme^.nom_texte);
              with g_interprete, l_pt_programme^ do
                for l_indice_variable:= 1 to indice_variable_max do
                  with table_variables[l_indice_variable] do
                    if proprietaire= l_pt_programme^.nom_texte
                      then proprietaire[1]:= '*';
              lis_symbole(p_pt_programme);
            end; 
          end; 

        procedure traite_ampersand;
          var l_pt_programme: t_pt_texte;
          begin
            with g_interprete do
            begin
              lis_symbole(p_pt_programme);
              if type_symbole= symbole_variable
                then begin
                    if f_variable_existe
                      then begin
                          getmem(l_pt_programme, sizeof(t_texte));
                          with l_pt_programme^ do
                          begin
                            nom_texte:= p_pt_programme^.nom_texte;
                            texte_max:= 256;
                            getmem(pt_tampon_texte, 255);
                            with g_interprete,
                                table_variables[indice_variable_courante].pt_descripteur^ do
                            begin
                              if taille_zone> 0
                                then move(pt_valeur_zone^, pt_tampon_texte^, taille_zone);
                              fin_texte:= taille_zone;
                            end;
                            pt_tampon_texte^[fin_texte]:= k_RETURN;
                            pt_tampon_texte^[fin_texte+ 1]:= k_INTERLIGNE;
                            fin_texte:= fin_texte+ 2;
                            indice_courant:= 0;
                          end; 
                          lis_symbole(l_pt_programme);
                          traite_instructions(l_pt_programme, [symbole_fin],
                              p_pt_programme^.nom_texte);
                        end
                      else affiche_erreur_programme(p_pt_programme,
                          'la variable '+ texte_symbole+ ' n''existe pas');
                  end
                else affiche_erreur_programme(p_pt_programme, 'que: & nom_variable');
              lis_symbole(p_pt_programme);
            end; 
          end; 

        begin 
          lis_symbole(p_pt_programme);
          case g_interprete.type_symbole of
            symbole_while : traite_WHILE;
            symbole_variable : traite_DO_programme;
            symbole_ampersand : traite_ampersand;
          end; 
        end; 

      procedure traite_CLEAR;

        procedure CLEAR_GETs;
          begin
            initialise_groupe_de_champs(l_groupe_champs);
          end; 

        begin 
          with g_interprete do
          begin
            lis_symbole(p_pt_programme);
            if type_symbole in [symbole_retour_chariot, symbole_SCREEN]
              then 
                   clrscr;
            if type_symbole in [symbole_retour_chariot, symbole_MEMORY]
              then 
                    g_interprete.indice_variable_libre:= 0;
            if type_symbole in [symbole_retour_chariot, symbole_GET]
              then 
                   CLEAR_GETs;
            if type_symbole<> symbole_retour_chariot
              then lis_symbole(p_pt_programme);
          end; 
        end; 

      procedure traite_STOPPE;
        begin
          write(' $', f_pointeur_hexadecimal(heapptr), ' ');
          stoppe;
          lis_symbole(p_pt_programme);
        end; 
