(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)


      procedure traite_expression;
        var l_valeur_constante, l_valeur_terme, l_valeur_expression: real;

        procedure compile_expression;
          var l_plus_moins: t_symbole;
              l_expression: real;
              l_signe: real;

          procedure compile_terme;
            var l_fois_divise: t_symbole;
                l_terme: real;

            procedure compile_facteur;
              var l_sauve_expression: real;

              procedure extrais_variable;
                var l_indice_variable_precedente: integer;
                begin
                  with g_interprete do
                  begin
                    l_indice_variable_precedente:= indice_variable_courante;
                    if f_variable_existe
                      then
                        with table_variables[indice_variable_courante].pt_descripteur^ do
                        begin
                          case type_zone of
                            'C' : begin
                                    type_symbole:= symbole_chaine_constante;
                                    if taille_zone> 0
                                      then move(pt_valeur_zone^, texte_symbole[1],
                                          taille_zone);
                                    texte_symbole[0]:= chr(taille_zone);
                                  end;
                            'N' : begin
                                    type_symbole:= symbole_nombre_constant;
                                    valeur_numerique_symbole:= valeur_numerique;
                                  end;
                            else affiche_erreur_programme(p_pt_programme,
                                'sait pas traiter cette var ');
                          end; 
                        end
                      else affiche_erreur_programme(p_pt_programme, 'pas cette variable');
                    indice_variable_courante:= l_indice_variable_precedente;
                  end; 
                end; 

              begin 
                with g_interprete do
                begin
                  if type_symbole= symbole_variable
                    then extrais_variable;
                  case type_symbole of
                    symbole_nombre_constant :
                      begin
                        if type_expression= '?'
                          then type_expression:= 'N'
                          else
                            if type_expression<> 'N'
                              then affiche_erreur_programme(p_pt_programme,
                                  'expression '+ type_expression+ ' et N' );
                        l_valeur_constante:= 1.0* valeur_numerique_symbole;
                        lis_symbole(p_pt_programme);
                      end;
                    symbole_parenthese_ouvrante :
                      begin
                        lis_symbole(p_pt_programme);
                        l_sauve_expression:= l_valeur_expression;
                        compile_expression;
                        l_valeur_constante:= l_valeur_expression;
                        l_valeur_expression:= l_sauve_expression;
                        if type_symbole= symbole_parenthese_fermante
                          then lis_symbole(p_pt_programme)
                          else affiche_erreur_programme(p_pt_programme, 'manque )');
                      end;
                    symbole_chaine_constante :
                      begin
                        if type_expression= '?'
                          then type_expression:= 'C'
                          else
                            if type_expression<> 'C'
                              then affiche_erreur_programme(p_pt_programme,
                                  'expression '+ type_expression+ ' et C' );
                        valeur_expression_chaine:= texte_symbole;
                        lis_symbole(p_pt_programme)
                      end;
                    else begin
                        affiche_erreur_programme(p_pt_programme,
                            'attend fact: k, var, (: '+ texte_symbole);
                        lis_symbole(p_pt_programme);
                      end;
                  end; 
                end; 
              end; 

            begin 
              with g_interprete do
              begin
                compile_facteur;
                l_terme:= l_valeur_constante;
                while type_symbole in [symbole_fois, symbole_divise] do
                begin
                  l_fois_divise:= type_symbole;
                  lis_symbole(p_pt_programme);
                  compile_facteur;
                  if l_fois_divise= symbole_fois
                    then l_terme:= l_terme* l_valeur_constante
                    else
                      if l_valeur_constante= 0
                        then affiche_erreur_programme(p_pt_programme, 'division par 0')
                        else l_terme:= l_terme / l_valeur_constante;
                end; 
                l_valeur_terme:= l_terme;
              end; 
            end; 

          begin 
            with g_interprete do
            begin
              if type_symbole in [symbole_plus, symbole_moins]
                then begin
                    if type_symbole= symbole_moins
                      then l_signe:= -1.0
                      else l_signe:= +1.0;
                    lis_symbole(p_pt_programme);
                    compile_terme;
                    l_expression:= l_signe* l_valeur_terme;
                  end
                else begin
                    compile_terme;
                    l_expression:= l_valeur_terme;
                  end;
              while type_symbole in [symbole_plus, symbole_moins] do
              begin
                l_plus_moins:= type_symbole;
                lis_symbole(p_pt_programme);
                compile_terme;
                if l_plus_moins= symbole_plus
                  then l_expression:= l_expression+ l_valeur_terme
                  else l_expression:= l_expression- l_valeur_terme;
              end; 
              l_valeur_expression:= l_expression;
            end; 
          end; 

        begin 
          g_interprete.type_expression:= '?';
          compile_expression;
          g_interprete.valeur_numerique_symbole:= l_valeur_expression;
        end; 

      function f_condition_vraie: boolean;
        const k_precision= 1e-20;
        var l_reel_gauche, l_reel_droite: real;
            l_chaine_gauche: string;
            l_type_membre_gauche: char;
            l_type_signe: t_symbole;
        begin
          with g_interprete do
          begin
            traite_expression;
            case type_expression of
              'C' : l_chaine_gauche:= valeur_expression_chaine;
              'N' : l_reel_gauche:= valeur_numerique_symbole;
              else affiche_erreur_programme(p_pt_programme, 'membre gauche que C ou N');
            end; 
            l_type_membre_gauche:= type_expression;
            if type_symbole in [symbole_egal, symbole_inferieur, symbole_superieur]
              then begin
                  l_type_signe:= type_symbole;
                  lis_symbole(p_pt_programme);
                  traite_expression;
                  if type_expression<> l_type_membre_gauche
                    then affiche_erreur_programme(p_pt_programme,
                        l_type_membre_gauche+ ' comp '+ type_expression);
                  case l_type_membre_gauche of
                    'N' : case l_type_signe of
                            symbole_egal : f_condition_vraie:=
                                abs(l_reel_gauche- valeur_numerique_symbole)<  k_precision;
                            symbole_inferieur : f_condition_vraie:=
                                l_reel_gauche< valeur_numerique_symbole;
                            symbole_superieur :
                                f_condition_vraie:= l_reel_gauche> valeur_numerique_symbole;
                            else affiche_erreur_programme(p_pt_programme, 'bug: pas ce signe');
                          end; 
                    'C' : case l_type_signe of
                            symbole_egal : f_condition_vraie:=
                                l_chaine_gauche= valeur_expression_chaine;
                            symbole_inferieur : f_condition_vraie:=
                                l_chaine_gauche< valeur_expression_chaine;
                            symbole_superieur : f_condition_vraie:=
                                l_chaine_gauche> valeur_expression_chaine;
                            else affiche_erreur_programme(p_pt_programme, 'bug: pas ce signe');
                          end; 
                    else affiche_erreur_programme(p_pt_programme, 'membre droite que C ou N');
                  end; 
                end 
              else affiche_erreur_programme(p_pt_programme, 'attend =, <, > ');
            while type_symbole= symbole_retour_chariot do
              lis_symbole(p_pt_programme);
          end; 
        end; 
