(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
(*$b+*)

program interprete_micro_db;
  uses crt,
       uclavier, uerreur,
       utypcons,
       uhex, uchained,
       uecran, usortie, uaffiche,
       udonnees, usaisis, uchamps,
       ubalaye,
       uediteur, umemo,
       ulexical;
  const k_suffixe_programme: string[4]= '.PAS';
        k_chemin_programme= 'A:';
  var g_choix: char;
      g_pt_programme: t_pt_texte;
      g_nom_programme: t_string_80;
      g_trace: boolean;

  procedure interprete_programme(p_pt_programme: t_pt_texte;
      p_ensemble_symboles_finaux: t_ensemble_de_symboles);
    var l_groupe_champs: t_groupe_champs;
        l_pt_fichier_memo: t_pt_fichier_memo;

    procedure traite_instructions(p_pt_programme: t_pt_texte;
               p_ensemble_symboles_finaux_2: t_ensemble_de_symboles;
               p_nom_proprietaire: t_nom_proprietaire);
      (*$i a:iintvar *)
      (*$i a:iintexpr *)
      (*$i a:iintcde *)
      (*$i a:iintfich *)
      begin 
        with g_interprete do
          while not (type_symbole in p_ensemble_symboles_finaux_2) do
          begin
            if g_trace
              then writeln(' ', texte_symbole, ' ');
            case type_symbole of
              symbole_CLEAR : traite_CLEAR;
              symbole_STOPPE : traite_STOPPE;
              symbole_QUIT : ;
              symbole_point_interrogation : traite_point_interrogation;
              symbole_WRITE : traite_WRITE;
              symbole_arobas : traite_arobas;
              symbole_variable : traite_affectation;
              symbole_DISPLAY : traite_DISPLAY;
              symbole_INPUT : traite_INPUT;
              symbole_RELEASE : traite_RELEASE;
              symbole_PUBLIC : traite_PUBLIC;
              symbole_PRIVATE : traite_PRIVATE;
              symbole_IF : traite_IF;
              symbole_DO : traite_DO;
              symbole_READ : traite_READ;
              symbole_CREATE : traite_CREATE;
              symbole_USE : traite_USE;
              symbole_APPEND : traite_APPEND;
              symbole_REPLACE : traite_REPLACE;
              symbole_CLOSE : traite_CLOSE;
              symbole_LIST : traite_LIST;
              else
                affiche_erreur_programme(p_pt_programme,
                    'attend pas le type_symbole '+ texte_symbole+ ' ici');
                lis_symbole(p_pt_programme);
            end; 
            while type_symbole= symbole_retour_chariot do
              lis_symbole(p_pt_programme);
          end; 
      end; 

    begin 
      p_pt_programme^.indice_courant:= 0;
      initialise_groupe_de_champs(l_groupe_champs);
      with g_interprete do
      begin
        indice_variable_max:= 0;
        indice_valeur_variable_suivante:= 0;
        fillchar(table_fichiers, sizeof(table_fichiers), 0);
      end; 
      lis_symbole(p_pt_programme);
      traite_instructions(p_pt_programme,
         p_ensemble_symboles_finaux, p_pt_programme^.nom_texte);
    end; 

  procedure interprete_depuis_clavier(var pv_pt_programme: t_pt_texte);
    begin
      getmem(pv_pt_programme, sizeof(t_texte));
      with pv_pt_programme^ do
      begin
        nom_texte:= 'CLAVIER';
        texte_max:= 256;
        getmem(pt_tampon_texte, 255);
      end; 
      lis_ligne_clavier(pv_pt_programme);
      interprete_programme(pv_pt_programme, [symbole_QUIT]);
    end; 

  procedure go;
    var l_table_noms: array[0..100] of t_string_80;
        l_indice_nom, l_nom_max: integer;
        l_choix: char;

    procedure ajoute_un_programme(p_nom: t_string_80);
      begin
        l_table_noms[l_nom_max]:= p_nom;
        l_nom_max:= l_nom_max+ 1;
      end; 

    begin 
      l_nom_max:= 0;
      ajoute_un_programme('AFFICHE');
      ajoute_un_programme('EXPRESSI');
      ajoute_un_programme('SAY');
      ajoute_un_programme('AFFECTE');
      ajoute_un_programme('AFFECHAI');
      ajoute_un_programme('AFFENUM');
      ajoute_un_programme('RELEASE');
      ajoute_un_programme('INPUT');
      ajoute_un_programme('GETREAD');
      ajoute_un_programme('WHILE');
      ajoute_un_programme('WHILEEMB');
      ajoute_un_programme('IF');
      ajoute_un_programme('IFTHENEL');
      ajoute_un_programme('IFEMB');
      ajoute_un_programme('EDO');
      ajoute_un_programme('EPRIVATE');
      ajoute_un_programme('AMPER');
      ajoute_un_programme('INTERPRE');
      ajoute_un_programme('ECREATEF');
      ajoute_un_programme('EAJOUTEF');
      ajoute_un_programme('ELISTEF');
      ajoute_un_programme('DEUXFICH');
      ajoute_un_programme('FICHSIMU');
      l_indice_nom:= 0; clrscr;
      repeat
        writeln;
        write(l_indice_nom: 2, ' ', l_table_noms[l_indice_nom]);
        write(' continue, Ok, Quitte ? '); lis_touche(l_choix);
        if l_choix= 'o'
          then begin
              g_nom_programme:= l_table_noms[l_indice_nom];
              charge_texte(g_pt_programme,
                  k_chemin_programme+ g_nom_programme+ k_suffixe_programme, k_texte_max);
              with g_pt_programme^ do
                affiche_programme(g_pt_programme);
              stoppe; writeln;
              write('INTERPRETE: ');
              interprete_programme(g_pt_programme, [symbole_fin, symbole_QUIT]);
              writeln;
              libere_texte(g_pt_programme);
            end;
        l_indice_nom:= l_indice_nom+ 1;
      until (l_choix= 'q') or (l_indice_nom= l_nom_max);
    end; 

  procedure initialise;
    begin 
      g_pt_programme:= nil;
      g_nom_programme:= '';
      g_trace:= true;
    end; 

  begin 
    initialise;
    repeat
      writeln;
      writeln(g_nom_programme, ' $', f_pointeur_hexadecimal(heapptr),
        ' long ', f_pointeur_longint(heapptr));
      writeln('manuel:      Nom, Charge, Affiche, Interprete, Klavier, Test, tRace, Sortie');
      write(  'automatique: Go, Quitte ? ');
      lis_touche(g_choix); writeln(g_choix);
      case g_choix of
        ' ' : clrscr;
        'a' : with g_pt_programme^ do
                affiche_programme(g_pt_programme);
        'c' : charge_texte(g_pt_programme,
                  k_chemin_programme+ g_nom_programme+ k_suffixe_programme, k_texte_max);
        'i' : begin
                if g_pt_programme= nil
                  then charge_texte(g_pt_programme,
                      k_chemin_programme+ g_nom_programme+ k_suffixe_programme,
                      k_texte_max);
                interprete_programme(g_pt_programme, [symbole_fin, symbole_QUIT]);
              end;
        'g' : go;
        'k' : interprete_depuis_clavier(g_pt_programme);
        'n' : begin
                write('nom <ESSAI> ? '); readln(g_nom_programme);
               end;
        'r' : affiche_reserves;
        's' : choisis_sortie;
        't' : g_interprete.teste_interprete:= not g_interprete.teste_interprete;
        'r' : g_trace:= not g_trace;
      end; 
    until g_choix= 'q';
  end. 
