(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)

program interprete_nano_db;
  uses crt,
       uclavier, uerreur,
       utypcons,
       uecran, uaffiche, uediteur;
  const k_programme_max= 2000;
        k_taille_reserve_max= 10; 
        k_tampon_valeur_variable_max= 2000;
  type t_tampon_texte= array[0..k_programme_max] of char;
       t_programme= record
                      nom_programme: t_string_80;
                      fin_programme: integer;
                      programme_max: integer;
                      indice_programme: integer;
                      pt_texte_programme: ^t_tampon_texte;
                    end;
       t_pt_programme= ^t_programme;
       t_symbole= (symbole_inconnu,
                   symbole_chaine_constante,
                   symbole_entier_constant,
                   symbole_reserve_debut,
                   symbole_clear,
                   symbole_say,
                   symbole_reserve_fin,
                   symbole_arobas, symbole_virgule, symbole_point_interrogation,
                   symbole_fin);
       t_ensemble_de_symboles= set of t_symbole;
       t_nom_reserve= string[k_taille_reserve_max];
       t_interprete= record
                       ensemble_de_lettres,
                           ensemble_de_separateurs, ensemble_numerique: set of char;
                       table_reserves: array[symbole_reserve_debut..symbole_reserve_fin]
                           of t_nom_reserve;
                       table_symboles_de_ponctuation: array[' '..'_'] of t_symbole;
                     end;
  var g_choix: char;
      g_test: boolean;
      g_interprete: t_interprete;
      g_pt_programme: t_pt_programme;
      g_nom_programme: t_string_80;

  procedure affiche_erreur_entier(p_message: t_string_80; p_entier: integer);
    begin
      writeln;
      write('ERREUR: ', p_message, ' ', p_entier);
      stoppe;
    end; 

  procedure initialise_tables_interprete;
    var l_taille_reserve_max: integer;

    procedure initialise_reserve(p_nom: t_nom_reserve; p_symbole: t_symbole);
      begin
        g_interprete.table_reserves[p_symbole]:= p_nom;
        if length(p_nom)> l_taille_reserve_max
          then l_taille_reserve_max:= length(p_nom);
      end; 

    procedure initialise_ponctuation(p_caractere: char; p_symbole: t_symbole);
      begin
        g_interprete.table_symboles_de_ponctuation[p_caractere]:= p_symbole;
      end; 

    begin 
      with g_interprete do
      begin
        fillchar(g_interprete, sizeof(g_interprete), 0);
        ensemble_de_lettres:= ['A'..'Z', 'a'..'z', '', '', '', '', '',
                                       '', '', '', '', '', '0'..'9', '_'];
        ensemble_de_separateurs:= [' ', #13, #10, #26];
        ensemble_numerique:= ['0'..'9', '.', '-'];
        l_taille_reserve_max:= 0;
        initialise_reserve('CLEAR', symbole_clear);
        initialise_reserve('SAY', symbole_say);
        if l_taille_reserve_max> k_taille_reserve_max
          then affiche_erreur_entier('difference reserve max', l_taille_reserve_max);
        initialise_ponctuation('@', symbole_arobas);
        initialise_ponctuation(',', symbole_virgule);
        initialise_ponctuation('?', symbole_point_interrogation);
      end; 
    end; 

  procedure affiche_symbole_reserve(p_symbole: t_symbole);
    begin
      with g_interprete do
        case p_symbole of
          symbole_arobas : write('@');
          symbole_virgule : write(',');
          symbole_point_interrogation : write('?');
          symbole_clear..symbole_say :
            write(table_reserves[p_symbole]);
        end; 
    end; 

  procedure affiche_reserves;
    var l_symbole: t_symbole;
    begin
      for l_symbole:= succ(symbole_reserve_debut) to pred(symbole_fin) do
        affiche_symbole_reserve(l_symbole);
    end; 

  procedure charge_programme(var pv_pt_programme: t_pt_programme;
      p_nom_programme: t_string_80; p_programme_max: integer);
    var l_programme: file;
    begin
      writeln('charge ', p_nom_programme);
      assign(l_programme, p_nom_programme);
      reset(l_programme, 1);
      getmem(pv_pt_programme, sizeof(t_programme));
      with pv_pt_programme^ do
      begin
        fin_programme:= filesize(l_programme);
        programme_max:= p_programme_max;
        nom_programme:= p_nom_programme;
        getmem(pt_texte_programme, programme_max);
        blockread(l_programme, pt_texte_programme^, fin_programme);
        if pt_texte_programme^[fin_programme- 1]= #26
          then fin_programme:= fin_programme- 1;
        if (pt_texte_programme^[fin_programme- 1]<> #10)
            or (pt_texte_programme^[fin_programme- 2]<> #13)
          then begin
              write('AJ'); stoppe;
              if pt_texte_programme^[fin_programme- 1]<> #13
                then begin
                    pt_texte_programme^[fin_programme]:= #13;
                    fin_programme:= fin_programme+ 1;
                  end;
              pt_texte_programme^[fin_programme]:= #10;
              fin_programme:= fin_programme+ 1;
            end;
      end; 
      close(l_programme);
    end; 

  procedure affiche_programme(p_pt_programme: t_pt_programme);
    var l_indice: integer;
    begin
      clrscr; writeln;
      with p_pt_programme^ do
        for l_indice:= 0 to fin_programme- 3 do
          write(pt_texte_programme^[l_indice]);
    end; 

  procedure interprete_programme(p_pt_programme: t_pt_programme);
    var l_symbole: t_symbole;
        l_valeur_entier_constant: integer;
        l_valeur_chaine_constante: string;
        l_mot: string;
        l_indice_variable: integer;

    procedure affiche_symbole(p_symbole: t_symbole);
      begin
        with g_interprete do
          case p_symbole of
            symbole_chaine_constante : write('''', l_valeur_chaine_constante, '''');
            symbole_entier_constant : write(l_valeur_entier_constant);
            symbole_arobas, symbole_virgule, symbole_point_interrogation :
               affiche_symbole_reserve(p_symbole);
            symbole_reserve_debut..symbole_reserve_fin : affiche_symbole_reserve(p_symbole);
            else
              if p_symbole= symbole_inconnu
                then write(' symbole_inconnu ')
                else write(' pas implment cet affichage ', ord(p_symbole),
                  ' ', l_mot);
              with p_pt_programme^ do
                write(' ', pt_texte_programme^[indice_programme]); stoppe;
          end; 
      end; 

    procedure affiche_erreur_programme(p_pt_programme: t_pt_programme;
        p_message: t_string_80);
      var l_ligne, l_colonne, l_indice: integer;
      begin
        affiche_erreur(p_message);
        with p_pt_programme^ do
        begin
          affiche_programme(p_pt_programme);
          l_indice:= 0; l_ligne:= 2; l_colonne:= 1;
          while (l_indice< indice_programme) and (l_indice< fin_programme- 3) do
          begin
            if pt_texte_programme^[l_indice]= #13
              then begin
                  l_ligne:= l_ligne+ 1;
                  l_colonne:= 0;
                end;
            l_colonne:= l_colonne+ 1;
            l_indice:= l_indice+ 1;
          end; 
          gotoxy(l_colonne, l_ligne); stoppe;
        end; 
      end; 

    procedure lis_symbole(p_pt_programme_2: t_pt_programme);
      var l_taille: integer;
          l_indice_debut_mot: integer;

      procedure analyse_identificateur;
        var l_indice_reserve: integer;
        begin
          with g_interprete, p_pt_programme_2^ do
          begin
            l_indice_debut_mot:= indice_programme;
            while pt_texte_programme^[indice_programme] in ensemble_de_lettres do
              indice_programme:= indice_programme+ 1;
            move(pt_texte_programme^[l_indice_debut_mot], l_mot[1],
                 indice_programme- l_indice_debut_mot);
            l_mot[0]:= chr(indice_programme- l_indice_debut_mot);
            if length(l_mot)<= k_taille_reserve_max
              then begin
                  table_reserves[symbole_reserve_fin]:= l_mot;
                  l_symbole:= succ(symbole_reserve_debut);
                  while table_reserves[l_symbole]<> l_mot do
                    l_symbole:= succ(l_symbole);
                end
              else l_symbole:= symbole_reserve_fin;
          end; 
        end; 

      begin 
        with g_interprete, p_pt_programme_2^ do
        begin
          if g_test
            then write(' %i=', indice_programme, ' ', fin_programme, ' ',
                  pt_texte_programme^[indice_programme], ' ');
          l_symbole:= symbole_inconnu;
          l_mot:= '???';
          while (indice_programme< fin_programme)
               and (pt_texte_programme^[indice_programme] in ensemble_de_separateurs) do
            indice_programme:= indice_programme+ 1;
          l_indice_debut_mot:= indice_programme;
          if indice_programme= fin_programme
            then l_symbole:= symbole_fin
            else
              case pt_texte_programme^[indice_programme] of
                'A'..'Z', 'a'..'z', '', '', '', '', '',
                '', '', 'i', '', '_',
                '' : analyse_identificateur;
                '''' : begin
                         l_symbole:= symbole_chaine_constante;
                         indice_programme:= indice_programme+ 1;
                         l_indice_debut_mot:= indice_programme;
                         while pt_texte_programme^[indice_programme]<> '''' do
                           indice_programme:= indice_programme+ 1;
                         move(pt_texte_programme^[l_indice_debut_mot],
                              l_valeur_chaine_constante[1],
                              indice_programme- l_indice_debut_mot);
                         l_valeur_chaine_constante[0]:=
                             chr(indice_programme- l_indice_debut_mot);
                         indice_programme:= indice_programme+ 1;
                       end;
                ',', '@',
                  '?' : begin
                          l_symbole:=
                              table_symboles_de_ponctuation
                                  [pt_texte_programme^[indice_programme]];
                          indice_programme:= indice_programme+ 1;
                        end;
                '0'..'9' : begin
                             l_symbole:= symbole_entier_constant;
                             l_valeur_entier_constant:= 0;
                             repeat
                               l_valeur_entier_constant:= l_valeur_entier_constant* 10
                                   + ord(pt_texte_programme^[indice_programme])- 48;
                               indice_programme:= indice_programme+ 1;
                             until not (pt_texte_programme^[indice_programme] in ['0'..'9']);
                           end;
                else indice_programme:= indice_programme+ 1;
              end; 
         if g_test
            then begin
                affiche_symbole(l_symbole);
                write('- i=', indice_programme, '%'); stoppe;
              end;
        end; 
      end; 

    procedure traite_instructions(p_pt_programme: t_pt_programme;
               p_ensemble_symboles_finaux: t_ensemble_de_symboles);

      procedure traite_point_interrogation;
        begin
          lis_symbole(p_pt_programme);
          case l_symbole of
            symbole_chaine_constante : writeln(l_valeur_chaine_constante);
            symbole_entier_constant: writeln(l_valeur_entier_constant);
            else
              affiche_erreur_programme(p_pt_programme, 'attend chaine ou nombre');
          end; 
          lis_symbole(p_pt_programme);
        end; 

      procedure traite_arobas;
        var l_ligne, l_colonne: integer;
        begin 
          lis_symbole(p_pt_programme);
          l_ligne:= l_valeur_entier_constant;
          lis_symbole(p_pt_programme);
          if l_symbole<> symbole_virgule
            then affiche_erreur_programme(p_pt_programme, 'attend ,');
          lis_symbole(p_pt_programme);
          l_colonne:= l_valeur_entier_constant;
          gotoxy(l_colonne, l_ligne);
          lis_symbole(p_pt_programme);
          lis_symbole(p_pt_programme);
          case l_symbole of
            symbole_chaine_constante : write(l_valeur_chaine_constante);
            else affiche_erreur_programme(p_pt_programme,
                'attend chaine litterale');
          end; 
          lis_symbole(p_pt_programme);
        end; 

      procedure traite_clear;
        begin 
          clrscr;
          lis_symbole(p_pt_programme);
        end; 

      begin 
        while not (l_symbole in p_ensemble_symboles_finaux) do
        begin
          case l_symbole of
            symbole_point_interrogation : traite_point_interrogation;
            symbole_arobas : traite_arobas;
            symbole_clear : traite_clear;
            else
              affiche_erreur_programme(p_pt_programme, 'symbole illegal');
          end; 
        end; 
      end; 

    begin 
      p_pt_programme^.indice_programme:= 0;
      lis_symbole(p_pt_programme);
      traite_instructions(p_pt_programme, [symbole_fin]);
    end; 

  procedure initialise;
    begin 
      g_pt_programme:= nil;
      g_nom_programme:= 'A:AFFICHE.PAS';
      initialise_tables_interprete;
      g_test:= false;
    end; 

  begin 
    initialise;
    repeat
      writeln; writeln(g_nom_programme); writeln;
      write('Nom, Charge, Affiche, Interprte, Test, Quitte ? ');
      lis_touche(g_choix); writeln(g_choix);
      case g_choix of
        'c' : charge_programme(g_pt_programme, g_nom_programme, k_programme_max);
        'a' : affiche_programme(g_pt_programme);
        'i' : interprete_programme(g_pt_programme);
        'n' : begin
                write('nom <A:ESSAI.PRG> ? '); readln(g_nom_programme);
              end;
        'r' : affiche_reserves;
        't' : g_test:= not g_test;
      end; 
    until g_choix= 'q';
  end. 
