(* -- programme prsent et expliqu dans le livre     *)
(* -- dBase <--> PASCAL  de  John  COLIBRI             *)

(* -- disponible  l'INSTITUT PASCAL                   *)
(* -- 26 Rue Lamartine, 75009 PARIS - (16) 42.85.10.82 *)

(* -- (C) Copyright MNEMODYNE 1991                     *)

(*$r+*)
unit ulexical;
  interface
    uses crt,
         uclavier, uerreur, uecran, uaffiche,
         utypcons, udonnees,
         uediteur;
    const k_variable_max= 249;
          k_taille_reserve_max= 10; 
          k_taille_nom_proprietaire= 10;
          k_tampon_valeur_variable_max= 2000;
          k_fichier_max= 10;
    type t_symbole= (symbole_inconnu,
                     symbole_retour_chariot, symbole_ampersand,
                     symbole_chaine_constante,
                     symbole_nombre_constant,
                     symbole_booleen_constant,
                     symbole_reserve_debut,
                     symbole_CLEAR, symbole_SCREEN,
                     symbole_point_interrogation, symbole_WRITE,
                     symbole_arobas, symbole_SAY,
                     symbole_GET, symbole_READ,
                     symbole_IF, symbole_ELSE, symbole_ENDIF,
                     symbole_DO, symbole_WHILE, symbole_ENDDO,
                     symbole_AND,
                     symbole_egal, symbole_inferieur, symbole_superieur,
                     symbole_virgule,
                     symbole_parenthese_ouvrante, symbole_parenthese_fermante,
                     symbole_fleche,
                     symbole_plus, symbole_moins, symbole_fois, symbole_divise,
                     symbole_INPUT, symbole_TO,
                     symbole_DISPLAY, symbole_MEMORY, symbole_RELEASE,
                     symbole_PUBLIC, symbole_PRIVATE,
                     symbole_CREATE, symbole_USE, symbole_COPY, symbole_STRUCTURE,
                     symbole_APPEND, symbole_BLANK,
                     symbole_REPLACE, symbole_WITH,
                     symbole_CLOSE, symbole_DATABASES,
                     symbole_LIST,
                     symbole_STOPPE, symbole_QUIT,
                     symbole_SPACE,
                     symbole_variable,
                     symbole_fin);
         t_nom_reserve= string[k_taille_reserve_max];
         t_ensemble_de_symboles= set of t_symbole;
         t_nom_proprietaire= string[k_taille_nom_proprietaire];
         t_variable= record
                       proprietaire: t_nom_proprietaire;
                       privee: boolean;
                       pt_descripteur: t_pt_descripteur_de_zone;
                     end;
         t_fichiers= record
                       nom_fichier: t_nom_proprietaire;
                       pt_fichier_donnees: t_pt_fichier_donnees;
                     end;
         t_interprete= record
                         ensemble_de_lettres, ensemble_de_separateurs,
                           ensemble_numerique: set of char;
                         table_reserves: array[symbole_reserve_debut..symbole_variable]
                             of t_nom_reserve;
                         table_symboles_de_ponctuation: array[k_RETURN..'_'] of t_symbole;
                         type_symbole: t_symbole;
                         texte_symbole: string;
                         valeur_numerique_symbole: real;
                         indice_variable_courante, indice_variable_libre,
                           indice_variable_max: integer;
                         table_variables: array[0..k_variable_max] of t_variable;
                         indice_valeur_variable_suivante: integer;
                         tampon_valeur_variable: array[0..k_tampon_valeur_variable_max]
                             of char;
                         indice_fichier_courant: integer;
                         table_fichiers: array[0..k_fichier_max] of t_fichiers;
                         type_expression: char;
                         valeur_expression_chaine: string;
                         teste_interprete: boolean;
                       end;
    var g_interprete: t_interprete;

    procedure initialise_tables_interprete;

    procedure lis_ligne_clavier(p_pt_programme_3: t_pt_texte);

    procedure lis_symbole(p_pt_programme_2: t_pt_texte);

    procedure affiche_reserves;

    procedure affiche_symbole(p_symbole: t_symbole);

    procedure affiche_programme(p_pt_programme: t_pt_texte);

    procedure affiche_erreur_programme(p_pt_programme: t_pt_texte;
          p_message: t_string_80);
  implementation

    procedure affiche_erreur_entier(p_message: t_string_80; p_entier: integer);
      begin
        writeln;
        write('ERREUR: ', p_message, ' ', p_entier);
        stoppe;
      end; 

    procedure affiche_programme(p_pt_programme: t_pt_texte);
      var l_indice: integer;
      begin
        clrscr; writeln;
        with p_pt_programme^ do
          for l_indice:= 0 to fin_texte- 3 do
            write(pt_tampon_texte^[l_indice]);
      end; 

    procedure affiche_erreur_programme(p_pt_programme: t_pt_texte;
          p_message: t_string_80);
      var l_ligne, l_colonne, l_indice: integer;
      begin
        clrscr;
        writeln(p_message);
        with p_pt_programme^ do
        begin
          l_indice:= 0; l_ligne:= 2; l_colonne:= 1;
          while (l_indice< indice_courant) and (l_indice< fin_texte- 3) do
          begin
            write(pt_tampon_texte^[l_indice]);
            if pt_tampon_texte^[l_indice]= #13
              then begin
                  if l_ligne= 25
                    then begin
                        write(pt_tampon_texte^[l_indice+ 1]);
                        l_indice:= l_indice+ 1;
                        gotoxy(1, 1); clreol; writeln(p_message);
                        gotoxy(1, 25);
                      end
                    else l_ligne:= l_ligne+ 1;
                  l_colonne:= 0;
                end;
            l_colonne:= l_colonne+ 1;
            l_indice:= l_indice+ 1;
          end; 
          gotoxy(l_colonne, l_ligne); stoppe;
        end; 
      end; 

    procedure affiche_symbole_reserve(p_symbole: t_symbole);
      begin
        with g_interprete do
          case p_symbole of
            symbole_arobas : write('@');
            symbole_egal : write('=');
            symbole_virgule : write(',');
            symbole_parenthese_ouvrante : write('(');
            symbole_parenthese_fermante : write(')');
            symbole_point_interrogation : write('?');
            symbole_CLEAR..symbole_SPACE : write(table_reserves[p_symbole]);
            else write('symbole inconnu');
          end; 
      end; 

    procedure affiche_symbole(p_symbole: t_symbole);
      begin
        with g_interprete do
          case p_symbole of
            symbole_retour_chariot : write('RETURN');
            symbole_chaine_constante : write('''', texte_symbole, '''');
            symbole_nombre_constant : write(texte_symbole);
            symbole_booleen_constant : write('pas implem');
            symbole_reserve_debut..symbole_SPACE: affiche_symbole_reserve(p_symbole);
            symbole_variable : write(texte_symbole);
            else
              if p_symbole= symbole_inconnu
                then write(' aff: symbole inconnu ')
                else write(' pas implment cet affichage ', ord(p_symbole),
                  ' ', texte_symbole);
              write(' >', texte_symbole, '< '); stoppe;
         end; 
      end; 

    procedure affiche_reserves;
      var symbole: t_symbole;
      begin
        for symbole:= succ(symbole_reserve_debut) to pred(symbole_variable) do
          affiche_symbole_reserve(symbole);
      end; 

    procedure lis_ligne_clavier(p_pt_programme_3: t_pt_texte);
      var l_ligne: string;
      begin
        with p_pt_programme_3^ do
        begin
          if wherex<> 1
            then writeln;
          write('-> '); readln(l_ligne);
          move(l_ligne[1], pt_tampon_texte^, length(l_ligne));
          fin_texte:= length(l_ligne);
          pt_tampon_texte^[fin_texte]:= k_RETURN;
          indice_courant:= 0;
        end; 
      end; 

      procedure lis_symbole(p_pt_programme_2: t_pt_texte);
        var l_taille: integer;
            l_indice_debut_texte_symbole: integer;

        procedure analyse_identificateur;
          var l_indice_reserve: integer;
          begin
            with g_interprete, p_pt_programme_2^ do
            begin
              l_indice_debut_texte_symbole:= indice_courant;
              while pt_tampon_texte^[indice_courant] in ensemble_de_lettres do
                indice_courant:= indice_courant+ 1;
              move(pt_tampon_texte^[l_indice_debut_texte_symbole], texte_symbole[1],
                   indice_courant- l_indice_debut_texte_symbole);
              texte_symbole[0]:= chr(indice_courant- l_indice_debut_texte_symbole);
              if length(texte_symbole)<= k_taille_reserve_max
                then begin
                    table_reserves[symbole_variable]:= texte_symbole;
                    type_symbole:= succ(symbole_reserve_debut);
                    while table_reserves[type_symbole]<> texte_symbole do
                      type_symbole:= succ(type_symbole);
                  end
                else type_symbole:= symbole_variable;
            end; 
          end; 

        procedure analyse_nombre;
          var l_indice_erreur: integer;
          begin
            with g_interprete, p_pt_programme_2^ do
            begin
              l_indice_debut_texte_symbole:= indice_courant;
              while pt_tampon_texte^[indice_courant] in ensemble_numerique do
                indice_courant:= indice_courant+ 1;
              move(pt_tampon_texte^[l_indice_debut_texte_symbole], texte_symbole[1],
                   indice_courant- l_indice_debut_texte_symbole);
              texte_symbole[0]:= chr(indice_courant- l_indice_debut_texte_symbole);
              val(texte_symbole, valeur_numerique_symbole, l_indice_erreur);
              if l_indice_erreur<> 0
                then affiche_erreur_programme(p_pt_programme_2, 'erreur symbole_numrique');
              type_symbole:= symbole_nombre_constant;
            end;
          end; 

        procedure teste_et_saute_commentaire;
          begin
            with g_interprete, p_pt_programme_2^ do
            begin
              while pt_tampon_texte^[indice_courant]= '*' do
              begin
                while (indice_courant< fin_texte)
                    and (pt_tampon_texte^[indice_courant]<> k_RETURN) do
                  indice_courant:= indice_courant+ 1;
                if pt_tampon_texte^[indice_courant]= k_RETURN
                 then indice_courant:= indice_courant+ 2;
              end; 
            end; 
          end; 

        begin 
          with g_interprete, p_pt_programme_2^ do
          begin
            if teste_interprete
              then begin
                  write(' %i=', indice_courant, ' ', fin_texte, ' ',
                    pt_tampon_texte^[indice_courant], ' ');
                end;
            if indice_courant= 0
              then teste_et_saute_commentaire;
            type_symbole:= symbole_inconnu;
            texte_symbole:= '???';
            repeat
              while (indice_courant< fin_texte)
                   and (pt_tampon_texte^[indice_courant] in ensemble_de_separateurs) do
              begin
                if pt_tampon_texte^[indice_courant]= ';'
                  then begin
                      indice_courant:= indice_courant+ 1;
                      if nom_texte<> 'CLAVIER'
                        then
                          if pt_tampon_texte^[indice_courant]= k_RETURN
                            then indice_courant:= indice_courant+ 2
                            else affiche_erreur_programme(p_pt_programme_2,
                                'attend fin de ligne aprs ;');
                    end
                else indice_courant:= indice_courant+ 1;
              end; 
              if (indice_courant= fin_texte)
                  and (nom_texte= 'CLAVIER')
                then lis_ligne_clavier(p_pt_programme_2);
            until (indice_courant= fin_texte)
              or not (pt_tampon_texte^[indice_courant] in ensemble_de_separateurs);
            l_indice_debut_texte_symbole:= indice_courant;
            if indice_courant= fin_texte
              then type_symbole:= symbole_fin
              else
                case pt_tampon_texte^[indice_courant] of
                  k_RETURN : begin
                               type_symbole:= symbole_retour_chariot;
                               texte_symbole:= 'RETURN';
                               indice_courant:= indice_courant+ 2;
                               teste_et_saute_commentaire;
                             end;
                  'A'..'Z', 'a'..'z', '', '', '', '', '',
                  '', '', 'i', '', '_',
                  '' : analyse_identificateur;
                  '''' : begin
                           type_symbole:= symbole_chaine_constante;
                           l_indice_debut_texte_symbole:= indice_courant+ 1;
                           repeat
                             repeat
                               indice_courant:= indice_courant+ 1;
                             until pt_tampon_texte^[indice_courant]= '''';
                             indice_courant:= indice_courant+ 1;
                           until pt_tampon_texte^[indice_courant]<> '''';
                           move(pt_tampon_texte^[l_indice_debut_texte_symbole],
                                texte_symbole[1],
                                indice_courant- 1- l_indice_debut_texte_symbole);
                           texte_symbole[0]:=
                               chr(indice_courant- 1- l_indice_debut_texte_symbole);
                         end;
                  '=', '<', '>', ',', '@', '(', ')', '&', '+', '*', '/',
                    '?' : begin
                            type_symbole:=
                                table_symboles_de_ponctuation[pt_tampon_texte^[indice_courant]];
                            texte_symbole:= pt_tampon_texte^[indice_courant];
                            indice_courant:= indice_courant+ 1;
                          end;
                  '-' : begin 
                          if pt_tampon_texte^[indice_courant+ 1]= '>'
                            then begin
                                type_symbole:= symbole_fleche;
                                texte_symbole:= '->';
                                indice_courant:= indice_courant+ 2;
                              end
                            else begin
                                type_symbole:= symbole_moins;
                                texte_symbole:= '-';
                                indice_courant:= indice_courant+ 1;
                              end;
                        end;
                  '0'..'9' : analyse_nombre;
                  else
                    affiche_erreur_programme(p_pt_programme_2, 'caractre illgal');
                    texte_symbole:= pt_tampon_texte^[indice_courant];
                    indice_courant:= indice_courant+ 1;
                end; 
           if teste_interprete
              then begin
                  affiche_symbole(type_symbole);
                  write('- i=', indice_courant, '%'); stoppe;
                end;
          end; 
        end; 

    procedure initialise_tables_interprete;
      var l_taille_reserve_max: integer;

      procedure initialise_reserve(p_nom: t_nom_reserve; p_symbole: t_symbole);
        begin
          g_interprete.table_reserves[p_symbole]:= p_nom;
          if length(p_nom)> l_taille_reserve_max
            then l_taille_reserve_max:= length(p_nom);
        end; 

      procedure initialise_ponctuation(p_caractere: char; p_symbole: t_symbole);
        begin
          g_interprete.table_symboles_de_ponctuation[p_caractere]:= p_symbole;
        end; 

      procedure initialise_variables;
        var l_variable: integer;
        begin
          with g_interprete do
          begin
            with g_interprete do
              for l_variable:= 0 to k_variable_max do
                new(table_variables[l_variable].pt_descripteur);
          end; 
        end; 

      begin 
        with g_interprete do
        begin
          fillchar(g_interprete, sizeof(g_interprete), 0);
          ensemble_de_lettres:= ['A'..'Z', 'a'..'z', '', '', '', '', '',
                                         '', '', '', '', '', '0'..'9', '_'];
          ensemble_de_separateurs:= [' ', #9, ';'];
          ensemble_numerique:= ['0'..'9', '.'];
          l_taille_reserve_max:= 0;
          initialise_reserve('AND', symbole_AND);
          initialise_reserve('DISPLAY', symbole_DISPLAY);
          initialise_reserve('MEMORY', symbole_MEMORY);
          initialise_reserve('RELEASE', symbole_RELEASE);
          initialise_reserve('PRIVATE', symbole_PRIVATE);
          initialise_reserve('PUBLIC', symbole_PUBLIC);
          initialise_reserve('PRIVATE', symbole_PRIVATE);
          initialise_reserve('IF', symbole_IF);
          initialise_reserve('ELSE', symbole_ELSE);
          initialise_reserve('ENDIF', symbole_ENDIF);
          initialise_reserve('INPUT', symbole_INPUT);
          initialise_reserve('TO', symbole_TO);
          initialise_reserve('DO', symbole_DO);
          initialise_reserve('WHILE', symbole_WHILE);
          initialise_reserve('ENDDO', symbole_ENDDO);
          initialise_reserve('CLEAR', symbole_CLEAR);
          initialise_reserve('SCREEN', symbole_SCREEN);
          initialise_reserve('WRITE', symbole_WRITE);
          initialise_reserve('GET', symbole_GET);
          initialise_reserve('SAY', symbole_SAY);
          initialise_reserve('READ', symbole_READ);
          initialise_reserve('CREATE', symbole_CREATE);
          initialise_reserve('USE', symbole_USE);
          initialise_reserve('COPY', symbole_COPY);
          initialise_reserve('STRUCTURE', symbole_STRUCTURE);
          initialise_reserve('APPEND', symbole_APPEND);
          initialise_reserve('BLANK', symbole_BLANK);
          initialise_reserve('REPLACE', symbole_REPLACE);
          initialise_reserve('WITH', symbole_WITH);
          initialise_reserve('CLOSE', symbole_CLOSE);
          initialise_reserve('DATABASES', symbole_DATABASES);
          initialise_reserve('LIST', symbole_LIST);
          initialise_reserve('->', symbole_fleche);
          initialise_reserve('STOPPE', symbole_STOPPE);
          initialise_reserve('QUIT', symbole_QUIT);
          initialise_reserve('SPACE', symbole_SPACE);
          if l_taille_reserve_max> k_taille_reserve_max
            then affiche_erreur_entier('difference reserve max', l_taille_reserve_max);
          initialise_ponctuation(k_RETURN, symbole_retour_chariot);
          initialise_ponctuation('&', symbole_ampersand);
          initialise_ponctuation('@', symbole_arobas);
          initialise_ponctuation(',', symbole_virgule);
          initialise_ponctuation('=', symbole_egal);
          initialise_ponctuation('<', symbole_inferieur);
          initialise_ponctuation('>', symbole_superieur);
          initialise_ponctuation('(', symbole_parenthese_ouvrante);
          initialise_ponctuation(')', symbole_parenthese_fermante);
          initialise_ponctuation('?', symbole_point_interrogation);
          initialise_ponctuation('+', symbole_plus);
          initialise_ponctuation('-', symbole_moins);
          initialise_ponctuation('*', symbole_fois);
          initialise_ponctuation('/', symbole_divise);
          initialise_variables;
          teste_interprete:= false;
        end; 
      end; 

  begin 
    initialise_tables_interprete;
  end. 






